/* Easing.c generated by valac 0.36.2, the Vala compiler
 * generated from Easing.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
/**
 * Utility functions to calculate progress of transitions.
 * Initially ported from clutter's clutter-enums.h and clutter-easing.c
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define PLANK_TYPE_ANIMATION_MODE (plank_animation_mode_get_type ())

#define PLANK_TYPE_ANIMATION_MODE_MAPPING (plank_animation_mode_mapping_get_type ())
typedef struct _PlankAnimationModeMapping PlankAnimationModeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	PLANK_ANIMATION_MODE_CUSTOM = 0,
	PLANK_ANIMATION_MODE_LINEAR,
	PLANK_ANIMATION_MODE_EASE_IN_QUAD,
	PLANK_ANIMATION_MODE_EASE_OUT_QUAD,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	PLANK_ANIMATION_MODE_EASE_IN_CUBIC,
	PLANK_ANIMATION_MODE_EASE_OUT_CUBIC,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	PLANK_ANIMATION_MODE_EASE_IN_QUART,
	PLANK_ANIMATION_MODE_EASE_OUT_QUART,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART,
	PLANK_ANIMATION_MODE_EASE_IN_QUINT,
	PLANK_ANIMATION_MODE_EASE_OUT_QUINT,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	PLANK_ANIMATION_MODE_EASE_IN_SINE,
	PLANK_ANIMATION_MODE_EASE_OUT_SINE,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE,
	PLANK_ANIMATION_MODE_EASE_IN_EXPO,
	PLANK_ANIMATION_MODE_EASE_OUT_EXPO,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	PLANK_ANIMATION_MODE_EASE_IN_CIRC,
	PLANK_ANIMATION_MODE_EASE_OUT_CIRC,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	PLANK_ANIMATION_MODE_EASE_IN_ELASTIC,
	PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	PLANK_ANIMATION_MODE_EASE_IN_BACK,
	PLANK_ANIMATION_MODE_EASE_OUT_BACK,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK,
	PLANK_ANIMATION_MODE_EASE_IN_BOUNCE,
	PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE,
	PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	PLANK_ANIMATION_MODE_LAST
} PlankAnimationMode;

typedef gdouble (*PlankEasingFunc) (gdouble t, gdouble d);
struct _PlankAnimationModeMapping {
	PlankAnimationMode mode;
	PlankEasingFunc func;
	gchar* name;
};



GType plank_animation_mode_get_type (void) G_GNUC_CONST;
GType plank_animation_mode_mapping_get_type (void) G_GNUC_CONST;
PlankAnimationModeMapping* plank_animation_mode_mapping_dup (const PlankAnimationModeMapping* self);
void plank_animation_mode_mapping_free (PlankAnimationModeMapping* self);
void plank_animation_mode_mapping_copy (const PlankAnimationModeMapping* self, PlankAnimationModeMapping* dest);
void plank_animation_mode_mapping_destroy (PlankAnimationModeMapping* self);
gdouble plank_linear (gdouble t, gdouble d);
static gdouble _plank_linear_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_quad (gdouble t, gdouble d);
static gdouble _plank_ease_in_quad_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_quad (gdouble t, gdouble d);
static gdouble _plank_ease_out_quad_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_quad (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_quad_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_cubic (gdouble t, gdouble d);
static gdouble _plank_ease_in_cubic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_cubic (gdouble t, gdouble d);
static gdouble _plank_ease_out_cubic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_cubic (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_cubic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_quart (gdouble t, gdouble d);
static gdouble _plank_ease_in_quart_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_quart (gdouble t, gdouble d);
static gdouble _plank_ease_out_quart_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_quart (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_quart_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_quint (gdouble t, gdouble d);
static gdouble _plank_ease_in_quint_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_quint (gdouble t, gdouble d);
static gdouble _plank_ease_out_quint_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_quint (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_quint_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_sine (gdouble t, gdouble d);
static gdouble _plank_ease_in_sine_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_sine (gdouble t, gdouble d);
static gdouble _plank_ease_out_sine_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_sine (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_sine_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_expo (gdouble t, gdouble d);
static gdouble _plank_ease_in_expo_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_expo (gdouble t, gdouble d);
static gdouble _plank_ease_out_expo_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_expo (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_expo_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_circ (gdouble t, gdouble d);
static gdouble _plank_ease_in_circ_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_circ (gdouble t, gdouble d);
static gdouble _plank_ease_out_circ_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_circ (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_circ_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_elastic (gdouble t, gdouble d);
static gdouble _plank_ease_in_elastic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_elastic (gdouble t, gdouble d);
static gdouble _plank_ease_out_elastic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_elastic (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_elastic_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_back (gdouble t, gdouble d);
static gdouble _plank_ease_in_back_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_back (gdouble t, gdouble d);
static gdouble _plank_ease_out_back_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_back (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_back_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_bounce (gdouble t, gdouble d);
static gdouble _plank_ease_in_bounce_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_out_bounce (gdouble t, gdouble d);
static gdouble _plank_ease_out_bounce_plank_easing_func (gdouble t, gdouble d);
gdouble plank_ease_in_out_bounce (gdouble t, gdouble d);
static gdouble _plank_ease_in_out_bounce_plank_easing_func (gdouble t, gdouble d);
PlankEasingFunc plank_easing_func_for_mode (PlankAnimationMode mode);
const gchar* plank_easing_name_for_mode (PlankAnimationMode mode);
gdouble plank_easing_for_mode (PlankAnimationMode mode, gdouble t, gdouble d);
gdouble plank_ease_out_bounce_internal (gdouble t, gdouble d);
gdouble plank_ease_in_bounce_internal (gdouble t, gdouble d);

const PlankAnimationModeMapping PLANK_ANIMATION_MODES[33] = {{PLANK_ANIMATION_MODE_CUSTOM, NULL, "custom"}, {PLANK_ANIMATION_MODE_LINEAR, _plank_linear_plank_easing_func, "linear"}, {PLANK_ANIMATION_MODE_EASE_IN_QUAD, _plank_ease_in_quad_plank_easing_func, "easeInQuad"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUAD, _plank_ease_out_quad_plank_easing_func, "easeOutQuad"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD, _plank_ease_in_out_quad_plank_easing_func, "easeInOutQuad"}, {PLANK_ANIMATION_MODE_EASE_IN_CUBIC, _plank_ease_in_cubic_plank_easing_func, "easeInCubic"}, {PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, _plank_ease_out_cubic_plank_easing_func, "easeOutCubic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC, _plank_ease_in_out_cubic_plank_easing_func, "easeInOutCubic"}, {PLANK_ANIMATION_MODE_EASE_IN_QUART, _plank_ease_in_quart_plank_easing_func, "easeInQuart"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUART, _plank_ease_out_quart_plank_easing_func, "easeOutQuart"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART, _plank_ease_in_out_quart_plank_easing_func, "easeInOutQuart"}, {PLANK_ANIMATION_MODE_EASE_IN_QUINT, _plank_ease_in_quint_plank_easing_func, "easeInQuint"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUINT, _plank_ease_out_quint_plank_easing_func, "easeOutQuint"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT, _plank_ease_in_out_quint_plank_easing_func, "easeInOutQuint"}, {PLANK_ANIMATION_MODE_EASE_IN_SINE, _plank_ease_in_sine_plank_easing_func, "easeInSine"}, {PLANK_ANIMATION_MODE_EASE_OUT_SINE, _plank_ease_out_sine_plank_easing_func, "easeOutSine"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE, _plank_ease_in_out_sine_plank_easing_func, "easeInOutSine"}, {PLANK_ANIMATION_MODE_EASE_IN_EXPO, _plank_ease_in_expo_plank_easing_func, "easeInExpo"}, {PLANK_ANIMATION_MODE_EASE_OUT_EXPO, _plank_ease_out_expo_plank_easing_func, "easeOutExpo"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO, _plank_ease_in_out_expo_plank_easing_func, "easeInOutExpo"}, {PLANK_ANIMATION_MODE_EASE_IN_CIRC, _plank_ease_in_circ_plank_easing_func, "easeInCirc"}, {PLANK_ANIMATION_MODE_EASE_OUT_CIRC, _plank_ease_out_circ_plank_easing_func, "easeOutCirc"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC, _plank_ease_in_out_circ_plank_easing_func, "easeInOutCirc"}, {PLANK_ANIMATION_MODE_EASE_IN_ELASTIC, _plank_ease_in_elastic_plank_easing_func, "easeInElastic"}, {PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC, _plank_ease_out_elastic_plank_easing_func, "easeOutElastic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, _plank_ease_in_out_elastic_plank_easing_func, "easeInOutElastic"}, {PLANK_ANIMATION_MODE_EASE_IN_BACK, _plank_ease_in_back_plank_easing_func, "easeInBack"}, {PLANK_ANIMATION_MODE_EASE_OUT_BACK, _plank_ease_out_back_plank_easing_func, "easeOutBack"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK, _plank_ease_in_out_back_plank_easing_func, "easeInOutBack"}, {PLANK_ANIMATION_MODE_EASE_IN_BOUNCE, _plank_ease_in_bounce_plank_easing_func, "easeInBounce"}, {PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE, _plank_ease_out_bounce_plank_easing_func, "easeOutBounce"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, _plank_ease_in_out_bounce_plank_easing_func, "easeInOutBounce"}, {PLANK_ANIMATION_MODE_LAST, NULL, "sentinel"}};

/**
 * The available animation modes
 */
GType plank_animation_mode_get_type (void) {
	static volatile gsize plank_animation_mode_type_id__volatile = 0;
	if (g_once_init_enter (&plank_animation_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_ANIMATION_MODE_CUSTOM, "PLANK_ANIMATION_MODE_CUSTOM", "custom"}, {PLANK_ANIMATION_MODE_LINEAR, "PLANK_ANIMATION_MODE_LINEAR", "linear"}, {PLANK_ANIMATION_MODE_EASE_IN_QUAD, "PLANK_ANIMATION_MODE_EASE_IN_QUAD", "ease-in-quad"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUAD, "PLANK_ANIMATION_MODE_EASE_OUT_QUAD", "ease-out-quad"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD", "ease-in-out-quad"}, {PLANK_ANIMATION_MODE_EASE_IN_CUBIC, "PLANK_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, "PLANK_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {PLANK_ANIMATION_MODE_EASE_IN_QUART, "PLANK_ANIMATION_MODE_EASE_IN_QUART", "ease-in-quart"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUART, "PLANK_ANIMATION_MODE_EASE_OUT_QUART", "ease-out-quart"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART", "ease-in-out-quart"}, {PLANK_ANIMATION_MODE_EASE_IN_QUINT, "PLANK_ANIMATION_MODE_EASE_IN_QUINT", "ease-in-quint"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUINT, "PLANK_ANIMATION_MODE_EASE_OUT_QUINT", "ease-out-quint"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT", "ease-in-out-quint"}, {PLANK_ANIMATION_MODE_EASE_IN_SINE, "PLANK_ANIMATION_MODE_EASE_IN_SINE", "ease-in-sine"}, {PLANK_ANIMATION_MODE_EASE_OUT_SINE, "PLANK_ANIMATION_MODE_EASE_OUT_SINE", "ease-out-sine"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE, "PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE", "ease-in-out-sine"}, {PLANK_ANIMATION_MODE_EASE_IN_EXPO, "PLANK_ANIMATION_MODE_EASE_IN_EXPO", "ease-in-expo"}, {PLANK_ANIMATION_MODE_EASE_OUT_EXPO, "PLANK_ANIMATION_MODE_EASE_OUT_EXPO", "ease-out-expo"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO, "PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO", "ease-in-out-expo"}, {PLANK_ANIMATION_MODE_EASE_IN_CIRC, "PLANK_ANIMATION_MODE_EASE_IN_CIRC", "ease-in-circ"}, {PLANK_ANIMATION_MODE_EASE_OUT_CIRC, "PLANK_ANIMATION_MODE_EASE_OUT_CIRC", "ease-out-circ"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC", "ease-in-out-circ"}, {PLANK_ANIMATION_MODE_EASE_IN_ELASTIC, "PLANK_ANIMATION_MODE_EASE_IN_ELASTIC", "ease-in-elastic"}, {PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC, "PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC", "ease-out-elastic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC", "ease-in-out-elastic"}, {PLANK_ANIMATION_MODE_EASE_IN_BACK, "PLANK_ANIMATION_MODE_EASE_IN_BACK", "ease-in-back"}, {PLANK_ANIMATION_MODE_EASE_OUT_BACK, "PLANK_ANIMATION_MODE_EASE_OUT_BACK", "ease-out-back"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK, "PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK", "ease-in-out-back"}, {PLANK_ANIMATION_MODE_EASE_IN_BOUNCE, "PLANK_ANIMATION_MODE_EASE_IN_BOUNCE", "ease-in-bounce"}, {PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE, "PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE", "ease-out-bounce"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, "PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE", "ease-in-out-bounce"}, {PLANK_ANIMATION_MODE_LAST, "PLANK_ANIMATION_MODE_LAST", "last"}, {0, NULL, NULL}};
		GType plank_animation_mode_type_id;
		plank_animation_mode_type_id = g_enum_register_static ("PlankAnimationMode", values);
		g_once_init_leave (&plank_animation_mode_type_id__volatile, plank_animation_mode_type_id);
	}
	return plank_animation_mode_type_id__volatile;
}


void plank_animation_mode_mapping_copy (const PlankAnimationModeMapping* self, PlankAnimationModeMapping* dest) {
	PlankAnimationMode _tmp0_;
	PlankEasingFunc _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).mode;
	(*dest).mode = _tmp0_;
	_tmp1_ = (*self).func;
	(*dest).func = _tmp1_;
	_tmp2_ = (*self).name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp3_;
}


void plank_animation_mode_mapping_destroy (PlankAnimationModeMapping* self) {
	_g_free0 ((*self).name);
}


PlankAnimationModeMapping* plank_animation_mode_mapping_dup (const PlankAnimationModeMapping* self) {
	PlankAnimationModeMapping* dup;
	dup = g_new0 (PlankAnimationModeMapping, 1);
	plank_animation_mode_mapping_copy (self, dup);
	return dup;
}


void plank_animation_mode_mapping_free (PlankAnimationModeMapping* self) {
	plank_animation_mode_mapping_destroy (self);
	g_free (self);
}


GType plank_animation_mode_mapping_get_type (void) {
	static volatile gsize plank_animation_mode_mapping_type_id__volatile = 0;
	if (g_once_init_enter (&plank_animation_mode_mapping_type_id__volatile)) {
		GType plank_animation_mode_mapping_type_id;
		plank_animation_mode_mapping_type_id = g_boxed_type_register_static ("PlankAnimationModeMapping", (GBoxedCopyFunc) plank_animation_mode_mapping_dup, (GBoxedFreeFunc) plank_animation_mode_mapping_free);
		g_once_init_leave (&plank_animation_mode_mapping_type_id__volatile, plank_animation_mode_mapping_type_id);
	}
	return plank_animation_mode_mapping_type_id__volatile;
}


static gdouble _plank_linear_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_linear (t, d);
	return result;
}


static gdouble _plank_ease_in_quad_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_quad (t, d);
	return result;
}


static gdouble _plank_ease_out_quad_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_quad (t, d);
	return result;
}


static gdouble _plank_ease_in_out_quad_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_quad (t, d);
	return result;
}


static gdouble _plank_ease_in_cubic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_cubic (t, d);
	return result;
}


static gdouble _plank_ease_out_cubic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_cubic (t, d);
	return result;
}


static gdouble _plank_ease_in_out_cubic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_cubic (t, d);
	return result;
}


static gdouble _plank_ease_in_quart_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_quart (t, d);
	return result;
}


static gdouble _plank_ease_out_quart_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_quart (t, d);
	return result;
}


static gdouble _plank_ease_in_out_quart_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_quart (t, d);
	return result;
}


static gdouble _plank_ease_in_quint_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_quint (t, d);
	return result;
}


static gdouble _plank_ease_out_quint_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_quint (t, d);
	return result;
}


static gdouble _plank_ease_in_out_quint_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_quint (t, d);
	return result;
}


static gdouble _plank_ease_in_sine_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_sine (t, d);
	return result;
}


static gdouble _plank_ease_out_sine_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_sine (t, d);
	return result;
}


static gdouble _plank_ease_in_out_sine_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_sine (t, d);
	return result;
}


static gdouble _plank_ease_in_expo_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_expo (t, d);
	return result;
}


static gdouble _plank_ease_out_expo_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_expo (t, d);
	return result;
}


static gdouble _plank_ease_in_out_expo_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_expo (t, d);
	return result;
}


static gdouble _plank_ease_in_circ_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_circ (t, d);
	return result;
}


static gdouble _plank_ease_out_circ_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_circ (t, d);
	return result;
}


static gdouble _plank_ease_in_out_circ_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_circ (t, d);
	return result;
}


static gdouble _plank_ease_in_elastic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_elastic (t, d);
	return result;
}


static gdouble _plank_ease_out_elastic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_elastic (t, d);
	return result;
}


static gdouble _plank_ease_in_out_elastic_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_elastic (t, d);
	return result;
}


static gdouble _plank_ease_in_back_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_back (t, d);
	return result;
}


static gdouble _plank_ease_out_back_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_back (t, d);
	return result;
}


static gdouble _plank_ease_in_out_back_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_back (t, d);
	return result;
}


static gdouble _plank_ease_in_bounce_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_bounce (t, d);
	return result;
}


static gdouble _plank_ease_out_bounce_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_out_bounce (t, d);
	return result;
}


static gdouble _plank_ease_in_out_bounce_plank_easing_func (gdouble t, gdouble d) {
	gdouble result;
	result = plank_ease_in_out_bounce (t, d);
	return result;
}


PlankEasingFunc plank_easing_func_for_mode (PlankAnimationMode mode) {
	PlankEasingFunc result = NULL;
	PlankAnimationModeMapping* animation;
	PlankAnimationMode _tmp0_;
	PlankAnimationMode _tmp1_;
	PlankAnimationMode _tmp2_;
	PlankEasingFunc _tmp3_;
	PlankEasingFunc _tmp4_;
	_tmp0_ = mode;
	animation = &PLANK_ANIMATION_MODES[_tmp0_];
	_tmp1_ = (*animation).mode;
	_tmp2_ = mode;
	_vala_assert (_tmp1_ == _tmp2_, "animation.mode == mode");
	_tmp3_ = (*animation).func;
	_vala_assert (_tmp3_ != NULL, "animation.func != null");
	_tmp4_ = (*animation).func;
	result = _tmp4_;
	return result;
}


const gchar* plank_easing_name_for_mode (PlankAnimationMode mode) {
	const gchar* result = NULL;
	PlankAnimationModeMapping* animation;
	PlankAnimationMode _tmp0_;
	PlankAnimationMode _tmp1_;
	PlankAnimationMode _tmp2_;
	PlankEasingFunc _tmp3_;
	const gchar* _tmp4_;
	_tmp0_ = mode;
	animation = &PLANK_ANIMATION_MODES[_tmp0_];
	_tmp1_ = (*animation).mode;
	_tmp2_ = mode;
	_vala_assert (_tmp1_ == _tmp2_, "animation.mode == mode");
	_tmp3_ = (*animation).func;
	_vala_assert (_tmp3_ != NULL, "animation.func != null");
	_tmp4_ = (*animation).name;
	result = _tmp4_;
	return result;
}


/**
 * Calculate an interpolated value for selected animation-mode, and given
 * elapsed time and total duration.
 *
 * @param mode animation-mode to be used
 * @param t elapsed time
 * @param d total duration
 * @return the interpolated value, between -1.0 and 2.0
 */
gdouble plank_easing_for_mode (PlankAnimationMode mode, gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	PlankAnimationModeMapping* animation;
	PlankAnimationMode _tmp4_;
	PlankAnimationMode _tmp5_;
	PlankAnimationMode _tmp6_;
	PlankEasingFunc _tmp7_;
	PlankEasingFunc _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	_tmp0_ = t;
	_tmp1_ = d;
	_vala_return_val_if_fail ((_tmp0_ >= 0.0) && (_tmp1_ > 0.0), "t >= 0.0 && d > 0.0", 0.0);
	_tmp2_ = t;
	_tmp3_ = d;
	_vala_return_val_if_fail (_tmp2_ <= _tmp3_, "t <= d", 0.0);
	_tmp4_ = mode;
	animation = &PLANK_ANIMATION_MODES[_tmp4_];
	_tmp5_ = (*animation).mode;
	_tmp6_ = mode;
	_vala_assert (_tmp5_ == _tmp6_, "animation.mode == mode");
	_tmp7_ = (*animation).func;
	_vala_assert (_tmp7_ != NULL, "animation.func != null");
	_tmp8_ = (*animation).func;
	_tmp9_ = t;
	_tmp10_ = d;
	_tmp11_ = _tmp8_ (_tmp9_, _tmp10_);
	result = _tmp11_;
	_tmp12_ = result;
	_tmp13_ = result;
	_vala_warn_if_fail ((_tmp12_ >= (-1.0)) && (_tmp13_ <= 2.0), "result >= -1.0 && result <= 2.0");
	return result;
}


gdouble plank_linear (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	result = _tmp0_ / _tmp1_;
	return result;
}


gdouble plank_ease_in_quad (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = p * p;
	return result;
}


gdouble plank_ease_out_quad (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = ((-1.0) * p) * (p - 2);
	return result;
}


gdouble plank_ease_in_out_quad (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = p;
		_tmp4_ = p;
		result = (0.5 * _tmp3_) * _tmp4_;
		return result;
	}
	_tmp5_ = p;
	p = _tmp5_ - 1;
	_tmp6_ = p;
	_tmp7_ = p;
	result = (-0.5) * ((_tmp6_ * (_tmp7_ - 2)) - 1);
	return result;
}


gdouble plank_ease_in_cubic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = (p * p) * p;
	return result;
}


gdouble plank_ease_out_cubic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = (_tmp0_ / _tmp1_) - 1;
	result = ((p * p) * p) + 1;
	return result;
}


gdouble plank_ease_in_out_cubic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		_tmp3_ = p;
		_tmp4_ = p;
		_tmp5_ = p;
		result = ((0.5 * _tmp3_) * _tmp4_) * _tmp5_;
		return result;
	}
	_tmp6_ = p;
	p = _tmp6_ - 2;
	_tmp7_ = p;
	_tmp8_ = p;
	_tmp9_ = p;
	result = 0.5 * (((_tmp7_ * _tmp8_) * _tmp9_) + 2);
	return result;
}


gdouble plank_ease_in_quart (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = ((p * p) * p) * p;
	return result;
}


gdouble plank_ease_out_quart (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = (_tmp0_ / _tmp1_) - 1;
	result = (-1.0) * ((((p * p) * p) * p) - 1);
	return result;
}


gdouble plank_ease_in_out_quart (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		_tmp3_ = p;
		_tmp4_ = p;
		_tmp5_ = p;
		_tmp6_ = p;
		result = (((0.5 * _tmp3_) * _tmp4_) * _tmp5_) * _tmp6_;
		return result;
	}
	_tmp7_ = p;
	p = _tmp7_ - 2;
	_tmp8_ = p;
	_tmp9_ = p;
	_tmp10_ = p;
	_tmp11_ = p;
	result = (-0.5) * ((((_tmp8_ * _tmp9_) * _tmp10_) * _tmp11_) - 2);
	return result;
}


gdouble plank_ease_in_quint (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = (((p * p) * p) * p) * p;
	return result;
}


gdouble plank_ease_out_quint (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = (_tmp0_ / _tmp1_) - 1;
	result = ((((p * p) * p) * p) * p) + 1;
	return result;
}


gdouble plank_ease_in_out_quint (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		_tmp3_ = p;
		_tmp4_ = p;
		_tmp5_ = p;
		_tmp6_ = p;
		_tmp7_ = p;
		result = ((((0.5 * _tmp3_) * _tmp4_) * _tmp5_) * _tmp6_) * _tmp7_;
		return result;
	}
	_tmp8_ = p;
	p = _tmp8_ - 2;
	_tmp9_ = p;
	_tmp10_ = p;
	_tmp11_ = p;
	_tmp12_ = p;
	_tmp13_ = p;
	result = 0.5 * (((((_tmp9_ * _tmp10_) * _tmp11_) * _tmp12_) * _tmp13_) + 2);
	return result;
}


gdouble plank_ease_in_sine (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	_tmp2_ = cos ((_tmp0_ / _tmp1_) * G_PI_2);
	result = ((-1.0) * _tmp2_) + 1.0;
	return result;
}


gdouble plank_ease_out_sine (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	_tmp2_ = sin ((_tmp0_ / _tmp1_) * G_PI_2);
	result = _tmp2_;
	return result;
}


gdouble plank_ease_in_out_sine (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	_tmp2_ = cos ((G_PI * _tmp0_) / _tmp1_);
	result = (-0.5) * (_tmp2_ - 1);
	return result;
}


gdouble plank_ease_in_expo (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_;
	_tmp1_ = t;
	if (_tmp1_ == ((gdouble) 0)) {
		_tmp0_ = 0.0;
	} else {
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp2_ = t;
		_tmp3_ = d;
		_tmp4_ = pow ((gdouble) 2, 10 * ((_tmp2_ / _tmp3_) - 1));
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}


gdouble plank_ease_out_expo (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp1_ = t;
	_tmp2_ = d;
	if (_tmp1_ == _tmp2_) {
		_tmp0_ = 1.0;
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		_tmp3_ = t;
		_tmp4_ = d;
		_tmp5_ = pow ((gdouble) 2, (-10 * _tmp3_) / _tmp4_);
		_tmp0_ = (-_tmp5_) + 1;
	}
	result = _tmp0_;
	return result;
}


gdouble plank_ease_in_out_expo (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	_tmp0_ = t;
	if (_tmp0_ == ((gdouble) 0)) {
		result = 0.0;
		return result;
	}
	_tmp1_ = t;
	_tmp2_ = d;
	if (_tmp1_ == _tmp2_) {
		result = 1.0;
		return result;
	}
	_tmp3_ = t;
	_tmp4_ = d;
	p = _tmp3_ / (_tmp4_ / 2);
	_tmp5_ = p;
	if (_tmp5_ < ((gdouble) 1)) {
		gdouble _tmp6_;
		gdouble _tmp7_;
		_tmp6_ = p;
		_tmp7_ = pow ((gdouble) 2, 10 * (_tmp6_ - 1));
		result = 0.5 * _tmp7_;
		return result;
	}
	_tmp8_ = p;
	p = _tmp8_ - 1;
	_tmp9_ = p;
	_tmp10_ = pow ((gdouble) 2, -10 * _tmp9_);
	result = 0.5 * ((-_tmp10_) + 2);
	return result;
}


gdouble plank_ease_in_circ (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	_tmp2_ = sqrt (1 - (p * p));
	result = (-1.0) * (_tmp2_ - 1);
	return result;
}


gdouble plank_ease_out_circ (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = (_tmp0_ / _tmp1_) - 1;
	_tmp2_ = sqrt (1 - (p * p));
	result = _tmp2_;
	return result;
}


gdouble plank_ease_in_out_circ (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		_tmp3_ = p;
		_tmp4_ = p;
		_tmp5_ = sqrt (1 - (_tmp3_ * _tmp4_));
		result = (-0.5) * (_tmp5_ - 1);
		return result;
	}
	_tmp6_ = p;
	p = _tmp6_ - 2;
	_tmp7_ = p;
	_tmp8_ = p;
	_tmp9_ = sqrt (1 - (_tmp7_ * _tmp8_));
	result = 0.5 * (_tmp9_ + 1);
	return result;
}


gdouble plank_ease_in_elastic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble s;
	gdouble _tmp1_;
	gdouble q;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	_tmp0_ = d;
	p = _tmp0_ * 0.3;
	_tmp1_ = p;
	s = _tmp1_ / 4;
	_tmp2_ = t;
	_tmp3_ = d;
	q = _tmp2_ / _tmp3_;
	_tmp4_ = q;
	if (_tmp4_ == ((gdouble) 1)) {
		result = 1.0;
		return result;
	}
	_tmp5_ = q;
	q = _tmp5_ - 1;
	_tmp6_ = q;
	_tmp7_ = pow ((gdouble) 2, 10 * _tmp6_);
	_tmp8_ = q;
	_tmp9_ = d;
	_tmp10_ = s;
	_tmp11_ = p;
	_tmp12_ = sin ((((_tmp8_ * _tmp9_) - _tmp10_) * (2 * G_PI)) / _tmp11_);
	result = -(_tmp7_ * _tmp12_);
	return result;
}


gdouble plank_ease_out_elastic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble s;
	gdouble _tmp1_;
	gdouble q;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	_tmp0_ = d;
	p = _tmp0_ * 0.3;
	_tmp1_ = p;
	s = _tmp1_ / 4;
	_tmp2_ = t;
	_tmp3_ = d;
	q = _tmp2_ / _tmp3_;
	_tmp4_ = q;
	if (_tmp4_ == ((gdouble) 1)) {
		result = 1.0;
		return result;
	}
	_tmp5_ = q;
	_tmp6_ = pow ((gdouble) 2, -10 * _tmp5_);
	_tmp7_ = q;
	_tmp8_ = d;
	_tmp9_ = s;
	_tmp10_ = p;
	_tmp11_ = sin ((((_tmp7_ * _tmp8_) - _tmp9_) * (2 * G_PI)) / _tmp10_);
	result = (_tmp6_ * _tmp11_) + 1.0;
	return result;
}


gdouble plank_ease_in_out_elastic (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble s;
	gdouble _tmp1_;
	gdouble q;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	_tmp0_ = d;
	p = _tmp0_ * (0.3 * 1.5);
	_tmp1_ = p;
	s = _tmp1_ / 4;
	_tmp2_ = t;
	_tmp3_ = d;
	q = _tmp2_ / (_tmp3_ / 2);
	_tmp4_ = q;
	if (_tmp4_ == ((gdouble) 2)) {
		result = 1.0;
		return result;
	}
	_tmp5_ = q;
	if (_tmp5_ < ((gdouble) 1)) {
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		_tmp6_ = q;
		q = _tmp6_ - 1;
		_tmp7_ = q;
		_tmp8_ = pow ((gdouble) 2, 10 * _tmp7_);
		_tmp9_ = q;
		_tmp10_ = d;
		_tmp11_ = s;
		_tmp12_ = p;
		_tmp13_ = sin ((((_tmp9_ * _tmp10_) - _tmp11_) * (2 * G_PI)) / _tmp12_);
		result = (-0.5) * (_tmp8_ * _tmp13_);
		return result;
	} else {
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		_tmp14_ = q;
		q = _tmp14_ - 1;
		_tmp15_ = q;
		_tmp16_ = pow ((gdouble) 2, -10 * _tmp15_);
		_tmp17_ = q;
		_tmp18_ = d;
		_tmp19_ = s;
		_tmp20_ = p;
		_tmp21_ = sin ((((_tmp17_ * _tmp18_) - _tmp19_) * (2 * G_PI)) / _tmp20_);
		result = ((_tmp16_ * _tmp21_) * 0.5) + 1.0;
		return result;
	}
}


gdouble plank_ease_in_back (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	result = (p * p) * (((1.70158 + 1) * p) - 1.70158);
	return result;
}


gdouble plank_ease_out_back (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = (_tmp0_ / _tmp1_) - 1;
	result = ((p * p) * (((1.70158 + 1) * p) + 1.70158)) + 1;
	return result;
}


gdouble plank_ease_in_out_back (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble s;
	gdouble _tmp2_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / (_tmp1_ / 2);
	s = 1.70158 * 1.525;
	_tmp2_ = p;
	if (_tmp2_ < ((gdouble) 1)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		_tmp3_ = p;
		_tmp4_ = p;
		_tmp5_ = s;
		_tmp6_ = p;
		_tmp7_ = s;
		result = 0.5 * ((_tmp3_ * _tmp4_) * (((_tmp5_ + 1) * _tmp6_) - _tmp7_));
		return result;
	}
	_tmp8_ = p;
	p = _tmp8_ - 2;
	_tmp9_ = p;
	_tmp10_ = p;
	_tmp11_ = s;
	_tmp12_ = p;
	_tmp13_ = s;
	result = 0.5 * (((_tmp9_ * _tmp10_) * (((_tmp11_ + 1) * _tmp12_) + _tmp13_)) + 2);
	return result;
}


inline gdouble plank_ease_out_bounce_internal (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble p;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	p = _tmp0_ / _tmp1_;
	_tmp2_ = p;
	if (_tmp2_ < (1 / 2.75)) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = p;
		_tmp4_ = p;
		result = (7.5625 * _tmp3_) * _tmp4_;
		return result;
	} else {
		gdouble _tmp5_;
		_tmp5_ = p;
		if (_tmp5_ < (2 / 2.75)) {
			gdouble _tmp6_;
			gdouble _tmp7_;
			gdouble _tmp8_;
			_tmp6_ = p;
			p = _tmp6_ - (1.5 / 2.75);
			_tmp7_ = p;
			_tmp8_ = p;
			result = ((7.5625 * _tmp7_) * _tmp8_) + 0.75;
			return result;
		} else {
			gdouble _tmp9_;
			_tmp9_ = p;
			if (_tmp9_ < (2.5 / 2.75)) {
				gdouble _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_;
				_tmp10_ = p;
				p = _tmp10_ - (2.25 / 2.75);
				_tmp11_ = p;
				_tmp12_ = p;
				result = ((7.5625 * _tmp11_) * _tmp12_) + 0.9375;
				return result;
			} else {
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_;
				_tmp13_ = p;
				p = _tmp13_ - (2.625 / 2.75);
				_tmp14_ = p;
				_tmp15_ = p;
				result = ((7.5625 * _tmp14_) * _tmp15_) + 0.984375;
				return result;
			}
		}
	}
}


inline gdouble plank_ease_in_bounce_internal (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	_tmp0_ = d;
	_tmp1_ = t;
	_tmp2_ = d;
	_tmp3_ = plank_ease_out_bounce_internal (_tmp0_ - _tmp1_, _tmp2_);
	result = 1.0 - _tmp3_;
	return result;
}


gdouble plank_ease_in_bounce (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	_tmp2_ = plank_ease_in_bounce_internal (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


gdouble plank_ease_out_bounce (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = t;
	_tmp1_ = d;
	_tmp2_ = plank_ease_out_bounce_internal (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


gdouble plank_ease_in_out_bounce (gdouble t, gdouble d) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = t;
	_tmp1_ = d;
	if (_tmp0_ < (_tmp1_ / 2)) {
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp2_ = t;
		_tmp3_ = d;
		_tmp4_ = plank_ease_in_bounce_internal (_tmp2_ * 2, _tmp3_);
		result = _tmp4_ * 0.5;
		return result;
	} else {
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		_tmp5_ = t;
		_tmp6_ = d;
		_tmp7_ = d;
		_tmp8_ = plank_ease_out_bounce_internal ((_tmp5_ * 2) - _tmp6_, _tmp7_);
		result = (_tmp8_ * 0.5) + (1.0 * 0.5);
		return result;
	}
}



