/* Renderer.c generated by valac 0.36.2, the Vala compiler
 * generated from Renderer.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define PLANK_TYPE_RENDERER (plank_renderer_get_type ())
#define PLANK_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_RENDERER, PlankRenderer))
#define PLANK_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_RENDERER, PlankRendererClass))
#define PLANK_IS_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_RENDERER))
#define PLANK_IS_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_RENDERER))
#define PLANK_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_RENDERER, PlankRendererClass))

typedef struct _PlankRenderer PlankRenderer;
typedef struct _PlankRendererClass PlankRendererClass;
typedef struct _PlankRendererPrivate PlankRendererPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PlankRenderer {
	GObject parent_instance;
	PlankRendererPrivate * priv;
};

struct _PlankRendererClass {
	GObjectClass parent_class;
	gboolean (*animation_needed) (PlankRenderer* self, gint64 frame_time);
	void (*initialize_frame) (PlankRenderer* self, gint64 frame_time);
	void (*draw) (PlankRenderer* self, cairo_t* cr, gint64 frame_time);
};

struct _PlankRendererPrivate {
	GtkWidget* _widget;
	gint64 _frame_time;
	guint timer_id;
	gulong widget_realize_handler_id;
	gulong widget_draw_handler_id;
	gboolean is_updating;
};


static gpointer plank_renderer_parent_class = NULL;

GType plank_renderer_get_type (void) G_GNUC_CONST;
#define PLANK_RENDERER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_RENDERER, PlankRendererPrivate))
enum  {
	PLANK_RENDERER_DUMMY_PROPERTY,
	PLANK_RENDERER_WIDGET,
	PLANK_RENDERER_FRAME_TIME
};
GtkWidget* plank_renderer_get_widget (PlankRenderer* self);
PlankRenderer* plank_renderer_construct (GType object_type, GtkWidget* widget);
gboolean plank_renderer_animation_needed (PlankRenderer* self, gint64 frame_time);
static gboolean plank_renderer_real_animation_needed (PlankRenderer* self, gint64 frame_time);
void plank_renderer_initialize_frame (PlankRenderer* self, gint64 frame_time);
static void plank_renderer_real_initialize_frame (PlankRenderer* self, gint64 frame_time);
void plank_renderer_draw (PlankRenderer* self, cairo_t* cr, gint64 frame_time);
static void plank_renderer_real_draw (PlankRenderer* self, cairo_t* cr, gint64 frame_time);
void plank_renderer_force_frame_time_update (PlankRenderer* self);
static void plank_renderer_set_frame_time (PlankRenderer* self, gint64 value);
void plank_renderer_animated_draw (PlankRenderer* self);
gint64 plank_renderer_get_frame_time (PlankRenderer* self);
static gboolean plank_renderer_draw_timeout (GtkWidget* widget, GdkFrameClock* frame_clock, PlankRenderer* self);
static gboolean plank_renderer_on_widget_draw (GtkWidget* widget, cairo_t* cr, PlankRenderer* self);
static void plank_renderer_on_widget_realize (GtkWidget* widget, PlankRenderer* self);
static void plank_renderer_set_widget (PlankRenderer* self, GtkWidget* value);
static GObject * plank_renderer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _plank_renderer_on_widget_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self);
static gboolean _plank_renderer_on_widget_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static void plank_renderer_finalize (GObject * obj);
static void _vala_plank_renderer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_renderer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates a new animation renderer.
 */
PlankRenderer* plank_renderer_construct (GType object_type, GtkWidget* widget) {
	PlankRenderer * self = NULL;
	GtkWidget* _tmp0_;
	g_return_val_if_fail (widget != NULL, NULL);
	_tmp0_ = widget;
	self = (PlankRenderer*) g_object_new (object_type, "widget", _tmp0_, NULL);
	return self;
}


/**
 * Determines if animation should continue.
 *
 * @param frame_time the current time for this frame's render
 * @return if another animation frame is needed
 */
static gboolean plank_renderer_real_animation_needed (PlankRenderer* self, gint64 frame_time) {
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `plank_renderer_animation_needed'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}


gboolean plank_renderer_animation_needed (PlankRenderer* self, gint64 frame_time) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_RENDERER_GET_CLASS (self)->animation_needed (self, frame_time);
}


/**
 * Preparations which are not requiring a drawing context yet.
 *
 * @param frame_time the current time for this frame's render
 */
static void plank_renderer_real_initialize_frame (PlankRenderer* self, gint64 frame_time) {
	g_critical ("Type `%s' does not implement abstract method `plank_renderer_initialize_frame'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void plank_renderer_initialize_frame (PlankRenderer* self, gint64 frame_time) {
	g_return_if_fail (self != NULL);
	PLANK_RENDERER_GET_CLASS (self)->initialize_frame (self, frame_time);
}


/**
 * Draws onto a context.
 *
 * @param cr the context to use for drawing
 */
static void plank_renderer_real_draw (PlankRenderer* self, cairo_t* cr, gint64 frame_time) {
	g_critical ("Type `%s' does not implement abstract method `plank_renderer_draw'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void plank_renderer_draw (PlankRenderer* self, cairo_t* cr, gint64 frame_time) {
	g_return_if_fail (self != NULL);
	PLANK_RENDERER_GET_CLASS (self)->draw (self, cr, frame_time);
}


/**
 * Force an immediate update of the frame_time property.
 */
void plank_renderer_force_frame_time_update (PlankRenderer* self) {
	GdkFrameClock* frame_clock;
	GtkWidget* _tmp0_;
	GdkFrameClock* _tmp1_;
	GdkFrameClock* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_widget;
	_tmp1_ = gtk_widget_get_frame_clock (_tmp0_);
	frame_clock = _tmp1_;
	_tmp2_ = frame_clock;
	if (_tmp2_ != NULL) {
		GdkFrameClock* _tmp3_;
		gint64 _tmp4_;
		_tmp3_ = frame_clock;
		_tmp4_ = gdk_frame_clock_get_frame_time (_tmp3_);
		plank_renderer_set_frame_time (self, _tmp4_);
	} else {
		gint64 _tmp5_;
		_tmp5_ = g_get_monotonic_time ();
		plank_renderer_set_frame_time (self, _tmp5_);
		g_critical ("Renderer.vala:103: FrameClock not available");
	}
}


/**
 * Request re-drawing.
 */
void plank_renderer_animated_draw (PlankRenderer* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gint64 _tmp4_;
	GtkWidget* _tmp5_;
	gint64 _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->is_updating;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		GtkWidget* _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = self->priv->_widget;
		_tmp3_ = gtk_widget_get_realized (_tmp2_);
		_tmp0_ = !_tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	plank_renderer_force_frame_time_update (self);
	_tmp4_ = self->priv->_frame_time;
	plank_renderer_initialize_frame (self, _tmp4_);
	_tmp5_ = self->priv->_widget;
	gtk_widget_queue_draw (_tmp5_);
	_tmp6_ = self->priv->_frame_time;
	_tmp7_ = plank_renderer_animation_needed (self, _tmp6_);
	if (_tmp7_) {
		GdkFrameClock* frame_clock;
		GtkWidget* _tmp8_;
		GdkFrameClock* _tmp9_;
		GdkFrameClock* _tmp10_;
		_tmp8_ = self->priv->_widget;
		_tmp9_ = gtk_widget_get_frame_clock (_tmp8_);
		frame_clock = _tmp9_;
		_tmp10_ = frame_clock;
		gdk_frame_clock_begin_updating (_tmp10_);
		self->priv->is_updating = TRUE;
	}
}


static gboolean plank_renderer_draw_timeout (GtkWidget* widget, GdkFrameClock* frame_clock, PlankRenderer* self) {
	gboolean result = FALSE;
	GdkFrameClock* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GtkWidget* _tmp3_;
	gint64 _tmp4_;
	gboolean _tmp5_;
	GdkFrameClock* _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (frame_clock != NULL, FALSE);
	_tmp0_ = frame_clock;
	_tmp1_ = gdk_frame_clock_get_frame_time (_tmp0_);
	plank_renderer_set_frame_time (self, _tmp1_);
	_tmp2_ = self->priv->_frame_time;
	plank_renderer_initialize_frame (self, _tmp2_);
	_tmp3_ = widget;
	gtk_widget_queue_draw (_tmp3_);
	_tmp4_ = self->priv->_frame_time;
	_tmp5_ = plank_renderer_animation_needed (self, _tmp4_);
	if (_tmp5_) {
		result = TRUE;
		return result;
	}
	_tmp6_ = frame_clock;
	gdk_frame_clock_end_updating (_tmp6_);
	self->priv->is_updating = FALSE;
	result = TRUE;
	return result;
}


static gboolean plank_renderer_on_widget_draw (GtkWidget* widget, cairo_t* cr, PlankRenderer* self) {
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	gint64 _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = cr;
	_tmp1_ = self->priv->_frame_time;
	plank_renderer_draw (self, _tmp0_, _tmp1_);
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static void plank_renderer_on_widget_realize (GtkWidget* widget, PlankRenderer* self) {
	gint64 _tmp0_;
	gulong _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	plank_renderer_force_frame_time_update (self);
	_tmp0_ = self->priv->_frame_time;
	plank_renderer_initialize_frame (self, _tmp0_);
	_tmp1_ = self->priv->widget_realize_handler_id;
	if (_tmp1_ > 0UL) {
		GtkWidget* _tmp2_;
		gulong _tmp3_;
		_tmp2_ = widget;
		_tmp3_ = self->priv->widget_realize_handler_id;
		g_signal_handler_disconnect ((GObject*) _tmp2_, _tmp3_);
		self->priv->widget_realize_handler_id = 0UL;
	}
}


GtkWidget* plank_renderer_get_widget (PlankRenderer* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_widget;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void plank_renderer_set_widget (PlankRenderer* self, GtkWidget* value) {
	g_return_if_fail (self != NULL);
	if (plank_renderer_get_widget (self) != value) {
		GtkWidget* _tmp0_;
		GtkWidget* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_widget);
		self->priv->_widget = _tmp1_;
		g_object_notify ((GObject *) self, "widget");
	}
}


gint64 plank_renderer_get_frame_time (PlankRenderer* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_frame_time;
	result = _tmp0_;
	return result;
}


static void plank_renderer_set_frame_time (PlankRenderer* self, gint64 value) {
	gint64 _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_frame_time = _tmp0_;
}


static void _plank_renderer_on_widget_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	plank_renderer_on_widget_realize (_sender, (PlankRenderer*) self);
}


static gboolean _plank_renderer_on_widget_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = plank_renderer_on_widget_draw (_sender, cr, (PlankRenderer*) self);
	return result;
}


static GObject * plank_renderer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankRenderer * self;
	GtkWidget* _tmp0_;
	guint _tmp1_;
	GtkWidget* _tmp2_;
	gulong _tmp3_;
	GtkWidget* _tmp4_;
	gulong _tmp5_;
	parent_class = G_OBJECT_CLASS (plank_renderer_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_RENDERER, PlankRenderer);
	_tmp0_ = self->priv->_widget;
	_tmp1_ = gtk_widget_add_tick_callback (_tmp0_, (GtkTickCallback) plank_renderer_draw_timeout, g_object_ref (self), g_object_unref);
	self->priv->timer_id = _tmp1_;
	_tmp2_ = self->priv->_widget;
	_tmp3_ = g_signal_connect_object (_tmp2_, "realize", (GCallback) _plank_renderer_on_widget_realize_gtk_widget_realize, self, 0);
	self->priv->widget_realize_handler_id = _tmp3_;
	_tmp4_ = self->priv->_widget;
	_tmp5_ = g_signal_connect_object (_tmp4_, "draw", (GCallback) _plank_renderer_on_widget_draw_gtk_widget_draw, self, 0);
	self->priv->widget_draw_handler_id = _tmp5_;
	return obj;
}


static void plank_renderer_class_init (PlankRendererClass * klass) {
	plank_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankRendererPrivate));
	((PlankRendererClass *) klass)->animation_needed = (gboolean (*) (PlankRenderer *, gint64)) plank_renderer_real_animation_needed;
	((PlankRendererClass *) klass)->initialize_frame = (void (*) (PlankRenderer *, gint64)) plank_renderer_real_initialize_frame;
	((PlankRendererClass *) klass)->draw = (void (*) (PlankRenderer *, cairo_t*, gint64)) plank_renderer_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_renderer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_renderer_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_renderer_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_renderer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_RENDERER_WIDGET, g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_RENDERER_FRAME_TIME, g_param_spec_int64 ("frame-time", "frame-time", "frame-time", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void plank_renderer_instance_init (PlankRenderer * self) {
	self->priv = PLANK_RENDERER_GET_PRIVATE (self);
	self->priv->timer_id = 0U;
	self->priv->widget_realize_handler_id = 0UL;
	self->priv->widget_draw_handler_id = 0UL;
	self->priv->is_updating = FALSE;
}


static void plank_renderer_finalize (GObject * obj) {
	PlankRenderer * self;
	guint _tmp0_;
	gulong _tmp3_;
	gulong _tmp6_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_RENDERER, PlankRenderer);
	_tmp0_ = self->priv->timer_id;
	if (_tmp0_ > 0U) {
		GtkWidget* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->_widget;
		_tmp2_ = self->priv->timer_id;
		gtk_widget_remove_tick_callback (_tmp1_, _tmp2_);
		self->priv->timer_id = 0U;
	}
	_tmp3_ = self->priv->widget_realize_handler_id;
	if (_tmp3_ > 0UL) {
		GtkWidget* _tmp4_;
		gulong _tmp5_;
		_tmp4_ = self->priv->_widget;
		_tmp5_ = self->priv->widget_realize_handler_id;
		g_signal_handler_disconnect ((GObject*) _tmp4_, _tmp5_);
		self->priv->widget_realize_handler_id = 0UL;
	}
	_tmp6_ = self->priv->widget_draw_handler_id;
	if (_tmp6_ > 0UL) {
		GtkWidget* _tmp7_;
		gulong _tmp8_;
		_tmp7_ = self->priv->_widget;
		_tmp8_ = self->priv->widget_draw_handler_id;
		g_signal_handler_disconnect ((GObject*) _tmp7_, _tmp8_);
		self->priv->widget_draw_handler_id = 0UL;
	}
	_g_object_unref0 (self->priv->_widget);
	G_OBJECT_CLASS (plank_renderer_parent_class)->finalize (obj);
}


/**
 * Handles animated rendering.  Uses a timer and continues requesting
 * redraws for a widget until no more animation is needed.
 */
GType plank_renderer_get_type (void) {
	static volatile gsize plank_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&plank_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankRenderer), 0, (GInstanceInitFunc) plank_renderer_instance_init, NULL };
		GType plank_renderer_type_id;
		plank_renderer_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankRenderer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_renderer_type_id__volatile, plank_renderer_type_id);
	}
	return plank_renderer_type_id__volatile;
}


static void _vala_plank_renderer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_RENDERER, PlankRenderer);
	switch (property_id) {
		case PLANK_RENDERER_WIDGET:
		g_value_set_object (value, plank_renderer_get_widget (self));
		break;
		case PLANK_RENDERER_FRAME_TIME:
		g_value_set_int64 (value, plank_renderer_get_frame_time (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_renderer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_RENDERER, PlankRenderer);
	switch (property_id) {
		case PLANK_RENDERER_WIDGET:
		plank_renderer_set_widget (self, g_value_get_object (value));
		break;
		case PLANK_RENDERER_FRAME_TIME:
		plank_renderer_set_frame_time (self, g_value_get_int64 (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



