/* Surface.c generated by valac 0.36.2, the Vala compiler
 * generated from Surface.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <string.h>


#define PLANK_TYPE_SURFACE (plank_surface_get_type ())
#define PLANK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SURFACE, PlankSurface))
#define PLANK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_SURFACE, PlankSurfaceClass))
#define PLANK_IS_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SURFACE))
#define PLANK_IS_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_SURFACE))
#define PLANK_SURFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_SURFACE, PlankSurfaceClass))

typedef struct _PlankSurface PlankSurface;
typedef struct _PlankSurfaceClass PlankSurfaceClass;
typedef struct _PlankSurfacePrivate PlankSurfacePrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
typedef struct _Block5Data Block5Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSurface {
	GObject parent_instance;
	PlankSurfacePrivate * priv;
};

struct _PlankSurfaceClass {
	GObjectClass parent_class;
};

struct _PlankSurfacePrivate {
	cairo_surface_t* _Internal;
	gint _Width;
	gint _Height;
	cairo_t* _Context;
};

struct _Block5Data {
	int _ref_count_;
	PlankSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block6Data {
	int _ref_count_;
	PlankSurface* self;
	gint gaussWidth;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* abuffer;
	gint abuffer_length1;
	gint _abuffer_size_;
	gdouble* bbuffer;
	gint bbuffer_length1;
	gint _bbuffer_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};


static gpointer plank_surface_parent_class = NULL;

GType plank_surface_get_type (void) G_GNUC_CONST;
#define PLANK_SURFACE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_SURFACE, PlankSurfacePrivate))
enum  {
	PLANK_SURFACE_DUMMY_PROPERTY,
	PLANK_SURFACE_INTERNAL,
	PLANK_SURFACE_WIDTH,
	PLANK_SURFACE_HEIGHT,
	PLANK_SURFACE_CONTEXT
};
#define PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION 16
#define PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION 7
PlankSurface* plank_surface_new (gint width, gint height);
PlankSurface* plank_surface_construct (GType object_type, gint width, gint height);
PlankSurface* plank_surface_new_with_cairo_surface (gint width, gint height, cairo_surface_t* model);
PlankSurface* plank_surface_construct_with_cairo_surface (GType object_type, gint width, gint height, cairo_surface_t* model);
PlankSurface* plank_surface_new_with_surface (gint width, gint height, PlankSurface* model);
PlankSurface* plank_surface_construct_with_surface (GType object_type, gint width, gint height, PlankSurface* model);
cairo_surface_t* plank_surface_get_Internal (PlankSurface* self);
PlankSurface* plank_surface_new_with_internal (cairo_surface_t* image);
PlankSurface* plank_surface_construct_with_internal (GType object_type, cairo_surface_t* image);
void plank_surface_clear (PlankSurface* self);
cairo_t* plank_surface_get_Context (PlankSurface* self);
PlankSurface* plank_surface_copy (PlankSurface* self);
gint plank_surface_get_Width (PlankSurface* self);
gint plank_surface_get_Height (PlankSurface* self);
PlankSurface* plank_surface_scaled_copy (PlankSurface* self, gint width, gint height);
GdkPixbuf* plank_surface_to_pixbuf (PlankSurface* self);
PlankSurface* plank_surface_create_mask (PlankSurface* self, gdouble threshold, GdkRectangle* extent);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_surface_average_color (PlankSurface* self, PlankColor* result);
void plank_drawing_service_average_color (GdkPixbuf* source, PlankColor* result);
void plank_surface_fast_blur (PlankSurface* self, gint radius, gint process_count);
void plank_surface_exponential_blur (PlankSurface* self, gint radius);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void* __lambda4_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_rows (guint8* pixels, gint width, gint height, gint startRow, gint endRow, gint startX, gint endX, gint alpha);
static gpointer ___lambda4__gthread_func (gpointer self);
static void* __lambda5_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_columns (guint8* pixels, gint width, gint height, gint startCol, gint endCol, gint startY, gint endY, gint alpha);
static gpointer ___lambda5__gthread_func (gpointer self);
static inline void plank_surface_exponential_blur_inner (guint8* pixel, gint* zA, gint* zR, gint* zG, gint* zB, gint alpha);
void plank_surface_gaussian_blur (PlankSurface* self, gint radius);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gdouble* plank_surface_build_gaussian_kernel (gint gaussWidth, int* result_length1);
static void* __lambda6_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_horizontal (gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startRow, gint endRow, gint* shift, int shift_length1, int shift_length2);
static gpointer ___lambda6__gthread_func (gpointer self);
static void* __lambda7_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_vertical (gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startCol, gint endCol, gint* shift, int shift_length1, int shift_length2);
static gpointer ___lambda7__gthread_func (gpointer self);
static void plank_surface_set_Internal (PlankSurface* self, cairo_surface_t* value);
static void plank_surface_set_Width (PlankSurface* self, gint value);
static void plank_surface_set_Height (PlankSurface* self, gint value);
static void plank_surface_set_Context (PlankSurface* self, cairo_t* value);
static GObject * plank_surface_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_surface_finalize (GObject * obj);
static void _vala_plank_surface_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_surface_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates a new surface.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 */
PlankSurface* plank_surface_construct (GType object_type, gint width, gint height) {
	PlankSurface * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = width;
	_tmp3_ = height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	self = (PlankSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp5_, NULL);
	_cairo_surface_destroy0 (_tmp5_);
	return self;
}


PlankSurface* plank_surface_new (gint width, gint height) {
	return plank_surface_construct (PLANK_TYPE_SURFACE, width, height);
}


/**
 * Creates a new surface compatible with an existing {@link Cairo.Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Cairo.Surface} to be similar to
 */
PlankSurface* plank_surface_construct_with_cairo_surface (GType object_type, gint width, gint height, cairo_surface_t* model) {
	PlankSurface * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_surface_t* _tmp6_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = model;
	_tmp3_ = width;
	_tmp4_ = height;
	_tmp5_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, _tmp3_, _tmp4_);
	_tmp6_ = _tmp5_;
	self = (PlankSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp6_, NULL);
	_cairo_surface_destroy0 (_tmp6_);
	return self;
}


PlankSurface* plank_surface_new_with_cairo_surface (gint width, gint height, cairo_surface_t* model) {
	return plank_surface_construct_with_cairo_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface compatible with an existing {@link Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Surface} to be similar to
 */
PlankSurface* plank_surface_construct_with_surface (GType object_type, gint width, gint height, PlankSurface* model) {
	PlankSurface * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_surface_t* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = model;
	_tmp3_ = _tmp2_->priv->_Internal;
	_tmp4_ = width;
	_tmp5_ = height;
	_tmp6_ = cairo_surface_create_similar (_tmp3_, CAIRO_CONTENT_COLOR_ALPHA, _tmp4_, _tmp5_);
	_tmp7_ = _tmp6_;
	self = (PlankSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp7_, NULL);
	_cairo_surface_destroy0 (_tmp7_);
	return self;
}


PlankSurface* plank_surface_new_with_surface (gint width, gint height, PlankSurface* model) {
	return plank_surface_construct_with_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface with the given {@link Cairo.ImageSurface} as Internal.
 *
 * @param image existing {@link Cairo.ImageSurface} as Internal
 */
PlankSurface* plank_surface_construct_with_internal (GType object_type, cairo_surface_t* image) {
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (image != NULL, NULL);
	_tmp0_ = image;
	_tmp1_ = cairo_image_surface_get_width (_tmp0_);
	_tmp2_ = image;
	_tmp3_ = cairo_image_surface_get_height (_tmp2_);
	_tmp4_ = image;
	self = (PlankSurface*) g_object_new (object_type, "Width", _tmp1_, "Height", _tmp3_, "Internal", _tmp4_, NULL);
	return self;
}


PlankSurface* plank_surface_new_with_internal (cairo_surface_t* image) {
	return plank_surface_construct_with_internal (PLANK_TYPE_SURFACE, image);
}


/**
 * Clears the entire surface.
 */
void plank_surface_clear (PlankSurface* self) {
	cairo_t* cr;
	cairo_t* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Context;
	cr = _tmp0_;
	cairo_save (cr);
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
	cairo_paint (cr);
	cairo_restore (cr);
}


/**
 * Create a copy of the surface
 *
 * @return copy of this surface
 */
PlankSurface* plank_surface_copy (PlankSurface* self) {
	PlankSurface* result = NULL;
	PlankSurface* copy;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_t* cr;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = plank_surface_new_with_surface (_tmp0_, _tmp1_, self);
	copy = _tmp2_;
	_tmp3_ = copy->priv->_Context;
	cr = _tmp3_;
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	result = copy;
	return result;
}


/**
 * Create a scaled copy of the surface
 *
 * @param width the resulting width
 * @param height the resulting height
 * @return scaled copy of this surface
 */
PlankSurface* plank_surface_scaled_copy (PlankSurface* self, gint width, gint height) {
	PlankSurface* result = NULL;
	PlankSurface* _result_;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_t* cr;
	cairo_t* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	cairo_surface_t* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = plank_surface_new_with_surface (_tmp0_, _tmp1_, self);
	_result_ = _tmp2_;
	_tmp3_ = _result_->priv->_Context;
	cr = _tmp3_;
	cairo_save (cr);
	_tmp4_ = width;
	_tmp5_ = self->priv->_Width;
	_tmp6_ = height;
	_tmp7_ = self->priv->_Height;
	cairo_scale (cr, ((gdouble) _tmp4_) / _tmp5_, ((gdouble) _tmp6_) / _tmp7_);
	_tmp8_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp8_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	cairo_restore (cr);
	result = _result_;
	return result;
}


/**
 * Saves the current surface to a {@link Gdk.Pixbuf}.
 *
 * @return the {@link Gdk.Pixbuf}
 */
GdkPixbuf* plank_surface_to_pixbuf (PlankSurface* self) {
	GdkPixbuf* result = NULL;
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Computes the mask of the surface.
 *
 * @param threshold value defining the minimum opacity [0.0 .. 1.0]
 * @param extent bounding box of the found mask
 * @return a new surface containing the mask
 */
PlankSurface* plank_surface_create_mask (PlankSurface* self, gdouble threshold, GdkRectangle* extent) {
	GdkRectangle _vala_extent = {0};
	PlankSurface* result = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	cairo_surface_t* surface;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* cr;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	gint w;
	cairo_surface_t* _tmp11_;
	gint _tmp12_;
	gint h;
	cairo_surface_t* _tmp13_;
	gint _tmp14_;
	guint8 slice;
	gdouble _tmp15_;
	gint left;
	gint _tmp16_;
	gint right;
	gint top;
	gint _tmp17_;
	gint bottom;
	guint8* data;
	cairo_surface_t* _tmp18_;
	guchar* _tmp19_;
	gint src = 0;
	gboolean mask = FALSE;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	GdkRectangle _tmp68_ = {0};
	cairo_surface_t* _tmp69_;
	PlankSurface* _tmp70_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = threshold;
	_tmp1_ = threshold;
	_vala_return_val_if_fail ((_tmp0_ >= 0.0) && (_tmp1_ <= 1.0), "threshold >= 0.0 && threshold <= 1.0", NULL);
	_tmp2_ = self->priv->_Width;
	_tmp3_ = self->priv->_Height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	surface = _tmp4_;
	_tmp5_ = surface;
	_tmp6_ = cairo_create (_tmp5_);
	cr = _tmp6_;
	_tmp7_ = cr;
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
	_tmp8_ = cr;
	_tmp9_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
	_tmp10_ = cr;
	cairo_paint (_tmp10_);
	_tmp11_ = surface;
	_tmp12_ = cairo_image_surface_get_width (_tmp11_);
	w = _tmp12_;
	_tmp13_ = surface;
	_tmp14_ = cairo_image_surface_get_height (_tmp13_);
	h = _tmp14_;
	_tmp15_ = threshold;
	slice = (guint8) (G_MAXUINT8 * _tmp15_);
	_tmp16_ = w;
	left = _tmp16_;
	right = 0;
	_tmp17_ = h;
	top = _tmp17_;
	bottom = 0;
	_tmp18_ = surface;
	_tmp19_ = cairo_image_surface_get_data (_tmp18_);
	data = _tmp19_;
	{
		gint y;
		y = 0;
		{
			gboolean _tmp20_;
			_tmp20_ = TRUE;
			while (TRUE) {
				gint _tmp22_;
				gint _tmp23_;
				if (!_tmp20_) {
					gint _tmp21_;
					_tmp21_ = y;
					y = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				_tmp22_ = y;
				_tmp23_ = h;
				if (!(_tmp22_ < _tmp23_)) {
					break;
				}
				{
					gint x;
					x = 0;
					{
						gboolean _tmp24_;
						_tmp24_ = TRUE;
						while (TRUE) {
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							guint8* _tmp31_;
							gint _tmp32_;
							guint8 _tmp33_;
							guint8 _tmp34_;
							guint8* _tmp35_;
							gint _tmp36_;
							guint8 _tmp37_;
							guint8* _tmp38_;
							gint _tmp39_;
							guint8 _tmp40_;
							guint8* _tmp41_;
							gint _tmp42_;
							guint8 _tmp43_;
							guint8 _tmp44_ = 0U;
							gboolean _tmp45_;
							guint8* _tmp46_;
							gint _tmp47_;
							guint8 _tmp48_;
							gboolean _tmp49_;
							if (!_tmp24_) {
								gint _tmp25_;
								_tmp25_ = x;
								x = _tmp25_ + 1;
							}
							_tmp24_ = FALSE;
							_tmp26_ = x;
							_tmp27_ = w;
							if (!(_tmp26_ < _tmp27_)) {
								break;
							}
							_tmp28_ = y;
							_tmp29_ = w;
							_tmp30_ = x;
							src = ((_tmp28_ * _tmp29_) + _tmp30_) * 4;
							_tmp31_ = data;
							_tmp32_ = src;
							_tmp33_ = _tmp31_[_tmp32_ + 3];
							_tmp34_ = slice;
							mask = _tmp33_ > _tmp34_;
							_tmp35_ = data;
							_tmp36_ = src;
							_tmp35_[_tmp36_ + 0] = (guint8) 0;
							_tmp37_ = _tmp35_[_tmp36_ + 0];
							_tmp38_ = data;
							_tmp39_ = src;
							_tmp38_[_tmp39_ + 1] = (guint8) 0;
							_tmp40_ = _tmp38_[_tmp39_ + 1];
							_tmp41_ = data;
							_tmp42_ = src;
							_tmp41_[_tmp42_ + 2] = (guint8) 0;
							_tmp43_ = _tmp41_[_tmp42_ + 2];
							_tmp45_ = mask;
							if (_tmp45_) {
								_tmp44_ = G_MAXUINT8;
							} else {
								_tmp44_ = (guint8) 0;
							}
							_tmp46_ = data;
							_tmp47_ = src;
							_tmp46_[_tmp47_ + 3] = _tmp44_;
							_tmp48_ = _tmp46_[_tmp47_ + 3];
							_tmp49_ = mask;
							if (_tmp49_) {
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp53_;
								gint _tmp54_;
								gint _tmp56_;
								gint _tmp57_;
								gint _tmp59_;
								gint _tmp60_;
								_tmp50_ = y;
								_tmp51_ = top;
								if (_tmp50_ < _tmp51_) {
									gint _tmp52_;
									_tmp52_ = y;
									top = _tmp52_;
								}
								_tmp53_ = y;
								_tmp54_ = bottom;
								if (_tmp53_ > _tmp54_) {
									gint _tmp55_;
									_tmp55_ = y;
									bottom = _tmp55_;
								}
								_tmp56_ = x;
								_tmp57_ = left;
								if (_tmp56_ < _tmp57_) {
									gint _tmp58_;
									_tmp58_ = x;
									left = _tmp58_;
								}
								_tmp59_ = x;
								_tmp60_ = right;
								if (_tmp59_ > _tmp60_) {
									gint _tmp61_;
									_tmp61_ = x;
									right = _tmp61_;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp62_ = left;
	_tmp63_ = top;
	_tmp64_ = right;
	_tmp65_ = left;
	_tmp66_ = bottom;
	_tmp67_ = top;
	_tmp68_.x = _tmp62_;
	_tmp68_.y = _tmp63_;
	_tmp68_.width = _tmp64_ - _tmp65_;
	_tmp68_.height = _tmp66_ - _tmp67_;
	_vala_extent = _tmp68_;
	_tmp69_ = surface;
	_tmp70_ = plank_surface_new_with_internal (_tmp69_);
	result = _tmp70_;
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	if (extent) {
		*extent = _vala_extent;
	}
	return result;
}


/**
 * Computes and returns the average color of the surface.
 *
 * @return the average color of the surface
 */
void plank_surface_average_color (PlankSurface* self, PlankColor* result) {
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	PlankColor _tmp5_ = {0};
	PlankColor _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_drawing_service_average_color (_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	*result = _tmp6_;
	return;
}


/**
 * Performs a fast blur on the surface.
 *
 * @param radius the radius of the blur
 * @param process_count how many iterations to blur
 */
void plank_surface_fast_blur (PlankSurface* self, gint radius, gint process_count) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint w;
	gint _tmp3_;
	gint h;
	gint _tmp4_;
	gint channels;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gint _tmp7_;
	cairo_surface_t* original;
	gint _tmp10_;
	gint _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* cr;
	cairo_surface_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
	guint8* pixels;
	cairo_surface_t* _tmp19_;
	guchar* _tmp20_;
	guint8* buffer;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	guint8* _tmp24_;
	gint buffer_length1;
	gint _buffer_size_;
	gint* vmin;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint* _tmp28_;
	gint vmin_length1;
	gint _vmin_size_;
	gint* vmax;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint* _tmp32_;
	gint vmax_length1;
	gint _vmax_size_;
	gint div;
	gint _tmp33_;
	guint8* dv;
	gint _tmp34_;
	guint8* _tmp35_;
	gint dv_length1;
	gint _dv_size_;
	cairo_surface_t* _tmp324_;
	cairo_t* target_cr;
	cairo_t* _tmp325_;
	cairo_t* _tmp326_;
	cairo_t* _tmp327_;
	cairo_t* _tmp328_;
	cairo_surface_t* _tmp329_;
	cairo_t* _tmp330_;
	cairo_t* _tmp331_;
	g_return_if_fail (self != NULL);
	_tmp1_ = radius;
	if (_tmp1_ < 1) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp2_;
		_tmp2_ = process_count;
		_tmp0_ = _tmp2_ < 1;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->_Width;
	w = _tmp3_;
	_tmp4_ = self->priv->_Height;
	h = _tmp4_;
	channels = 4;
	_tmp6_ = radius;
	_tmp7_ = w;
	if (_tmp6_ > (_tmp7_ - 1)) {
		_tmp5_ = TRUE;
	} else {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = radius;
		_tmp9_ = h;
		_tmp5_ = _tmp8_ > (_tmp9_ - 1);
	}
	if (_tmp5_) {
		return;
	}
	_tmp10_ = w;
	_tmp11_ = h;
	_tmp12_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp10_, _tmp11_);
	original = _tmp12_;
	_tmp13_ = original;
	_tmp14_ = cairo_create (_tmp13_);
	cr = _tmp14_;
	_tmp15_ = cr;
	cairo_set_operator (_tmp15_, CAIRO_OPERATOR_SOURCE);
	_tmp16_ = cr;
	_tmp17_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp16_, _tmp17_, (gdouble) 0, (gdouble) 0);
	_tmp18_ = cr;
	cairo_paint (_tmp18_);
	_tmp19_ = original;
	_tmp20_ = cairo_image_surface_get_data (_tmp19_);
	pixels = _tmp20_;
	_tmp21_ = w;
	_tmp22_ = h;
	_tmp23_ = channels;
	_tmp24_ = g_new0 (guint8, (_tmp21_ * _tmp22_) * _tmp23_);
	buffer = _tmp24_;
	buffer_length1 = (_tmp21_ * _tmp22_) * _tmp23_;
	_buffer_size_ = buffer_length1;
	_tmp25_ = w;
	_tmp26_ = h;
	_tmp27_ = MAX (_tmp25_, _tmp26_);
	_tmp28_ = g_new0 (gint, _tmp27_);
	vmin = _tmp28_;
	vmin_length1 = _tmp27_;
	_vmin_size_ = vmin_length1;
	_tmp29_ = w;
	_tmp30_ = h;
	_tmp31_ = MAX (_tmp29_, _tmp30_);
	_tmp32_ = g_new0 (gint, _tmp31_);
	vmax = _tmp32_;
	vmax_length1 = _tmp31_;
	_vmax_size_ = vmax_length1;
	_tmp33_ = radius;
	div = (2 * _tmp33_) + 1;
	_tmp34_ = div;
	_tmp35_ = g_new0 (guint8, 256 * _tmp34_);
	dv = _tmp35_;
	dv_length1 = 256 * _tmp34_;
	_dv_size_ = dv_length1;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp36_;
			_tmp36_ = TRUE;
			while (TRUE) {
				gint _tmp38_;
				guint8* _tmp39_;
				gint _tmp39__length1;
				guint8* _tmp40_;
				gint _tmp40__length1;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				guint8 _tmp44_;
				if (!_tmp36_) {
					gint _tmp37_;
					_tmp37_ = i;
					i = _tmp37_ + 1;
				}
				_tmp36_ = FALSE;
				_tmp38_ = i;
				_tmp39_ = dv;
				_tmp39__length1 = dv_length1;
				if (!(_tmp38_ < _tmp39__length1)) {
					break;
				}
				_tmp40_ = dv;
				_tmp40__length1 = dv_length1;
				_tmp41_ = i;
				_tmp42_ = i;
				_tmp43_ = div;
				_tmp40_[_tmp41_] = (guint8) (_tmp42_ / _tmp43_);
				_tmp44_ = _tmp40_[_tmp41_];
			}
		}
	}
	while (TRUE) {
		gint _tmp45_;
		_tmp45_ = process_count;
		process_count = _tmp45_ - 1;
		if (!(_tmp45_ > 0)) {
			break;
		}
		{
			gint x;
			x = 0;
			{
				gboolean _tmp46_;
				_tmp46_ = TRUE;
				while (TRUE) {
					gint _tmp48_;
					gint _tmp49_;
					gint* _tmp50_;
					gint _tmp50__length1;
					gint _tmp51_;
					gint _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					gint* _tmp57_;
					gint _tmp57__length1;
					gint _tmp58_;
					gint _tmp59_;
					gint _tmp60_;
					gint _tmp61_;
					gint _tmp62_;
					if (!_tmp46_) {
						gint _tmp47_;
						_tmp47_ = x;
						x = _tmp47_ + 1;
					}
					_tmp46_ = FALSE;
					_tmp48_ = x;
					_tmp49_ = w;
					if (!(_tmp48_ < _tmp49_)) {
						break;
					}
					_tmp50_ = vmin;
					_tmp50__length1 = vmin_length1;
					_tmp51_ = x;
					_tmp52_ = x;
					_tmp53_ = radius;
					_tmp54_ = w;
					_tmp55_ = MIN ((_tmp52_ + _tmp53_) + 1, _tmp54_ - 1);
					_tmp50_[_tmp51_] = _tmp55_;
					_tmp56_ = _tmp50_[_tmp51_];
					_tmp57_ = vmax;
					_tmp57__length1 = vmax_length1;
					_tmp58_ = x;
					_tmp59_ = x;
					_tmp60_ = radius;
					_tmp61_ = MAX (_tmp59_ - _tmp60_, 0);
					_tmp57_[_tmp58_] = _tmp61_;
					_tmp62_ = _tmp57_[_tmp58_];
				}
			}
		}
		{
			gint y;
			y = 0;
			{
				gboolean _tmp63_;
				_tmp63_ = TRUE;
				while (TRUE) {
					gint _tmp65_;
					gint _tmp66_;
					gint asum;
					gint rsum;
					gint gsum;
					gint bsum;
					guint32 cur_pixel;
					gint _tmp67_;
					gint _tmp68_;
					gint _tmp69_;
					gint _tmp70_;
					gint _tmp71_;
					guint8* _tmp72_;
					guint32 _tmp73_;
					guint8 _tmp74_;
					gint _tmp75_;
					gint _tmp76_;
					guint8* _tmp77_;
					guint32 _tmp78_;
					guint8 _tmp79_;
					gint _tmp80_;
					gint _tmp81_;
					guint8* _tmp82_;
					guint32 _tmp83_;
					guint8 _tmp84_;
					gint _tmp85_;
					gint _tmp86_;
					guint8* _tmp87_;
					guint32 _tmp88_;
					guint8 _tmp89_;
					gint _tmp112_;
					gint _tmp113_;
					gint _tmp114_;
					if (!_tmp63_) {
						gint _tmp64_;
						_tmp64_ = y;
						y = _tmp64_ + 1;
					}
					_tmp63_ = FALSE;
					_tmp65_ = y;
					_tmp66_ = h;
					if (!(_tmp65_ < _tmp66_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp67_ = y;
					_tmp68_ = w;
					_tmp69_ = channels;
					cur_pixel = (guint32) ((_tmp67_ * _tmp68_) * _tmp69_);
					_tmp70_ = asum;
					_tmp71_ = radius;
					_tmp72_ = pixels;
					_tmp73_ = cur_pixel;
					_tmp74_ = _tmp72_[_tmp73_ + 0];
					asum = _tmp70_ + (_tmp71_ * _tmp74_);
					_tmp75_ = rsum;
					_tmp76_ = radius;
					_tmp77_ = pixels;
					_tmp78_ = cur_pixel;
					_tmp79_ = _tmp77_[_tmp78_ + 1];
					rsum = _tmp75_ + (_tmp76_ * _tmp79_);
					_tmp80_ = gsum;
					_tmp81_ = radius;
					_tmp82_ = pixels;
					_tmp83_ = cur_pixel;
					_tmp84_ = _tmp82_[_tmp83_ + 2];
					gsum = _tmp80_ + (_tmp81_ * _tmp84_);
					_tmp85_ = bsum;
					_tmp86_ = radius;
					_tmp87_ = pixels;
					_tmp88_ = cur_pixel;
					_tmp89_ = _tmp87_[_tmp88_ + 3];
					bsum = _tmp85_ + (_tmp86_ * _tmp89_);
					{
						gint i;
						i = 0;
						{
							gboolean _tmp90_;
							_tmp90_ = TRUE;
							while (TRUE) {
								gint _tmp92_;
								gint _tmp93_;
								gint _tmp94_;
								guint8* _tmp95_;
								guint32 _tmp96_;
								guint8 _tmp97_;
								gint _tmp98_;
								guint8* _tmp99_;
								guint32 _tmp100_;
								guint8 _tmp101_;
								gint _tmp102_;
								guint8* _tmp103_;
								guint32 _tmp104_;
								guint8 _tmp105_;
								gint _tmp106_;
								guint8* _tmp107_;
								guint32 _tmp108_;
								guint8 _tmp109_;
								guint32 _tmp110_;
								gint _tmp111_;
								if (!_tmp90_) {
									gint _tmp91_;
									_tmp91_ = i;
									i = _tmp91_ + 1;
								}
								_tmp90_ = FALSE;
								_tmp92_ = i;
								_tmp93_ = radius;
								if (!(_tmp92_ <= _tmp93_)) {
									break;
								}
								_tmp94_ = asum;
								_tmp95_ = pixels;
								_tmp96_ = cur_pixel;
								_tmp97_ = _tmp95_[_tmp96_ + 0];
								asum = _tmp94_ + _tmp97_;
								_tmp98_ = rsum;
								_tmp99_ = pixels;
								_tmp100_ = cur_pixel;
								_tmp101_ = _tmp99_[_tmp100_ + 1];
								rsum = _tmp98_ + _tmp101_;
								_tmp102_ = gsum;
								_tmp103_ = pixels;
								_tmp104_ = cur_pixel;
								_tmp105_ = _tmp103_[_tmp104_ + 2];
								gsum = _tmp102_ + _tmp105_;
								_tmp106_ = bsum;
								_tmp107_ = pixels;
								_tmp108_ = cur_pixel;
								_tmp109_ = _tmp107_[_tmp108_ + 3];
								bsum = _tmp106_ + _tmp109_;
								_tmp110_ = cur_pixel;
								_tmp111_ = channels;
								cur_pixel = _tmp110_ + _tmp111_;
							}
						}
					}
					_tmp112_ = y;
					_tmp113_ = w;
					_tmp114_ = channels;
					cur_pixel = (guint32) ((_tmp112_ * _tmp113_) * _tmp114_);
					{
						gint x;
						x = 0;
						{
							gboolean _tmp115_;
							_tmp115_ = TRUE;
							while (TRUE) {
								gint _tmp117_;
								gint _tmp118_;
								guint32 p1;
								gint _tmp119_;
								gint _tmp120_;
								gint* _tmp121_;
								gint _tmp121__length1;
								gint _tmp122_;
								gint _tmp123_;
								gint _tmp124_;
								guint32 p2;
								gint _tmp125_;
								gint _tmp126_;
								gint* _tmp127_;
								gint _tmp127__length1;
								gint _tmp128_;
								gint _tmp129_;
								gint _tmp130_;
								guint8* _tmp131_;
								gint _tmp131__length1;
								guint32 _tmp132_;
								guint8* _tmp133_;
								gint _tmp133__length1;
								gint _tmp134_;
								guint8 _tmp135_;
								guint8 _tmp136_;
								guint8* _tmp137_;
								gint _tmp137__length1;
								guint32 _tmp138_;
								guint8* _tmp139_;
								gint _tmp139__length1;
								gint _tmp140_;
								guint8 _tmp141_;
								guint8 _tmp142_;
								guint8* _tmp143_;
								gint _tmp143__length1;
								guint32 _tmp144_;
								guint8* _tmp145_;
								gint _tmp145__length1;
								gint _tmp146_;
								guint8 _tmp147_;
								guint8 _tmp148_;
								guint8* _tmp149_;
								gint _tmp149__length1;
								guint32 _tmp150_;
								guint8* _tmp151_;
								gint _tmp151__length1;
								gint _tmp152_;
								guint8 _tmp153_;
								guint8 _tmp154_;
								gint _tmp155_;
								guint8* _tmp156_;
								guint32 _tmp157_;
								guint8 _tmp158_;
								guint8* _tmp159_;
								guint32 _tmp160_;
								guint8 _tmp161_;
								gint _tmp162_;
								guint8* _tmp163_;
								guint32 _tmp164_;
								guint8 _tmp165_;
								guint8* _tmp166_;
								guint32 _tmp167_;
								guint8 _tmp168_;
								gint _tmp169_;
								guint8* _tmp170_;
								guint32 _tmp171_;
								guint8 _tmp172_;
								guint8* _tmp173_;
								guint32 _tmp174_;
								guint8 _tmp175_;
								gint _tmp176_;
								guint8* _tmp177_;
								guint32 _tmp178_;
								guint8 _tmp179_;
								guint8* _tmp180_;
								guint32 _tmp181_;
								guint8 _tmp182_;
								guint32 _tmp183_;
								gint _tmp184_;
								if (!_tmp115_) {
									gint _tmp116_;
									_tmp116_ = x;
									x = _tmp116_ + 1;
								}
								_tmp115_ = FALSE;
								_tmp117_ = x;
								_tmp118_ = w;
								if (!(_tmp117_ < _tmp118_)) {
									break;
								}
								_tmp119_ = y;
								_tmp120_ = w;
								_tmp121_ = vmin;
								_tmp121__length1 = vmin_length1;
								_tmp122_ = x;
								_tmp123_ = _tmp121_[_tmp122_];
								_tmp124_ = channels;
								p1 = (guint32) (((_tmp119_ * _tmp120_) + _tmp123_) * _tmp124_);
								_tmp125_ = y;
								_tmp126_ = w;
								_tmp127_ = vmax;
								_tmp127__length1 = vmax_length1;
								_tmp128_ = x;
								_tmp129_ = _tmp127_[_tmp128_];
								_tmp130_ = channels;
								p2 = (guint32) (((_tmp125_ * _tmp126_) + _tmp129_) * _tmp130_);
								_tmp131_ = buffer;
								_tmp131__length1 = buffer_length1;
								_tmp132_ = cur_pixel;
								_tmp133_ = dv;
								_tmp133__length1 = dv_length1;
								_tmp134_ = asum;
								_tmp135_ = _tmp133_[_tmp134_];
								_tmp131_[_tmp132_ + 0] = _tmp135_;
								_tmp136_ = _tmp131_[_tmp132_ + 0];
								_tmp137_ = buffer;
								_tmp137__length1 = buffer_length1;
								_tmp138_ = cur_pixel;
								_tmp139_ = dv;
								_tmp139__length1 = dv_length1;
								_tmp140_ = rsum;
								_tmp141_ = _tmp139_[_tmp140_];
								_tmp137_[_tmp138_ + 1] = _tmp141_;
								_tmp142_ = _tmp137_[_tmp138_ + 1];
								_tmp143_ = buffer;
								_tmp143__length1 = buffer_length1;
								_tmp144_ = cur_pixel;
								_tmp145_ = dv;
								_tmp145__length1 = dv_length1;
								_tmp146_ = gsum;
								_tmp147_ = _tmp145_[_tmp146_];
								_tmp143_[_tmp144_ + 2] = _tmp147_;
								_tmp148_ = _tmp143_[_tmp144_ + 2];
								_tmp149_ = buffer;
								_tmp149__length1 = buffer_length1;
								_tmp150_ = cur_pixel;
								_tmp151_ = dv;
								_tmp151__length1 = dv_length1;
								_tmp152_ = bsum;
								_tmp153_ = _tmp151_[_tmp152_];
								_tmp149_[_tmp150_ + 3] = _tmp153_;
								_tmp154_ = _tmp149_[_tmp150_ + 3];
								_tmp155_ = asum;
								_tmp156_ = pixels;
								_tmp157_ = p1;
								_tmp158_ = _tmp156_[_tmp157_ + 0];
								_tmp159_ = pixels;
								_tmp160_ = p2;
								_tmp161_ = _tmp159_[_tmp160_ + 0];
								asum = _tmp155_ + (_tmp158_ - _tmp161_);
								_tmp162_ = rsum;
								_tmp163_ = pixels;
								_tmp164_ = p1;
								_tmp165_ = _tmp163_[_tmp164_ + 1];
								_tmp166_ = pixels;
								_tmp167_ = p2;
								_tmp168_ = _tmp166_[_tmp167_ + 1];
								rsum = _tmp162_ + (_tmp165_ - _tmp168_);
								_tmp169_ = gsum;
								_tmp170_ = pixels;
								_tmp171_ = p1;
								_tmp172_ = _tmp170_[_tmp171_ + 2];
								_tmp173_ = pixels;
								_tmp174_ = p2;
								_tmp175_ = _tmp173_[_tmp174_ + 2];
								gsum = _tmp169_ + (_tmp172_ - _tmp175_);
								_tmp176_ = bsum;
								_tmp177_ = pixels;
								_tmp178_ = p1;
								_tmp179_ = _tmp177_[_tmp178_ + 3];
								_tmp180_ = pixels;
								_tmp181_ = p2;
								_tmp182_ = _tmp180_[_tmp181_ + 3];
								bsum = _tmp176_ + (_tmp179_ - _tmp182_);
								_tmp183_ = cur_pixel;
								_tmp184_ = channels;
								cur_pixel = _tmp183_ + _tmp184_;
							}
						}
					}
				}
			}
		}
		{
			gint y;
			y = 0;
			{
				gboolean _tmp185_;
				_tmp185_ = TRUE;
				while (TRUE) {
					gint _tmp187_;
					gint _tmp188_;
					gint* _tmp189_;
					gint _tmp189__length1;
					gint _tmp190_;
					gint _tmp191_;
					gint _tmp192_;
					gint _tmp193_;
					gint _tmp194_;
					gint _tmp195_;
					gint _tmp196_;
					gint* _tmp197_;
					gint _tmp197__length1;
					gint _tmp198_;
					gint _tmp199_;
					gint _tmp200_;
					gint _tmp201_;
					gint _tmp202_;
					gint _tmp203_;
					if (!_tmp185_) {
						gint _tmp186_;
						_tmp186_ = y;
						y = _tmp186_ + 1;
					}
					_tmp185_ = FALSE;
					_tmp187_ = y;
					_tmp188_ = h;
					if (!(_tmp187_ < _tmp188_)) {
						break;
					}
					_tmp189_ = vmin;
					_tmp189__length1 = vmin_length1;
					_tmp190_ = y;
					_tmp191_ = y;
					_tmp192_ = radius;
					_tmp193_ = h;
					_tmp194_ = MIN ((_tmp191_ + _tmp192_) + 1, _tmp193_ - 1);
					_tmp195_ = w;
					_tmp189_[_tmp190_] = _tmp194_ * _tmp195_;
					_tmp196_ = _tmp189_[_tmp190_];
					_tmp197_ = vmax;
					_tmp197__length1 = vmax_length1;
					_tmp198_ = y;
					_tmp199_ = y;
					_tmp200_ = radius;
					_tmp201_ = MAX (_tmp199_ - _tmp200_, 0);
					_tmp202_ = w;
					_tmp197_[_tmp198_] = _tmp201_ * _tmp202_;
					_tmp203_ = _tmp197_[_tmp198_];
				}
			}
		}
		{
			gint x;
			x = 0;
			{
				gboolean _tmp204_;
				_tmp204_ = TRUE;
				while (TRUE) {
					gint _tmp206_;
					gint _tmp207_;
					gint asum;
					gint rsum;
					gint gsum;
					gint bsum;
					guint32 cur_pixel;
					gint _tmp208_;
					gint _tmp209_;
					gint _tmp210_;
					gint _tmp211_;
					guint8* _tmp212_;
					gint _tmp212__length1;
					guint32 _tmp213_;
					guint8 _tmp214_;
					gint _tmp215_;
					gint _tmp216_;
					guint8* _tmp217_;
					gint _tmp217__length1;
					guint32 _tmp218_;
					guint8 _tmp219_;
					gint _tmp220_;
					gint _tmp221_;
					guint8* _tmp222_;
					gint _tmp222__length1;
					guint32 _tmp223_;
					guint8 _tmp224_;
					gint _tmp225_;
					gint _tmp226_;
					guint8* _tmp227_;
					gint _tmp227__length1;
					guint32 _tmp228_;
					guint8 _tmp229_;
					gint _tmp253_;
					gint _tmp254_;
					if (!_tmp204_) {
						gint _tmp205_;
						_tmp205_ = x;
						x = _tmp205_ + 1;
					}
					_tmp204_ = FALSE;
					_tmp206_ = x;
					_tmp207_ = w;
					if (!(_tmp206_ < _tmp207_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp208_ = x;
					_tmp209_ = channels;
					cur_pixel = (guint32) (_tmp208_ * _tmp209_);
					_tmp210_ = asum;
					_tmp211_ = radius;
					_tmp212_ = buffer;
					_tmp212__length1 = buffer_length1;
					_tmp213_ = cur_pixel;
					_tmp214_ = _tmp212_[_tmp213_ + 0];
					asum = _tmp210_ + (_tmp211_ * _tmp214_);
					_tmp215_ = rsum;
					_tmp216_ = radius;
					_tmp217_ = buffer;
					_tmp217__length1 = buffer_length1;
					_tmp218_ = cur_pixel;
					_tmp219_ = _tmp217_[_tmp218_ + 1];
					rsum = _tmp215_ + (_tmp216_ * _tmp219_);
					_tmp220_ = gsum;
					_tmp221_ = radius;
					_tmp222_ = buffer;
					_tmp222__length1 = buffer_length1;
					_tmp223_ = cur_pixel;
					_tmp224_ = _tmp222_[_tmp223_ + 2];
					gsum = _tmp220_ + (_tmp221_ * _tmp224_);
					_tmp225_ = bsum;
					_tmp226_ = radius;
					_tmp227_ = buffer;
					_tmp227__length1 = buffer_length1;
					_tmp228_ = cur_pixel;
					_tmp229_ = _tmp227_[_tmp228_ + 3];
					bsum = _tmp225_ + (_tmp226_ * _tmp229_);
					{
						gint i;
						i = 0;
						{
							gboolean _tmp230_;
							_tmp230_ = TRUE;
							while (TRUE) {
								gint _tmp232_;
								gint _tmp233_;
								gint _tmp234_;
								guint8* _tmp235_;
								gint _tmp235__length1;
								guint32 _tmp236_;
								guint8 _tmp237_;
								gint _tmp238_;
								guint8* _tmp239_;
								gint _tmp239__length1;
								guint32 _tmp240_;
								guint8 _tmp241_;
								gint _tmp242_;
								guint8* _tmp243_;
								gint _tmp243__length1;
								guint32 _tmp244_;
								guint8 _tmp245_;
								gint _tmp246_;
								guint8* _tmp247_;
								gint _tmp247__length1;
								guint32 _tmp248_;
								guint8 _tmp249_;
								guint32 _tmp250_;
								gint _tmp251_;
								gint _tmp252_;
								if (!_tmp230_) {
									gint _tmp231_;
									_tmp231_ = i;
									i = _tmp231_ + 1;
								}
								_tmp230_ = FALSE;
								_tmp232_ = i;
								_tmp233_ = radius;
								if (!(_tmp232_ <= _tmp233_)) {
									break;
								}
								_tmp234_ = asum;
								_tmp235_ = buffer;
								_tmp235__length1 = buffer_length1;
								_tmp236_ = cur_pixel;
								_tmp237_ = _tmp235_[_tmp236_ + 0];
								asum = _tmp234_ + _tmp237_;
								_tmp238_ = rsum;
								_tmp239_ = buffer;
								_tmp239__length1 = buffer_length1;
								_tmp240_ = cur_pixel;
								_tmp241_ = _tmp239_[_tmp240_ + 1];
								rsum = _tmp238_ + _tmp241_;
								_tmp242_ = gsum;
								_tmp243_ = buffer;
								_tmp243__length1 = buffer_length1;
								_tmp244_ = cur_pixel;
								_tmp245_ = _tmp243_[_tmp244_ + 2];
								gsum = _tmp242_ + _tmp245_;
								_tmp246_ = bsum;
								_tmp247_ = buffer;
								_tmp247__length1 = buffer_length1;
								_tmp248_ = cur_pixel;
								_tmp249_ = _tmp247_[_tmp248_ + 3];
								bsum = _tmp246_ + _tmp249_;
								_tmp250_ = cur_pixel;
								_tmp251_ = w;
								_tmp252_ = channels;
								cur_pixel = _tmp250_ + (_tmp251_ * _tmp252_);
							}
						}
					}
					_tmp253_ = x;
					_tmp254_ = channels;
					cur_pixel = (guint32) (_tmp253_ * _tmp254_);
					{
						gint y;
						y = 0;
						{
							gboolean _tmp255_;
							_tmp255_ = TRUE;
							while (TRUE) {
								gint _tmp257_;
								gint _tmp258_;
								guint32 p1;
								gint _tmp259_;
								gint* _tmp260_;
								gint _tmp260__length1;
								gint _tmp261_;
								gint _tmp262_;
								gint _tmp263_;
								guint32 p2;
								gint _tmp264_;
								gint* _tmp265_;
								gint _tmp265__length1;
								gint _tmp266_;
								gint _tmp267_;
								gint _tmp268_;
								guint8* _tmp269_;
								guint32 _tmp270_;
								guint8* _tmp271_;
								gint _tmp271__length1;
								gint _tmp272_;
								guint8 _tmp273_;
								guint8 _tmp274_;
								guint8* _tmp275_;
								guint32 _tmp276_;
								guint8* _tmp277_;
								gint _tmp277__length1;
								gint _tmp278_;
								guint8 _tmp279_;
								guint8 _tmp280_;
								guint8* _tmp281_;
								guint32 _tmp282_;
								guint8* _tmp283_;
								gint _tmp283__length1;
								gint _tmp284_;
								guint8 _tmp285_;
								guint8 _tmp286_;
								guint8* _tmp287_;
								guint32 _tmp288_;
								guint8* _tmp289_;
								gint _tmp289__length1;
								gint _tmp290_;
								guint8 _tmp291_;
								guint8 _tmp292_;
								gint _tmp293_;
								guint8* _tmp294_;
								gint _tmp294__length1;
								guint32 _tmp295_;
								guint8 _tmp296_;
								guint8* _tmp297_;
								gint _tmp297__length1;
								guint32 _tmp298_;
								guint8 _tmp299_;
								gint _tmp300_;
								guint8* _tmp301_;
								gint _tmp301__length1;
								guint32 _tmp302_;
								guint8 _tmp303_;
								guint8* _tmp304_;
								gint _tmp304__length1;
								guint32 _tmp305_;
								guint8 _tmp306_;
								gint _tmp307_;
								guint8* _tmp308_;
								gint _tmp308__length1;
								guint32 _tmp309_;
								guint8 _tmp310_;
								guint8* _tmp311_;
								gint _tmp311__length1;
								guint32 _tmp312_;
								guint8 _tmp313_;
								gint _tmp314_;
								guint8* _tmp315_;
								gint _tmp315__length1;
								guint32 _tmp316_;
								guint8 _tmp317_;
								guint8* _tmp318_;
								gint _tmp318__length1;
								guint32 _tmp319_;
								guint8 _tmp320_;
								guint32 _tmp321_;
								gint _tmp322_;
								gint _tmp323_;
								if (!_tmp255_) {
									gint _tmp256_;
									_tmp256_ = y;
									y = _tmp256_ + 1;
								}
								_tmp255_ = FALSE;
								_tmp257_ = y;
								_tmp258_ = h;
								if (!(_tmp257_ < _tmp258_)) {
									break;
								}
								_tmp259_ = x;
								_tmp260_ = vmin;
								_tmp260__length1 = vmin_length1;
								_tmp261_ = y;
								_tmp262_ = _tmp260_[_tmp261_];
								_tmp263_ = channels;
								p1 = (guint32) ((_tmp259_ + _tmp262_) * _tmp263_);
								_tmp264_ = x;
								_tmp265_ = vmax;
								_tmp265__length1 = vmax_length1;
								_tmp266_ = y;
								_tmp267_ = _tmp265_[_tmp266_];
								_tmp268_ = channels;
								p2 = (guint32) ((_tmp264_ + _tmp267_) * _tmp268_);
								_tmp269_ = pixels;
								_tmp270_ = cur_pixel;
								_tmp271_ = dv;
								_tmp271__length1 = dv_length1;
								_tmp272_ = asum;
								_tmp273_ = _tmp271_[_tmp272_];
								_tmp269_[_tmp270_ + 0] = _tmp273_;
								_tmp274_ = _tmp269_[_tmp270_ + 0];
								_tmp275_ = pixels;
								_tmp276_ = cur_pixel;
								_tmp277_ = dv;
								_tmp277__length1 = dv_length1;
								_tmp278_ = rsum;
								_tmp279_ = _tmp277_[_tmp278_];
								_tmp275_[_tmp276_ + 1] = _tmp279_;
								_tmp280_ = _tmp275_[_tmp276_ + 1];
								_tmp281_ = pixels;
								_tmp282_ = cur_pixel;
								_tmp283_ = dv;
								_tmp283__length1 = dv_length1;
								_tmp284_ = gsum;
								_tmp285_ = _tmp283_[_tmp284_];
								_tmp281_[_tmp282_ + 2] = _tmp285_;
								_tmp286_ = _tmp281_[_tmp282_ + 2];
								_tmp287_ = pixels;
								_tmp288_ = cur_pixel;
								_tmp289_ = dv;
								_tmp289__length1 = dv_length1;
								_tmp290_ = bsum;
								_tmp291_ = _tmp289_[_tmp290_];
								_tmp287_[_tmp288_ + 3] = _tmp291_;
								_tmp292_ = _tmp287_[_tmp288_ + 3];
								_tmp293_ = asum;
								_tmp294_ = buffer;
								_tmp294__length1 = buffer_length1;
								_tmp295_ = p1;
								_tmp296_ = _tmp294_[_tmp295_ + 0];
								_tmp297_ = buffer;
								_tmp297__length1 = buffer_length1;
								_tmp298_ = p2;
								_tmp299_ = _tmp297_[_tmp298_ + 0];
								asum = _tmp293_ + (_tmp296_ - _tmp299_);
								_tmp300_ = rsum;
								_tmp301_ = buffer;
								_tmp301__length1 = buffer_length1;
								_tmp302_ = p1;
								_tmp303_ = _tmp301_[_tmp302_ + 1];
								_tmp304_ = buffer;
								_tmp304__length1 = buffer_length1;
								_tmp305_ = p2;
								_tmp306_ = _tmp304_[_tmp305_ + 1];
								rsum = _tmp300_ + (_tmp303_ - _tmp306_);
								_tmp307_ = gsum;
								_tmp308_ = buffer;
								_tmp308__length1 = buffer_length1;
								_tmp309_ = p1;
								_tmp310_ = _tmp308_[_tmp309_ + 2];
								_tmp311_ = buffer;
								_tmp311__length1 = buffer_length1;
								_tmp312_ = p2;
								_tmp313_ = _tmp311_[_tmp312_ + 2];
								gsum = _tmp307_ + (_tmp310_ - _tmp313_);
								_tmp314_ = bsum;
								_tmp315_ = buffer;
								_tmp315__length1 = buffer_length1;
								_tmp316_ = p1;
								_tmp317_ = _tmp315_[_tmp316_ + 3];
								_tmp318_ = buffer;
								_tmp318__length1 = buffer_length1;
								_tmp319_ = p2;
								_tmp320_ = _tmp318_[_tmp319_ + 3];
								bsum = _tmp314_ + (_tmp317_ - _tmp320_);
								_tmp321_ = cur_pixel;
								_tmp322_ = w;
								_tmp323_ = channels;
								cur_pixel = _tmp321_ + (_tmp322_ * _tmp323_);
							}
						}
					}
				}
			}
		}
	}
	_tmp324_ = original;
	cairo_surface_mark_dirty (_tmp324_);
	_tmp325_ = self->priv->_Context;
	target_cr = _tmp325_;
	_tmp326_ = target_cr;
	cairo_save (_tmp326_);
	_tmp327_ = target_cr;
	cairo_set_operator (_tmp327_, CAIRO_OPERATOR_SOURCE);
	_tmp328_ = target_cr;
	_tmp329_ = original;
	cairo_set_source_surface (_tmp328_, _tmp329_, (gdouble) 0, (gdouble) 0);
	_tmp330_ = target_cr;
	cairo_paint (_tmp330_);
	_tmp331_ = target_cr;
	cairo_restore (_tmp331_);
	dv = (g_free (dv), NULL);
	vmax = (g_free (vmax), NULL);
	vmin = (g_free (vmin), NULL);
	buffer = (g_free (buffer), NULL);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
}


/**
 * Performs an exponential blur on the surface.
 *
 * @param radius the radius of the blur
 */
static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PlankSurface* self;
		self = _data5_->self;
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void* __lambda4_ (Block5Data* _data5_) {
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->height;
	_tmp4_ = _data5_->width;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer ___lambda4__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda4_ (self);
	block5_data_unref (self);
	return result;
}


static gpointer _g_thread_ref0 (gpointer self) {
	return self ? g_thread_ref (self) : NULL;
}


static void* __lambda5_ (Block5Data* _data5_) {
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->width;
	_tmp4_ = _data5_->height;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer ___lambda5__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda5_ (self);
	block5_data_unref (self);
	return result;
}


void plank_surface_exponential_blur (PlankSurface* self, gint radius) {
	Block5Data* _data5_;
	gint _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	cairo_surface_t* original;
	gint _tmp5_;
	gint _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* cr;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_surface_t* _tmp14_;
	guchar* _tmp15_;
	GThread* th;
	GThread* _tmp16_;
	guint8* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GThread* _tmp24_;
	GThread* _tmp25_;
	GThread* th2;
	GThread* _tmp26_;
	guint8* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GThread* _tmp34_;
	GThread* _tmp35_;
	cairo_surface_t* _tmp36_;
	cairo_t* target_cr;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_surface_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = radius;
	if (_tmp0_ < 1) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp1_ = radius;
	_tmp2_ = exp ((-2.3) / (_tmp1_ + 1.0));
	_data5_->alpha = (gint) ((1 << PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION) * (1.0 - _tmp2_));
	_tmp3_ = self->priv->_Height;
	_data5_->height = _tmp3_;
	_tmp4_ = self->priv->_Width;
	_data5_->width = _tmp4_;
	_tmp5_ = _data5_->width;
	_tmp6_ = _data5_->height;
	_tmp7_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp5_, _tmp6_);
	original = _tmp7_;
	_tmp8_ = original;
	_tmp9_ = cairo_create (_tmp8_);
	cr = _tmp9_;
	_tmp10_ = cr;
	cairo_set_operator (_tmp10_, CAIRO_OPERATOR_SOURCE);
	_tmp11_ = cr;
	_tmp12_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp11_, _tmp12_, (gdouble) 0, (gdouble) 0);
	_tmp13_ = cr;
	cairo_paint (_tmp13_);
	_tmp14_ = original;
	_tmp15_ = cairo_image_surface_get_data (_tmp14_);
	_data5_->pixels = _tmp15_;
	_tmp16_ = g_thread_new (NULL, ___lambda4__gthread_func, block5_data_ref (_data5_));
	th = _tmp16_;
	_tmp17_ = _data5_->pixels;
	_tmp18_ = _data5_->width;
	_tmp19_ = _data5_->height;
	_tmp20_ = _data5_->height;
	_tmp21_ = _data5_->height;
	_tmp22_ = _data5_->width;
	_tmp23_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp17_, _tmp18_, _tmp19_, _tmp20_ / 2, _tmp21_, 0, _tmp22_, _tmp23_);
	_tmp24_ = th;
	_tmp25_ = _g_thread_ref0 (_tmp24_);
	g_thread_join (_tmp25_);
	_tmp26_ = g_thread_new (NULL, ___lambda5__gthread_func, block5_data_ref (_data5_));
	th2 = _tmp26_;
	_tmp27_ = _data5_->pixels;
	_tmp28_ = _data5_->width;
	_tmp29_ = _data5_->height;
	_tmp30_ = _data5_->width;
	_tmp31_ = _data5_->width;
	_tmp32_ = _data5_->height;
	_tmp33_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp27_, _tmp28_, _tmp29_, _tmp30_ / 2, _tmp31_, 0, _tmp32_, _tmp33_);
	_tmp34_ = th2;
	_tmp35_ = _g_thread_ref0 (_tmp34_);
	g_thread_join (_tmp35_);
	_tmp36_ = original;
	cairo_surface_mark_dirty (_tmp36_);
	_tmp37_ = self->priv->_Context;
	target_cr = _tmp37_;
	_tmp38_ = target_cr;
	cairo_save (_tmp38_);
	_tmp39_ = target_cr;
	cairo_set_operator (_tmp39_, CAIRO_OPERATOR_SOURCE);
	_tmp40_ = target_cr;
	_tmp41_ = original;
	cairo_set_source_surface (_tmp40_, _tmp41_, (gdouble) 0, (gdouble) 0);
	_tmp42_ = target_cr;
	cairo_paint (_tmp42_);
	_tmp43_ = target_cr;
	cairo_restore (_tmp43_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


static void plank_surface_exponential_blur_columns (guint8* pixels, gint width, gint height, gint startCol, gint endCol, gint startY, gint endY, gint alpha) {
	{
		gint columnIndex;
		gint _tmp0_;
		_tmp0_ = startCol;
		columnIndex = _tmp0_;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				guint8* column;
				guint8* _tmp5_;
				gint _tmp6_;
				gint zA;
				guint8* _tmp7_;
				guint8 _tmp8_;
				gint zR;
				guint8* _tmp9_;
				guint8 _tmp10_;
				gint zG;
				guint8* _tmp11_;
				guint8 _tmp12_;
				gint zB;
				guint8* _tmp13_;
				guint8 _tmp14_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = columnIndex;
					columnIndex = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = columnIndex;
				_tmp4_ = endCol;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				_tmp5_ = pixels;
				_tmp6_ = columnIndex;
				column = _tmp5_ + (_tmp6_ * 4);
				_tmp7_ = column;
				_tmp8_ = _tmp7_[0];
				zA = _tmp8_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp9_ = column;
				_tmp10_ = _tmp9_[1];
				zR = _tmp10_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp11_ = column;
				_tmp12_ = _tmp11_[2];
				zG = _tmp12_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp13_ = column;
				_tmp14_ = _tmp13_[3];
				zB = _tmp14_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index;
					gint _tmp15_;
					gint _tmp16_;
					_tmp15_ = width;
					_tmp16_ = startY;
					index = _tmp15_ * (_tmp16_ + 1);
					{
						gboolean _tmp17_;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							guint8* _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							if (!_tmp17_) {
								gint _tmp18_;
								gint _tmp19_;
								_tmp18_ = index;
								_tmp19_ = width;
								index = _tmp18_ + _tmp19_;
							}
							_tmp17_ = FALSE;
							_tmp20_ = index;
							_tmp21_ = endY;
							_tmp22_ = width;
							if (!(_tmp20_ < ((_tmp21_ - 1) * _tmp22_))) {
								break;
							}
							_tmp23_ = column;
							_tmp24_ = index;
							_tmp25_ = alpha;
							plank_surface_exponential_blur_inner (&_tmp23_[_tmp24_ * 4], &zA, &zR, &zG, &zB, _tmp25_);
						}
					}
				}
				{
					gint index;
					gint _tmp26_;
					gint _tmp27_;
					_tmp26_ = endY;
					_tmp27_ = width;
					index = (_tmp26_ - 2) * _tmp27_;
					{
						gboolean _tmp28_;
						_tmp28_ = TRUE;
						while (TRUE) {
							gint _tmp31_;
							gint _tmp32_;
							guint8* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							if (!_tmp28_) {
								gint _tmp29_;
								gint _tmp30_;
								_tmp29_ = index;
								_tmp30_ = width;
								index = _tmp29_ - _tmp30_;
							}
							_tmp28_ = FALSE;
							_tmp31_ = index;
							_tmp32_ = startY;
							if (!(_tmp31_ >= _tmp32_)) {
								break;
							}
							_tmp33_ = column;
							_tmp34_ = index;
							_tmp35_ = alpha;
							plank_surface_exponential_blur_inner (&_tmp33_[_tmp34_ * 4], &zA, &zR, &zG, &zB, _tmp35_);
						}
					}
				}
			}
		}
	}
}


static void plank_surface_exponential_blur_rows (guint8* pixels, gint width, gint height, gint startRow, gint endRow, gint startX, gint endX, gint alpha) {
	{
		gint rowIndex;
		gint _tmp0_;
		_tmp0_ = startRow;
		rowIndex = _tmp0_;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				guint8* row;
				guint8* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint zA;
				guint8* _tmp8_;
				gint _tmp9_;
				guint8 _tmp10_;
				gint zR;
				guint8* _tmp11_;
				gint _tmp12_;
				guint8 _tmp13_;
				gint zG;
				guint8* _tmp14_;
				gint _tmp15_;
				guint8 _tmp16_;
				gint zB;
				guint8* _tmp17_;
				gint _tmp18_;
				guint8 _tmp19_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = rowIndex;
					rowIndex = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = rowIndex;
				_tmp4_ = endRow;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				_tmp5_ = pixels;
				_tmp6_ = rowIndex;
				_tmp7_ = width;
				row = _tmp5_ + ((_tmp6_ * _tmp7_) * 4);
				_tmp8_ = row;
				_tmp9_ = startX;
				_tmp10_ = _tmp8_[_tmp9_ + 0];
				zA = _tmp10_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp11_ = row;
				_tmp12_ = startX;
				_tmp13_ = _tmp11_[_tmp12_ + 1];
				zR = _tmp13_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp14_ = row;
				_tmp15_ = startX;
				_tmp16_ = _tmp14_[_tmp15_ + 2];
				zG = _tmp16_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp17_ = row;
				_tmp18_ = startX;
				_tmp19_ = _tmp17_[_tmp18_ + 3];
				zB = _tmp19_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index;
					gint _tmp20_;
					_tmp20_ = startX;
					index = _tmp20_ + 1;
					{
						gboolean _tmp21_;
						_tmp21_ = TRUE;
						while (TRUE) {
							gint _tmp23_;
							gint _tmp24_;
							guint8* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							if (!_tmp21_) {
								gint _tmp22_;
								_tmp22_ = index;
								index = _tmp22_ + 1;
							}
							_tmp21_ = FALSE;
							_tmp23_ = index;
							_tmp24_ = endX;
							if (!(_tmp23_ < _tmp24_)) {
								break;
							}
							_tmp25_ = row;
							_tmp26_ = index;
							_tmp27_ = alpha;
							plank_surface_exponential_blur_inner (&_tmp25_[_tmp26_ * 4], &zA, &zR, &zG, &zB, _tmp27_);
						}
					}
				}
				{
					gint index;
					gint _tmp28_;
					_tmp28_ = endX;
					index = _tmp28_ - 2;
					{
						gboolean _tmp29_;
						_tmp29_ = TRUE;
						while (TRUE) {
							gint _tmp31_;
							gint _tmp32_;
							guint8* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							if (!_tmp29_) {
								gint _tmp30_;
								_tmp30_ = index;
								index = _tmp30_ - 1;
							}
							_tmp29_ = FALSE;
							_tmp31_ = index;
							_tmp32_ = startX;
							if (!(_tmp31_ >= _tmp32_)) {
								break;
							}
							_tmp33_ = row;
							_tmp34_ = index;
							_tmp35_ = alpha;
							plank_surface_exponential_blur_inner (&_tmp33_[_tmp34_ * 4], &zA, &zR, &zG, &zB, _tmp35_);
						}
					}
				}
			}
		}
	}
}


static inline void plank_surface_exponential_blur_inner (guint8* pixel, gint* zA, gint* zR, gint* zG, gint* zB, gint alpha) {
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	guint8 _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	guint8* _tmp7_;
	guint8 _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	guint8* _tmp12_;
	guint8 _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	guint8* _tmp17_;
	guint8 _tmp18_;
	gint _tmp19_;
	guint8* _tmp20_;
	gint _tmp21_;
	guint8 _tmp22_;
	guint8* _tmp23_;
	gint _tmp24_;
	guint8 _tmp25_;
	guint8* _tmp26_;
	gint _tmp27_;
	guint8 _tmp28_;
	guint8* _tmp29_;
	gint _tmp30_;
	guint8 _tmp31_;
	_tmp0_ = *zA;
	_tmp1_ = alpha;
	_tmp2_ = pixel;
	_tmp3_ = _tmp2_[0];
	_tmp4_ = *zA;
	*zA = _tmp0_ + ((_tmp1_ * ((_tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - _tmp4_)) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp5_ = *zR;
	_tmp6_ = alpha;
	_tmp7_ = pixel;
	_tmp8_ = _tmp7_[1];
	_tmp9_ = *zR;
	*zR = _tmp5_ + ((_tmp6_ * ((_tmp8_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - _tmp9_)) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp10_ = *zG;
	_tmp11_ = alpha;
	_tmp12_ = pixel;
	_tmp13_ = _tmp12_[2];
	_tmp14_ = *zG;
	*zG = _tmp10_ + ((_tmp11_ * ((_tmp13_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - _tmp14_)) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp15_ = *zB;
	_tmp16_ = alpha;
	_tmp17_ = pixel;
	_tmp18_ = _tmp17_[3];
	_tmp19_ = *zB;
	*zB = _tmp15_ + ((_tmp16_ * ((_tmp18_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - _tmp19_)) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp20_ = pixel;
	_tmp21_ = *zA;
	_tmp20_[0] = (guint8) (_tmp21_ >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp22_ = _tmp20_[0];
	_tmp23_ = pixel;
	_tmp24_ = *zR;
	_tmp23_[1] = (guint8) (_tmp24_ >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp25_ = _tmp23_[1];
	_tmp26_ = pixel;
	_tmp27_ = *zG;
	_tmp26_[2] = (guint8) (_tmp27_ >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp28_ = _tmp26_[2];
	_tmp29_ = pixel;
	_tmp30_ = *zB;
	_tmp29_[3] = (guint8) (_tmp30_ >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp31_ = _tmp29_[3];
}


/**
 * Performs a gaussian blur on the surface.
 * ''Note: This method is wickedly slow''
 *
 * @param radius the radius of the blur
 */
static Block6Data* block6_data_ref (Block6Data* _data6_) {
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PlankSurface* self;
		self = _data6_->self;
		_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
		_data6_->bbuffer = (g_free (_data6_->bbuffer), NULL);
		_data6_->abuffer = (g_free (_data6_->abuffer), NULL);
		_data6_->kernel = (g_free (_data6_->kernel), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static void* __lambda6_ (Block6Data* _data6_) {
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->abuffer;
	_tmp0__length1 = _data6_->abuffer_length1;
	_tmp1_ = _data6_->bbuffer;
	_tmp1__length1 = _data6_->bbuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->height;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer ___lambda6__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda6_ (self);
	block6_data_unref (self);
	return result;
}


static void* __lambda7_ (Block6Data* _data6_) {
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->bbuffer;
	_tmp0__length1 = _data6_->bbuffer_length1;
	_tmp1_ = _data6_->abuffer;
	_tmp1__length1 = _data6_->abuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->width;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer ___lambda7__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda7_ (self);
	block6_data_unref (self);
	return result;
}


void plank_surface_gaussian_blur (PlankSurface* self, gint radius) {
	Block6Data* _data6_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	cairo_surface_t* original;
	gint _tmp7_;
	gint _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* cr;
	cairo_surface_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	guint8* src;
	cairo_surface_t* _tmp16_;
	guchar* _tmp17_;
	gint size;
	gint _tmp18_;
	cairo_surface_t* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gdouble* _tmp22_;
	gint _tmp23_;
	gdouble* _tmp24_;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint* _tmp39_;
	GThread* th;
	GThread* _tmp65_;
	gdouble* _tmp66_;
	gint _tmp66__length1;
	gdouble* _tmp67_;
	gint _tmp67__length1;
	gdouble* _tmp68_;
	gint _tmp68__length1;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	gint* _tmp74_;
	gint _tmp74__length1;
	gint _tmp74__length2;
	GThread* _tmp75_;
	GThread* _tmp76_;
	gdouble* _tmp77_;
	gint _tmp77__length1;
	gint _tmp78_;
	gint _tmp79_;
	gint _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	gint* _tmp83_;
	GThread* th2;
	GThread* _tmp110_;
	gdouble* _tmp111_;
	gint _tmp111__length1;
	gdouble* _tmp112_;
	gint _tmp112__length1;
	gdouble* _tmp113_;
	gint _tmp113__length1;
	gint _tmp114_;
	gint _tmp115_;
	gint _tmp116_;
	gint _tmp117_;
	gint _tmp118_;
	gint* _tmp119_;
	gint _tmp119__length1;
	gint _tmp119__length2;
	GThread* _tmp120_;
	GThread* _tmp121_;
	cairo_surface_t* _tmp132_;
	cairo_t* target_cr;
	cairo_t* _tmp133_;
	cairo_t* _tmp134_;
	cairo_t* _tmp135_;
	cairo_t* _tmp136_;
	cairo_surface_t* _tmp137_;
	cairo_t* _tmp138_;
	cairo_t* _tmp139_;
	g_return_if_fail (self != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = radius;
	if (_tmp0_ < 1) {
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	_tmp1_ = radius;
	_data6_->gaussWidth = (_tmp1_ * 2) + 1;
	_tmp2_ = _data6_->gaussWidth;
	_tmp4_ = plank_surface_build_gaussian_kernel (_tmp2_, &_tmp3_);
	_data6_->kernel = _tmp4_;
	_data6_->kernel_length1 = _tmp3_;
	_data6_->_kernel_size_ = _data6_->kernel_length1;
	_tmp5_ = self->priv->_Width;
	_data6_->width = _tmp5_;
	_tmp6_ = self->priv->_Height;
	_data6_->height = _tmp6_;
	_tmp7_ = _data6_->width;
	_tmp8_ = _data6_->height;
	_tmp9_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp7_, _tmp8_);
	original = _tmp9_;
	_tmp10_ = original;
	_tmp11_ = cairo_create (_tmp10_);
	cr = _tmp11_;
	_tmp12_ = cr;
	cairo_set_operator (_tmp12_, CAIRO_OPERATOR_SOURCE);
	_tmp13_ = cr;
	_tmp14_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp13_, _tmp14_, (gdouble) 0, (gdouble) 0);
	_tmp15_ = cr;
	cairo_paint (_tmp15_);
	_tmp16_ = original;
	_tmp17_ = cairo_image_surface_get_data (_tmp16_);
	src = _tmp17_;
	_tmp18_ = _data6_->height;
	_tmp19_ = original;
	_tmp20_ = cairo_image_surface_get_stride (_tmp19_);
	size = _tmp18_ * _tmp20_;
	_tmp21_ = size;
	_tmp22_ = g_new0 (gdouble, _tmp21_);
	_data6_->abuffer = _tmp22_;
	_data6_->abuffer_length1 = _tmp21_;
	_data6_->_abuffer_size_ = _data6_->abuffer_length1;
	_tmp23_ = size;
	_tmp24_ = g_new0 (gdouble, _tmp23_);
	_data6_->bbuffer = _tmp24_;
	_data6_->bbuffer_length1 = _tmp23_;
	_data6_->_bbuffer_size_ = _data6_->bbuffer_length1;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp25_;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				gint _tmp28_;
				gdouble* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				guint8* _tmp31_;
				gint _tmp32_;
				guint8 _tmp33_;
				gdouble _tmp34_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = i;
				_tmp28_ = size;
				if (!(_tmp27_ < _tmp28_)) {
					break;
				}
				_tmp29_ = _data6_->abuffer;
				_tmp29__length1 = _data6_->abuffer_length1;
				_tmp30_ = i;
				_tmp31_ = src;
				_tmp32_ = i;
				_tmp33_ = _tmp31_[_tmp32_];
				_tmp29_[_tmp30_] = (gdouble) _tmp33_;
				_tmp34_ = _tmp29_[_tmp30_];
			}
		}
	}
	_tmp35_ = _data6_->width;
	_tmp36_ = _data6_->height;
	_tmp37_ = MAX (_tmp35_, _tmp36_);
	_tmp38_ = _data6_->gaussWidth;
	_tmp39_ = g_new0 (gint, _tmp37_ * _tmp38_);
	_data6_->shiftar = _tmp39_;
	_data6_->shiftar_length1 = _tmp37_;
	_data6_->shiftar_length2 = _tmp38_;
	{
		gint x;
		x = 0;
		{
			gboolean _tmp40_;
			_tmp40_ = TRUE;
			while (TRUE) {
				gint _tmp42_;
				gint _tmp43_;
				if (!_tmp40_) {
					gint _tmp41_;
					_tmp41_ = x;
					x = _tmp41_ + 1;
				}
				_tmp40_ = FALSE;
				_tmp42_ = x;
				_tmp43_ = _data6_->width;
				if (!(_tmp42_ < _tmp43_)) {
					break;
				}
				{
					gint k;
					k = 0;
					{
						gboolean _tmp44_;
						_tmp44_ = TRUE;
						while (TRUE) {
							gint _tmp46_;
							gint _tmp47_;
							gint shift;
							gint _tmp48_;
							gint _tmp49_;
							gboolean _tmp50_ = FALSE;
							gint _tmp51_;
							gint _tmp52_;
							if (!_tmp44_) {
								gint _tmp45_;
								_tmp45_ = k;
								k = _tmp45_ + 1;
							}
							_tmp44_ = FALSE;
							_tmp46_ = k;
							_tmp47_ = _data6_->gaussWidth;
							if (!(_tmp46_ < _tmp47_)) {
								break;
							}
							_tmp48_ = k;
							_tmp49_ = radius;
							shift = _tmp48_ - _tmp49_;
							_tmp51_ = x;
							_tmp52_ = shift;
							if ((_tmp51_ + _tmp52_) <= 0) {
								_tmp50_ = TRUE;
							} else {
								gint _tmp53_;
								gint _tmp54_;
								gint _tmp55_;
								_tmp53_ = x;
								_tmp54_ = shift;
								_tmp55_ = _data6_->width;
								_tmp50_ = (_tmp53_ + _tmp54_) >= _tmp55_;
							}
							if (_tmp50_) {
								gint* _tmp56_;
								gint _tmp56__length1;
								gint _tmp56__length2;
								gint _tmp57_;
								gint _tmp58_;
								gint _tmp59_;
								_tmp56_ = _data6_->shiftar;
								_tmp56__length1 = _data6_->shiftar_length1;
								_tmp56__length2 = _data6_->shiftar_length2;
								_tmp57_ = x;
								_tmp58_ = k;
								_tmp56_[(_tmp57_ * _tmp56__length2) + _tmp58_] = 0;
								_tmp59_ = _tmp56_[(_tmp57_ * _tmp56__length2) + _tmp58_];
							} else {
								gint* _tmp60_;
								gint _tmp60__length1;
								gint _tmp60__length2;
								gint _tmp61_;
								gint _tmp62_;
								gint _tmp63_;
								gint _tmp64_;
								_tmp60_ = _data6_->shiftar;
								_tmp60__length1 = _data6_->shiftar_length1;
								_tmp60__length2 = _data6_->shiftar_length2;
								_tmp61_ = x;
								_tmp62_ = k;
								_tmp63_ = shift;
								_tmp60_[(_tmp61_ * _tmp60__length2) + _tmp62_] = _tmp63_ * 4;
								_tmp64_ = _tmp60_[(_tmp61_ * _tmp60__length2) + _tmp62_];
							}
						}
					}
				}
			}
		}
	}
	_tmp65_ = g_thread_new (NULL, ___lambda6__gthread_func, block6_data_ref (_data6_));
	th = _tmp65_;
	_tmp66_ = _data6_->abuffer;
	_tmp66__length1 = _data6_->abuffer_length1;
	_tmp67_ = _data6_->bbuffer;
	_tmp67__length1 = _data6_->bbuffer_length1;
	_tmp68_ = _data6_->kernel;
	_tmp68__length1 = _data6_->kernel_length1;
	_tmp69_ = _data6_->gaussWidth;
	_tmp70_ = _data6_->width;
	_tmp71_ = _data6_->height;
	_tmp72_ = _data6_->height;
	_tmp73_ = _data6_->height;
	_tmp74_ = _data6_->shiftar;
	_tmp74__length1 = _data6_->shiftar_length1;
	_tmp74__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp70_, _tmp71_, _tmp72_ / 2, _tmp73_, _tmp74_, _tmp74__length1, _tmp74__length2);
	_tmp75_ = th;
	_tmp76_ = _g_thread_ref0 (_tmp75_);
	g_thread_join (_tmp76_);
	_tmp77_ = _data6_->abuffer;
	_tmp77__length1 = _data6_->abuffer_length1;
	_tmp78_ = size;
	memset (_tmp77_, 0, (gsize) (sizeof (gdouble) * _tmp78_));
	_tmp79_ = _data6_->width;
	_tmp80_ = _data6_->height;
	_tmp81_ = MAX (_tmp79_, _tmp80_);
	_tmp82_ = _data6_->gaussWidth;
	_tmp83_ = g_new0 (gint, _tmp81_ * _tmp82_);
	_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
	_data6_->shiftar = _tmp83_;
	_data6_->shiftar_length1 = _tmp81_;
	_data6_->shiftar_length2 = _tmp82_;
	{
		gint y;
		y = 0;
		{
			gboolean _tmp84_;
			_tmp84_ = TRUE;
			while (TRUE) {
				gint _tmp86_;
				gint _tmp87_;
				if (!_tmp84_) {
					gint _tmp85_;
					_tmp85_ = y;
					y = _tmp85_ + 1;
				}
				_tmp84_ = FALSE;
				_tmp86_ = y;
				_tmp87_ = _data6_->height;
				if (!(_tmp86_ < _tmp87_)) {
					break;
				}
				{
					gint k;
					k = 0;
					{
						gboolean _tmp88_;
						_tmp88_ = TRUE;
						while (TRUE) {
							gint _tmp90_;
							gint _tmp91_;
							gint shift;
							gint _tmp92_;
							gint _tmp93_;
							gboolean _tmp94_ = FALSE;
							gint _tmp95_;
							gint _tmp96_;
							if (!_tmp88_) {
								gint _tmp89_;
								_tmp89_ = k;
								k = _tmp89_ + 1;
							}
							_tmp88_ = FALSE;
							_tmp90_ = k;
							_tmp91_ = _data6_->gaussWidth;
							if (!(_tmp90_ < _tmp91_)) {
								break;
							}
							_tmp92_ = k;
							_tmp93_ = radius;
							shift = _tmp92_ - _tmp93_;
							_tmp95_ = y;
							_tmp96_ = shift;
							if ((_tmp95_ + _tmp96_) <= 0) {
								_tmp94_ = TRUE;
							} else {
								gint _tmp97_;
								gint _tmp98_;
								gint _tmp99_;
								_tmp97_ = y;
								_tmp98_ = shift;
								_tmp99_ = _data6_->height;
								_tmp94_ = (_tmp97_ + _tmp98_) >= _tmp99_;
							}
							if (_tmp94_) {
								gint* _tmp100_;
								gint _tmp100__length1;
								gint _tmp100__length2;
								gint _tmp101_;
								gint _tmp102_;
								gint _tmp103_;
								_tmp100_ = _data6_->shiftar;
								_tmp100__length1 = _data6_->shiftar_length1;
								_tmp100__length2 = _data6_->shiftar_length2;
								_tmp101_ = y;
								_tmp102_ = k;
								_tmp100_[(_tmp101_ * _tmp100__length2) + _tmp102_] = 0;
								_tmp103_ = _tmp100_[(_tmp101_ * _tmp100__length2) + _tmp102_];
							} else {
								gint* _tmp104_;
								gint _tmp104__length1;
								gint _tmp104__length2;
								gint _tmp105_;
								gint _tmp106_;
								gint _tmp107_;
								gint _tmp108_;
								gint _tmp109_;
								_tmp104_ = _data6_->shiftar;
								_tmp104__length1 = _data6_->shiftar_length1;
								_tmp104__length2 = _data6_->shiftar_length2;
								_tmp105_ = y;
								_tmp106_ = k;
								_tmp107_ = shift;
								_tmp108_ = _data6_->width;
								_tmp104_[(_tmp105_ * _tmp104__length2) + _tmp106_] = (_tmp107_ * _tmp108_) * 4;
								_tmp109_ = _tmp104_[(_tmp105_ * _tmp104__length2) + _tmp106_];
							}
						}
					}
				}
			}
		}
	}
	_tmp110_ = g_thread_new (NULL, ___lambda7__gthread_func, block6_data_ref (_data6_));
	th2 = _tmp110_;
	_tmp111_ = _data6_->bbuffer;
	_tmp111__length1 = _data6_->bbuffer_length1;
	_tmp112_ = _data6_->abuffer;
	_tmp112__length1 = _data6_->abuffer_length1;
	_tmp113_ = _data6_->kernel;
	_tmp113__length1 = _data6_->kernel_length1;
	_tmp114_ = _data6_->gaussWidth;
	_tmp115_ = _data6_->width;
	_tmp116_ = _data6_->height;
	_tmp117_ = _data6_->width;
	_tmp118_ = _data6_->width;
	_tmp119_ = _data6_->shiftar;
	_tmp119__length1 = _data6_->shiftar_length1;
	_tmp119__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp111_, _tmp112_, _tmp113_, _tmp114_, _tmp115_, _tmp116_, _tmp117_ / 2, _tmp118_, _tmp119_, _tmp119__length1, _tmp119__length2);
	_tmp120_ = th2;
	_tmp121_ = _g_thread_ref0 (_tmp120_);
	g_thread_join (_tmp121_);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp122_;
			_tmp122_ = TRUE;
			while (TRUE) {
				gint _tmp124_;
				gint _tmp125_;
				guint8* _tmp126_;
				gint _tmp127_;
				gdouble* _tmp128_;
				gint _tmp128__length1;
				gint _tmp129_;
				gdouble _tmp130_;
				guint8 _tmp131_;
				if (!_tmp122_) {
					gint _tmp123_;
					_tmp123_ = i;
					i = _tmp123_ + 1;
				}
				_tmp122_ = FALSE;
				_tmp124_ = i;
				_tmp125_ = size;
				if (!(_tmp124_ < _tmp125_)) {
					break;
				}
				_tmp126_ = src;
				_tmp127_ = i;
				_tmp128_ = _data6_->abuffer;
				_tmp128__length1 = _data6_->abuffer_length1;
				_tmp129_ = i;
				_tmp130_ = _tmp128_[_tmp129_];
				_tmp126_[_tmp127_] = (guint8) _tmp130_;
				_tmp131_ = _tmp126_[_tmp127_];
			}
		}
	}
	_tmp132_ = original;
	cairo_surface_mark_dirty (_tmp132_);
	_tmp133_ = self->priv->_Context;
	target_cr = _tmp133_;
	_tmp134_ = target_cr;
	cairo_save (_tmp134_);
	_tmp135_ = target_cr;
	cairo_set_operator (_tmp135_, CAIRO_OPERATOR_SOURCE);
	_tmp136_ = target_cr;
	_tmp137_ = original;
	cairo_set_source_surface (_tmp136_, _tmp137_, (gdouble) 0, (gdouble) 0);
	_tmp138_ = target_cr;
	cairo_paint (_tmp138_);
	_tmp139_ = target_cr;
	cairo_restore (_tmp139_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


static void plank_surface_gaussian_blur_horizontal (gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startRow, gint endRow, gint* shift, int shift_length1, int shift_length2) {
	guint32 cur_pixel;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = startRow;
	_tmp1_ = width;
	cur_pixel = (guint32) ((_tmp0_ * _tmp1_) * 4);
	{
		gint y;
		gint _tmp2_;
		_tmp2_ = startRow;
		y = _tmp2_;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = y;
					y = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = y;
				_tmp6_ = endRow;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				{
					gint x;
					x = 0;
					{
						gboolean _tmp7_;
						_tmp7_ = TRUE;
						while (TRUE) {
							gint _tmp9_;
							gint _tmp10_;
							guint32 _tmp51_;
							if (!_tmp7_) {
								gint _tmp8_;
								_tmp8_ = x;
								x = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							_tmp9_ = x;
							_tmp10_ = width;
							if (!(_tmp9_ < _tmp10_)) {
								break;
							}
							{
								gint k;
								k = 0;
								{
									gboolean _tmp11_;
									_tmp11_ = TRUE;
									while (TRUE) {
										gint _tmp13_;
										gint _tmp14_;
										guint32 source;
										guint32 _tmp15_;
										gint* _tmp16_;
										gint _tmp16__length1;
										gint _tmp16__length2;
										gint _tmp17_;
										gint _tmp18_;
										gint _tmp19_;
										gdouble kernel_k;
										gdouble* _tmp20_;
										gint _tmp21_;
										gdouble _tmp22_;
										gdouble* _tmp23_;
										guint32 _tmp24_;
										gdouble* _tmp25_;
										guint32 _tmp26_;
										gdouble _tmp27_;
										gdouble _tmp28_;
										gdouble _tmp29_;
										gdouble* _tmp30_;
										guint32 _tmp31_;
										gdouble* _tmp32_;
										guint32 _tmp33_;
										gdouble _tmp34_;
										gdouble _tmp35_;
										gdouble _tmp36_;
										gdouble* _tmp37_;
										guint32 _tmp38_;
										gdouble* _tmp39_;
										guint32 _tmp40_;
										gdouble _tmp41_;
										gdouble _tmp42_;
										gdouble _tmp43_;
										gdouble* _tmp44_;
										guint32 _tmp45_;
										gdouble* _tmp46_;
										guint32 _tmp47_;
										gdouble _tmp48_;
										gdouble _tmp49_;
										gdouble _tmp50_;
										if (!_tmp11_) {
											gint _tmp12_;
											_tmp12_ = k;
											k = _tmp12_ + 1;
										}
										_tmp11_ = FALSE;
										_tmp13_ = k;
										_tmp14_ = gaussWidth;
										if (!(_tmp13_ < _tmp14_)) {
											break;
										}
										_tmp15_ = cur_pixel;
										_tmp16_ = shift;
										_tmp16__length1 = shift_length1;
										_tmp16__length2 = shift_length2;
										_tmp17_ = x;
										_tmp18_ = k;
										_tmp19_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
										source = _tmp15_ + _tmp19_;
										_tmp20_ = kernel;
										_tmp21_ = k;
										_tmp22_ = _tmp20_[_tmp21_];
										kernel_k = _tmp22_;
										_tmp23_ = dest;
										_tmp24_ = cur_pixel;
										_tmp25_ = src;
										_tmp26_ = source;
										_tmp27_ = _tmp25_[_tmp26_ + 0];
										_tmp28_ = kernel_k;
										_tmp23_[_tmp24_ + 0] += _tmp27_ * _tmp28_;
										_tmp29_ = _tmp23_[_tmp24_ + 0];
										_tmp30_ = dest;
										_tmp31_ = cur_pixel;
										_tmp32_ = src;
										_tmp33_ = source;
										_tmp34_ = _tmp32_[_tmp33_ + 1];
										_tmp35_ = kernel_k;
										_tmp30_[_tmp31_ + 1] += _tmp34_ * _tmp35_;
										_tmp36_ = _tmp30_[_tmp31_ + 1];
										_tmp37_ = dest;
										_tmp38_ = cur_pixel;
										_tmp39_ = src;
										_tmp40_ = source;
										_tmp41_ = _tmp39_[_tmp40_ + 2];
										_tmp42_ = kernel_k;
										_tmp37_[_tmp38_ + 2] += _tmp41_ * _tmp42_;
										_tmp43_ = _tmp37_[_tmp38_ + 2];
										_tmp44_ = dest;
										_tmp45_ = cur_pixel;
										_tmp46_ = src;
										_tmp47_ = source;
										_tmp48_ = _tmp46_[_tmp47_ + 3];
										_tmp49_ = kernel_k;
										_tmp44_[_tmp45_ + 3] += _tmp48_ * _tmp49_;
										_tmp50_ = _tmp44_[_tmp45_ + 3];
									}
								}
							}
							_tmp51_ = cur_pixel;
							cur_pixel = _tmp51_ + 4;
						}
					}
				}
			}
		}
	}
}


static void plank_surface_gaussian_blur_vertical (gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startCol, gint endCol, gint* shift, int shift_length1, int shift_length2) {
	guint32 cur_pixel;
	gint _tmp0_;
	_tmp0_ = startCol;
	cur_pixel = (guint32) (_tmp0_ * 4);
	{
		gint y;
		y = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				guint32 _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				gint _tmp54_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = y;
					y = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = y;
				_tmp4_ = height;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				{
					gint x;
					gint _tmp5_;
					_tmp5_ = startCol;
					x = _tmp5_;
					{
						gboolean _tmp6_;
						_tmp6_ = TRUE;
						while (TRUE) {
							gint _tmp8_;
							gint _tmp9_;
							guint32 _tmp50_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = x;
								x = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = x;
							_tmp9_ = endCol;
							if (!(_tmp8_ < _tmp9_)) {
								break;
							}
							{
								gint k;
								k = 0;
								{
									gboolean _tmp10_;
									_tmp10_ = TRUE;
									while (TRUE) {
										gint _tmp12_;
										gint _tmp13_;
										guint32 source;
										guint32 _tmp14_;
										gint* _tmp15_;
										gint _tmp15__length1;
										gint _tmp15__length2;
										gint _tmp16_;
										gint _tmp17_;
										gint _tmp18_;
										gdouble kernel_k;
										gdouble* _tmp19_;
										gint _tmp20_;
										gdouble _tmp21_;
										gdouble* _tmp22_;
										guint32 _tmp23_;
										gdouble* _tmp24_;
										guint32 _tmp25_;
										gdouble _tmp26_;
										gdouble _tmp27_;
										gdouble _tmp28_;
										gdouble* _tmp29_;
										guint32 _tmp30_;
										gdouble* _tmp31_;
										guint32 _tmp32_;
										gdouble _tmp33_;
										gdouble _tmp34_;
										gdouble _tmp35_;
										gdouble* _tmp36_;
										guint32 _tmp37_;
										gdouble* _tmp38_;
										guint32 _tmp39_;
										gdouble _tmp40_;
										gdouble _tmp41_;
										gdouble _tmp42_;
										gdouble* _tmp43_;
										guint32 _tmp44_;
										gdouble* _tmp45_;
										guint32 _tmp46_;
										gdouble _tmp47_;
										gdouble _tmp48_;
										gdouble _tmp49_;
										if (!_tmp10_) {
											gint _tmp11_;
											_tmp11_ = k;
											k = _tmp11_ + 1;
										}
										_tmp10_ = FALSE;
										_tmp12_ = k;
										_tmp13_ = gaussWidth;
										if (!(_tmp12_ < _tmp13_)) {
											break;
										}
										_tmp14_ = cur_pixel;
										_tmp15_ = shift;
										_tmp15__length1 = shift_length1;
										_tmp15__length2 = shift_length2;
										_tmp16_ = y;
										_tmp17_ = k;
										_tmp18_ = _tmp15_[(_tmp16_ * _tmp15__length2) + _tmp17_];
										source = _tmp14_ + _tmp18_;
										_tmp19_ = kernel;
										_tmp20_ = k;
										_tmp21_ = _tmp19_[_tmp20_];
										kernel_k = _tmp21_;
										_tmp22_ = dest;
										_tmp23_ = cur_pixel;
										_tmp24_ = src;
										_tmp25_ = source;
										_tmp26_ = _tmp24_[_tmp25_ + 0];
										_tmp27_ = kernel_k;
										_tmp22_[_tmp23_ + 0] += _tmp26_ * _tmp27_;
										_tmp28_ = _tmp22_[_tmp23_ + 0];
										_tmp29_ = dest;
										_tmp30_ = cur_pixel;
										_tmp31_ = src;
										_tmp32_ = source;
										_tmp33_ = _tmp31_[_tmp32_ + 1];
										_tmp34_ = kernel_k;
										_tmp29_[_tmp30_ + 1] += _tmp33_ * _tmp34_;
										_tmp35_ = _tmp29_[_tmp30_ + 1];
										_tmp36_ = dest;
										_tmp37_ = cur_pixel;
										_tmp38_ = src;
										_tmp39_ = source;
										_tmp40_ = _tmp38_[_tmp39_ + 2];
										_tmp41_ = kernel_k;
										_tmp36_[_tmp37_ + 2] += _tmp40_ * _tmp41_;
										_tmp42_ = _tmp36_[_tmp37_ + 2];
										_tmp43_ = dest;
										_tmp44_ = cur_pixel;
										_tmp45_ = src;
										_tmp46_ = source;
										_tmp47_ = _tmp45_[_tmp46_ + 3];
										_tmp48_ = kernel_k;
										_tmp43_[_tmp44_ + 3] += _tmp47_ * _tmp48_;
										_tmp49_ = _tmp43_[_tmp44_ + 3];
									}
								}
							}
							_tmp50_ = cur_pixel;
							cur_pixel = _tmp50_ + 4;
						}
					}
				}
				_tmp51_ = cur_pixel;
				_tmp52_ = width;
				_tmp53_ = endCol;
				_tmp54_ = startCol;
				cur_pixel = _tmp51_ + (((_tmp52_ - _tmp53_) + _tmp54_) * 4);
			}
		}
	}
}


static gdouble* plank_surface_build_gaussian_kernel (gint gaussWidth, int* result_length1) {
	gdouble* result = NULL;
	gint _tmp0_;
	gdouble* kernel;
	gint _tmp1_;
	gdouble* _tmp2_;
	gint kernel_length1;
	gint _kernel_size_;
	gdouble sd;
	gint range;
	gint _tmp3_;
	gdouble mean;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble gaussSum;
	gdouble* _tmp23_;
	gint _tmp23__length1;
	gdouble* _tmp37_;
	gint _tmp37__length1;
	_tmp0_ = gaussWidth;
	_vala_return_val_if_fail ((_tmp0_ % 2) == 1, "gaussWidth % 2 == 1", NULL);
	_tmp1_ = gaussWidth;
	_tmp2_ = g_new0 (gdouble, _tmp1_);
	kernel = _tmp2_;
	kernel_length1 = _tmp1_;
	_kernel_size_ = kernel_length1;
	sd = 255.0;
	_tmp3_ = gaussWidth;
	range = _tmp3_;
	_tmp4_ = range;
	_tmp5_ = sd;
	mean = _tmp4_ / _tmp5_;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp6_;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gdouble* _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				gint _tmp12_;
				gdouble* _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				gint _tmp15_;
				gdouble _tmp16_;
				gint _tmp17_;
				gdouble _tmp18_;
				gdouble _tmp19_;
				gdouble _tmp20_;
				gdouble _tmp21_;
				gdouble _tmp22_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = gaussWidth;
				if (!(_tmp8_ < ((_tmp9_ / 2) + 1))) {
					break;
				}
				_tmp10_ = kernel;
				_tmp10__length1 = kernel_length1;
				_tmp11_ = gaussWidth;
				_tmp12_ = i;
				_tmp13_ = kernel;
				_tmp13__length1 = kernel_length1;
				_tmp14_ = i;
				_tmp15_ = i;
				_tmp16_ = mean;
				_tmp17_ = range;
				_tmp18_ = sin ((((_tmp15_ + 1) * G_PI_2) - _tmp16_) / _tmp17_);
				_tmp19_ = pow (_tmp18_, (gdouble) 2);
				_tmp20_ = sd;
				_tmp13_[_tmp14_] = _tmp19_ * _tmp20_;
				_tmp21_ = _tmp13_[_tmp14_];
				_tmp10_[(_tmp11_ - _tmp12_) - 1] = _tmp21_;
				_tmp22_ = _tmp10_[(_tmp11_ - _tmp12_) - 1];
			}
		}
	}
	gaussSum = 0.0;
	_tmp23_ = kernel;
	_tmp23__length1 = kernel_length1;
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
		d_collection = _tmp23_;
		d_collection_length1 = _tmp23__length1;
		for (d_it = 0; d_it < _tmp23__length1; d_it = d_it + 1) {
			gdouble d = 0.0;
			d = d_collection[d_it];
			{
				gdouble _tmp24_;
				gdouble _tmp25_;
				_tmp24_ = gaussSum;
				_tmp25_ = d;
				gaussSum = _tmp24_ + _tmp25_;
			}
		}
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp26_;
			_tmp26_ = TRUE;
			while (TRUE) {
				gint _tmp28_;
				gdouble* _tmp29_;
				gint _tmp29__length1;
				gdouble* _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				gdouble* _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_;
				gdouble _tmp34_;
				gdouble _tmp35_;
				gdouble _tmp36_;
				if (!_tmp26_) {
					gint _tmp27_;
					_tmp27_ = i;
					i = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				_tmp28_ = i;
				_tmp29_ = kernel;
				_tmp29__length1 = kernel_length1;
				if (!(_tmp28_ < _tmp29__length1)) {
					break;
				}
				_tmp30_ = kernel;
				_tmp30__length1 = kernel_length1;
				_tmp31_ = i;
				_tmp32_ = kernel;
				_tmp32__length1 = kernel_length1;
				_tmp33_ = i;
				_tmp34_ = _tmp32_[_tmp33_];
				_tmp35_ = gaussSum;
				_tmp30_[_tmp31_] = _tmp34_ / _tmp35_;
				_tmp36_ = _tmp30_[_tmp31_];
			}
		}
	}
	_tmp37_ = kernel;
	_tmp37__length1 = kernel_length1;
	if (result_length1) {
		*result_length1 = _tmp37__length1;
	}
	result = _tmp37_;
	return result;
}


cairo_surface_t* plank_surface_get_Internal (PlankSurface* self) {
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	result = _tmp0_;
	return result;
}


static gpointer _cairo_surface_reference0 (gpointer self) {
	return self ? cairo_surface_reference (self) : NULL;
}


static void plank_surface_set_Internal (PlankSurface* self, cairo_surface_t* value) {
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Internal (self) != value) {
		cairo_surface_t* _tmp0_;
		cairo_surface_t* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _cairo_surface_reference0 (_tmp0_);
		_cairo_surface_destroy0 (self->priv->_Internal);
		self->priv->_Internal = _tmp1_;
		g_object_notify ((GObject *) self, "Internal");
	}
}


gint plank_surface_get_Width (PlankSurface* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Width;
	result = _tmp0_;
	return result;
}


static void plank_surface_set_Width (PlankSurface* self, gint value) {
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Width (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_Width = _tmp0_;
		g_object_notify ((GObject *) self, "Width");
	}
}


gint plank_surface_get_Height (PlankSurface* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Height;
	result = _tmp0_;
	return result;
}


static void plank_surface_set_Height (PlankSurface* self, gint value) {
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Height (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_Height = _tmp0_;
		g_object_notify ((GObject *) self, "Height");
	}
}


cairo_t* plank_surface_get_Context (PlankSurface* self) {
	cairo_t* result;
	cairo_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Context;
	result = _tmp0_;
	return result;
}


static gpointer _cairo_reference0 (gpointer self) {
	return self ? cairo_reference (self) : NULL;
}


static void plank_surface_set_Context (PlankSurface* self, cairo_t* value) {
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Context (self) != value) {
		cairo_t* _tmp0_;
		cairo_t* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _cairo_reference0 (_tmp0_);
		_cairo_destroy0 (self->priv->_Context);
		self->priv->_Context = _tmp1_;
		g_object_notify ((GObject *) self, "Context");
	}
}


static GObject * plank_surface_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankSurface * self;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	parent_class = G_OBJECT_CLASS (plank_surface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = cairo_create (_tmp0_);
	_tmp2_ = _tmp1_;
	plank_surface_set_Context (self, _tmp2_);
	_cairo_destroy0 (_tmp2_);
	return obj;
}


static void plank_surface_class_init (PlankSurfaceClass * klass) {
	plank_surface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankSurfacePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_surface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_surface_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_surface_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_surface_finalize;
	/**
	 * The internal {@link Cairo.Surface} backing the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_INTERNAL, g_param_spec_pointer ("Internal", "Internal", "Internal", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The width of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_WIDTH, g_param_spec_int ("Width", "Width", "Width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The height of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_HEIGHT, g_param_spec_int ("Height", "Height", "Height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * A {@link Cairo.Context} for the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_CONTEXT, g_param_spec_pointer ("Context", "Context", "Context", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void plank_surface_instance_init (PlankSurface * self) {
	self->priv = PLANK_SURFACE_GET_PRIVATE (self);
}


static void plank_surface_finalize (GObject * obj) {
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_cairo_surface_destroy0 (self->priv->_Internal);
	_cairo_destroy0 (self->priv->_Context);
	G_OBJECT_CLASS (plank_surface_parent_class)->finalize (obj);
}


/**
 * A surface is a wrapper class for a {@link Cairo.Surface}.
 * It encapsulates a surface/context and provides utility methods.
 */
GType plank_surface_get_type (void) {
	static volatile gsize plank_surface_type_id__volatile = 0;
	if (g_once_init_enter (&plank_surface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankSurface), 0, (GInstanceInitFunc) plank_surface_instance_init, NULL };
		GType plank_surface_type_id;
		plank_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankSurface", &g_define_type_info, 0);
		g_once_init_leave (&plank_surface_type_id__volatile, plank_surface_type_id);
	}
	return plank_surface_type_id__volatile;
}


static void _vala_plank_surface_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL:
		g_value_set_pointer (value, plank_surface_get_Internal (self));
		break;
		case PLANK_SURFACE_WIDTH:
		g_value_set_int (value, plank_surface_get_Width (self));
		break;
		case PLANK_SURFACE_HEIGHT:
		g_value_set_int (value, plank_surface_get_Height (self));
		break;
		case PLANK_SURFACE_CONTEXT:
		g_value_set_pointer (value, plank_surface_get_Context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_surface_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL:
		plank_surface_set_Internal (self, g_value_get_pointer (value));
		break;
		case PLANK_SURFACE_WIDTH:
		plank_surface_set_Width (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_HEIGHT:
		plank_surface_set_Height (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_CONTEXT:
		plank_surface_set_Context (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



