/* Theme.c generated by valac 0.36.2, the Vala compiler
 * generated from Theme.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include "gtk-compat.h"
#include <stdarg.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>


#define PLANK_TYPE_PREFERENCES (plank_preferences_get_type ())
#define PLANK_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_PREFERENCES, PlankPreferences))
#define PLANK_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))
#define PLANK_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_PREFERENCES))
#define PLANK_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_PREFERENCES))
#define PLANK_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))

typedef struct _PlankPreferences PlankPreferences;
typedef struct _PlankPreferencesClass PlankPreferencesClass;
typedef struct _PlankPreferencesPrivate PlankPreferencesPrivate;

#define PLANK_TYPE_THEME (plank_theme_get_type ())
#define PLANK_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_THEME, PlankTheme))
#define PLANK_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_THEME, PlankThemeClass))
#define PLANK_IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_THEME))
#define PLANK_IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_THEME))
#define PLANK_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_THEME, PlankThemeClass))

typedef struct _PlankTheme PlankTheme;
typedef struct _PlankThemeClass PlankThemeClass;
typedef struct _PlankThemePrivate PlankThemePrivate;

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define PLANK_TYPE_SURFACE (plank_surface_get_type ())
#define PLANK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SURFACE, PlankSurface))
#define PLANK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_SURFACE, PlankSurfaceClass))
#define PLANK_IS_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SURFACE))
#define PLANK_IS_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_SURFACE))
#define PLANK_SURFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_SURFACE, PlankSurfaceClass))

typedef struct _PlankSurface PlankSurface;
typedef struct _PlankSurfaceClass PlankSurfaceClass;
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))

struct _PlankPreferences {
	GObject parent_instance;
	PlankPreferencesPrivate * priv;
};

struct _PlankPreferencesClass {
	GObjectClass parent_class;
	void (*verify) (PlankPreferences* self, const gchar* prop);
	void (*reset_properties) (PlankPreferences* self);
};

struct _PlankTheme {
	PlankPreferences parent_instance;
	PlankThemePrivate * priv;
};

struct _PlankThemeClass {
	PlankPreferencesClass parent_class;
};

struct _PlankThemePrivate {
	gint _TopRoundness;
	gint _BottomRoundness;
	gint _LineWidth;
	PlankColor _OuterStrokeColor;
	PlankColor _FillStartColor;
	PlankColor _FillEndColor;
	PlankColor _InnerStrokeColor;
	GFile* theme_folder;
	GtkStyleContext* style_context;
};


static gpointer plank_theme_parent_class = NULL;

GType plank_preferences_get_type (void) G_GNUC_CONST;
GType plank_theme_get_type (void) G_GNUC_CONST;
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
#define PLANK_THEME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_THEME, PlankThemePrivate))
enum  {
	PLANK_THEME_DUMMY_PROPERTY,
	PLANK_THEME_TOP_ROUNDNESS,
	PLANK_THEME_BOTTOM_ROUNDNESS,
	PLANK_THEME_LINE_WIDTH,
	PLANK_THEME_OUTER_STROKE_COLOR,
	PLANK_THEME_FILL_START_COLOR,
	PLANK_THEME_FILL_END_COLOR,
	PLANK_THEME_INNER_STROKE_COLOR
};
#define PLANK_THEME_DEFAULT_NAME "Default"
#define PLANK_THEME_GTK_THEME_NAME "Gtk+"
GtkStyleContext* plank_theme_create_style_context (GType widget_type, GtkStyleContext* parent_style, GtkCssProvider* provider, const gchar* object_name, const gchar* first_class, ...);
PlankTheme* plank_theme_construct (GType object_type);
PlankPreferences* plank_preferences_construct (GType object_type);
GFile* plank_theme_get_theme_folder (const gchar* name);
PlankTheme* plank_theme_construct_with_name (GType object_type, const gchar* name);
static void plank_theme_update_style_context (PlankTheme* self, const gchar* theme_name);
static void plank_theme_gtk_theme_name_changed (PlankTheme* self, GObject* o, GParamSpec* p);
GtkStyleContext* plank_theme_get_style_context (PlankTheme* self);
static void plank_theme_real_reset_properties (PlankPreferences* base);
void plank_theme_set_TopRoundness (PlankTheme* self, gint value);
void plank_theme_set_BottomRoundness (PlankTheme* self, gint value);
void plank_theme_set_LineWidth (PlankTheme* self, gint value);
void plank_theme_set_OuterStrokeColor (PlankTheme* self, PlankColor * value);
void plank_theme_set_FillStartColor (PlankTheme* self, PlankColor * value);
void plank_theme_set_FillEndColor (PlankTheme* self, PlankColor * value);
void plank_theme_set_InnerStrokeColor (PlankTheme* self, PlankColor * value);
void plank_theme_load (PlankTheme* self, const gchar* type);
void plank_preferences_reset_properties (PlankPreferences* self);
void plank_preferences_init_from_file (PlankPreferences* self, GFile* file);
gint plank_theme_get_top_offset (PlankTheme* self);
gint plank_theme_get_LineWidth (PlankTheme* self);
gint plank_theme_get_bottom_offset (PlankTheme* self);
gint plank_theme_get_BottomRoundness (PlankTheme* self);
GType plank_surface_get_type (void) G_GNUC_CONST;
void plank_theme_draw_background (PlankTheme* self, PlankSurface* surface);
cairo_t* plank_surface_get_Context (PlankSurface* self);
gint plank_surface_get_Width (PlankSurface* self);
gint plank_surface_get_Height (PlankSurface* self);
void plank_theme_get_FillStartColor (PlankTheme* self, PlankColor * result);
void plank_theme_get_FillEndColor (PlankTheme* self, PlankColor * result);
void plank_theme_draw_rounded_rect (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gdouble top_radius, gdouble bottom_radius, gdouble line_width);
gint plank_theme_get_TopRoundness (PlankTheme* self);
void plank_theme_get_OuterStrokeColor (PlankTheme* self, PlankColor * result);
void plank_theme_get_InnerStrokeColor (PlankTheme* self, PlankColor * result);
void plank_theme_draw_inner_rect (PlankTheme* self, cairo_t* cr, gint width, gint height);
void plank_theme_draw_rounded_line (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gboolean is_round_left, gboolean is_round_right, cairo_pattern_t* stroke, cairo_pattern_t* fill);
static void plank_theme_real_verify (PlankPreferences* base, const gchar* prop);
void plank_preferences_verify (PlankPreferences* self, const gchar* prop);
gchar** plank_theme_get_theme_list (int* result_length1);
GFile* plank_paths_get_AppThemeFolder (void);
GFile* plank_paths_get_ThemeFolder (void);
static GFile* plank_theme_get_default_theme_folder (void);
static GFile* plank_theme_get_gtk_theme_folder (void);
const gchar* plank_paths_get_AppName (void);
GFile* plank_paths_get_DataHomeFolder (void);
GFile* plank_paths_get_HomeFolder (void);
GeeArrayList* plank_paths_get_DataDirFolders (void);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1, const GdkRGBA * s2);
static GObject * plank_theme_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _plank_theme_gtk_theme_name_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void plank_theme_finalize (GObject * obj);
static void _vala_plank_theme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_theme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GtkStyleContext* plank_theme_create_style_context (GType widget_type, GtkStyleContext* parent_style, GtkCssProvider* provider, const gchar* object_name, const gchar* first_class, ...) {
	GtkStyleContext* result = NULL;
	GtkWidgetPath* path = NULL;
	GtkStyleContext* style;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkWidgetPath* _tmp8_;
	GType _tmp9_;
	const gchar* _tmp10_;
	GtkWidgetPath* _tmp13_;
	const gchar* _tmp14_;
	va_list name_list;
	GtkStyleContext* _tmp21_;
	GtkWidgetPath* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkCssProvider* _tmp24_;
	g_return_val_if_fail (provider != NULL, NULL);
	g_return_val_if_fail (first_class != NULL, NULL);
	_tmp0_ = gtk_style_context_new ();
	style = _tmp0_;
	_tmp1_ = style;
	_tmp2_ = parent_style;
	gtk_style_context_set_parent (_tmp1_, _tmp2_);
	_tmp3_ = parent_style;
	if (_tmp3_ != NULL) {
		GtkStyleContext* _tmp4_;
		GtkWidgetPath* _tmp5_;
		GtkWidgetPath* _tmp6_;
		_tmp4_ = parent_style;
		_tmp5_ = gtk_style_context_get_path (_tmp4_);
		_tmp6_ = gtk_widget_path_copy (_tmp5_);
		_gtk_widget_path_unref0 (path);
		path = _tmp6_;
	} else {
		GtkWidgetPath* _tmp7_;
		_tmp7_ = gtk_widget_path_new ();
		_gtk_widget_path_unref0 (path);
		path = _tmp7_;
	}
	_tmp8_ = path;
	_tmp9_ = widget_type;
	gtk_widget_path_append_type (_tmp8_, _tmp9_);
	_tmp10_ = object_name;
	if (_tmp10_ != NULL) {
		GtkWidgetPath* _tmp11_;
		const gchar* _tmp12_;
		_tmp11_ = path;
		_tmp12_ = object_name;
		plank_compat_gtk_widget_path_iter_set_object_name (_tmp11_, -1, _tmp12_);
	}
	_tmp13_ = path;
	_tmp14_ = first_class;
	gtk_widget_path_iter_add_class (_tmp13_, -1, _tmp14_);
	va_start (name_list, first_class);
	{
		const gchar* name;
		const gchar* _tmp15_;
		_tmp15_ = va_arg (name_list, const gchar*);
		name = _tmp15_;
		{
			gboolean _tmp16_;
			_tmp16_ = TRUE;
			while (TRUE) {
				const gchar* _tmp18_;
				GtkWidgetPath* _tmp19_;
				const gchar* _tmp20_;
				if (!_tmp16_) {
					const gchar* _tmp17_;
					_tmp17_ = va_arg (name_list, const gchar*);
					name = _tmp17_;
				}
				_tmp16_ = FALSE;
				_tmp18_ = name;
				if (!(_tmp18_ != NULL)) {
					break;
				}
				_tmp19_ = path;
				_tmp20_ = name;
				gtk_widget_path_iter_add_class (_tmp19_, -1, _tmp20_);
			}
		}
	}
	_tmp21_ = style;
	_tmp22_ = path;
	gtk_style_context_set_path (_tmp21_, _tmp22_);
	_tmp23_ = style;
	_tmp24_ = provider;
	gtk_style_context_add_provider (_tmp23_, (GtkStyleProvider*) _tmp24_, (guint) GTK_STYLE_PROVIDER_PRIORITY_SETTINGS);
	result = style;
	va_end (name_list);
	_gtk_widget_path_unref0 (path);
	return result;
}


PlankTheme* plank_theme_construct (GType object_type) {
	PlankTheme * self = NULL;
	GFile* _tmp0_;
	self = (PlankTheme*) plank_preferences_construct (object_type);
	_tmp0_ = plank_theme_get_theme_folder (PLANK_THEME_DEFAULT_NAME);
	_g_object_unref0 (self->priv->theme_folder);
	self->priv->theme_folder = _tmp0_;
	return self;
}


PlankTheme* plank_theme_construct_with_name (GType object_type, const gchar* name) {
	PlankTheme * self = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (PlankTheme*) plank_preferences_construct (object_type);
	_tmp0_ = name;
	_tmp1_ = plank_theme_get_theme_folder (_tmp0_);
	_g_object_unref0 (self->priv->theme_folder);
	self->priv->theme_folder = _tmp1_;
	return self;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void plank_theme_update_style_context (PlankTheme* self, const gchar* theme_name) {
	GtkCssProvider* provider = NULL;
	const gchar* _tmp0_;
	GtkCssProvider* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = theme_name;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		GtkCssProvider* _tmp3_;
		_tmp1_ = theme_name;
		_tmp2_ = gtk_css_provider_get_named (_tmp1_, NULL);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_g_object_unref0 (provider);
		provider = _tmp3_;
	} else {
		GtkCssProvider* _tmp4_;
		GtkCssProvider* _tmp5_;
		_tmp4_ = gtk_css_provider_get_default ();
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_g_object_unref0 (provider);
		provider = _tmp5_;
	}
	_tmp6_ = provider;
	_tmp7_ = plank_theme_create_style_context (gtk_icon_view_get_type (), NULL, _tmp6_, "iconview", GTK_STYLE_CLASS_VIEW, NULL);
	_g_object_unref0 (self->priv->style_context);
	self->priv->style_context = _tmp7_;
	_tmp8_ = self->priv->style_context;
	gtk_style_context_set_state (_tmp8_, GTK_STATE_FLAG_FOCUSED | GTK_STATE_FLAG_SELECTED);
	_g_object_unref0 (provider);
}


static void plank_theme_gtk_theme_name_changed (PlankTheme* self, GObject* o, GParamSpec* p) {
	gchar* theme_name;
	GObject* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GParamSpecBoolean* _tmp3_;
	GParamSpecBoolean* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = o;
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	theme_name = _tmp2_;
	plank_theme_update_style_context (self, theme_name);
	_tmp3_ = g_param_spec_boolean ("theme-changed", "theme-changed", "theme-changed", TRUE, G_PARAM_READABLE);
	_tmp4_ = _tmp3_;
	g_signal_emit_by_name ((GObject*) self, "notify", (GParamSpec*) _tmp4_);
	_g_param_spec_unref0 (_tmp4_);
	_g_free0 (theme_name);
}


GtkStyleContext* plank_theme_get_style_context (PlankTheme* self) {
	GtkStyleContext* result = NULL;
	GtkStyleContext* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->style_context;
	result = _tmp0_;
	return result;
}


/**
 * {@inheritDoc}
 */
static void plank_theme_real_reset_properties (PlankPreferences* base) {
	PlankTheme * self;
	PlankColor _tmp0_ = {0};
	PlankColor _tmp1_ = {0};
	PlankColor _tmp2_ = {0};
	PlankColor _tmp3_ = {0};
	self = (PlankTheme*) base;
	plank_theme_set_TopRoundness (self, 6);
	plank_theme_set_BottomRoundness (self, 6);
	plank_theme_set_LineWidth (self, 1);
	_tmp0_.red = 0.1647;
	_tmp0_.green = 0.1647;
	_tmp0_.blue = 0.1647;
	_tmp0_.alpha = 1.0;
	plank_theme_set_OuterStrokeColor (self, &_tmp0_);
	_tmp1_.red = 0.1647;
	_tmp1_.green = 0.1647;
	_tmp1_.blue = 0.1647;
	_tmp1_.alpha = 1.0;
	plank_theme_set_FillStartColor (self, &_tmp1_);
	_tmp2_.red = 0.3176;
	_tmp2_.green = 0.3176;
	_tmp2_.blue = 0.3176;
	_tmp2_.alpha = 1.0;
	plank_theme_set_FillEndColor (self, &_tmp2_);
	_tmp3_.red = 1.0;
	_tmp3_.green = 1.0;
	_tmp3_.blue = 1.0;
	_tmp3_.alpha = 1.0;
	plank_theme_set_InnerStrokeColor (self, &_tmp3_);
}


/**
 * Loads a theme for the renderer to use.
 *
 * @param type the type of theme to load
 */
void plank_theme_load (PlankTheme* self, const gchar* type) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->theme_folder;
	if (_tmp0_ == NULL) {
		plank_preferences_reset_properties ((PlankPreferences*) self);
		return;
	}
	_tmp1_ = self->priv->theme_folder;
	_tmp2_ = type;
	_tmp3_ = g_strdup_printf ("%s.theme", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_child (_tmp1_, _tmp4_);
	_tmp6_ = _tmp5_;
	plank_preferences_init_from_file ((PlankPreferences*) self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
}


/**
 * Returns the top offset.
 *
 * @return the top offset
 */
gint plank_theme_get_top_offset (PlankTheme* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_LineWidth;
	result = 2 * _tmp0_;
	return result;
}


/**
 * Returns the bottom offset.
 *
 * @return the bottom offset
 */
gint plank_theme_get_bottom_offset (PlankTheme* self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = self->priv->_BottomRoundness;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		_tmp2_ = self->priv->_LineWidth;
		_tmp0_ = 2 * _tmp2_;
	} else {
		_tmp0_ = 0;
	}
	result = _tmp0_;
	return result;
}


/**
 * Draws a background onto the surface.
 *
 * @param surface the surface to draw on
 */
void plank_theme_draw_background (PlankTheme* self, PlankSurface* surface) {
	cairo_t* cr;
	PlankSurface* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_pattern_t* gradient = NULL;
	gint width;
	PlankSurface* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint height;
	PlankSurface* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	gint bottom_offset;
	cairo_t* _tmp13_;
	gint _tmp14_;
	cairo_pattern_t* _tmp15_;
	cairo_pattern_t* _tmp16_;
	PlankColor _tmp17_;
	gdouble _tmp18_;
	PlankColor _tmp19_;
	gdouble _tmp20_;
	PlankColor _tmp21_;
	gdouble _tmp22_;
	PlankColor _tmp23_;
	gdouble _tmp24_;
	cairo_pattern_t* _tmp25_;
	PlankColor _tmp26_;
	gdouble _tmp27_;
	PlankColor _tmp28_;
	gdouble _tmp29_;
	PlankColor _tmp30_;
	gdouble _tmp31_;
	PlankColor _tmp32_;
	gdouble _tmp33_;
	cairo_t* _tmp34_;
	cairo_pattern_t* _tmp35_;
	cairo_t* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	cairo_t* _tmp47_;
	cairo_t* _tmp48_;
	PlankColor _tmp49_;
	gdouble _tmp50_;
	PlankColor _tmp51_;
	gdouble _tmp52_;
	PlankColor _tmp53_;
	gdouble _tmp54_;
	PlankColor _tmp55_;
	gdouble _tmp56_;
	cairo_t* _tmp57_;
	gint _tmp58_;
	cairo_t* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	cairo_pattern_t* _tmp64_;
	cairo_pattern_t* _tmp65_;
	PlankColor _tmp66_;
	gdouble _tmp67_;
	PlankColor _tmp68_;
	gdouble _tmp69_;
	PlankColor _tmp70_;
	gdouble _tmp71_;
	gint _tmp72_ = 0;
	gint _tmp73_;
	cairo_pattern_t* _tmp76_;
	gint _tmp77_;
	PlankColor _tmp78_;
	gdouble _tmp79_;
	PlankColor _tmp80_;
	gdouble _tmp81_;
	PlankColor _tmp82_;
	gdouble _tmp83_;
	gint _tmp84_ = 0;
	gint _tmp85_;
	cairo_pattern_t* _tmp88_;
	gint _tmp89_;
	PlankColor _tmp90_;
	gdouble _tmp91_;
	PlankColor _tmp92_;
	gdouble _tmp93_;
	PlankColor _tmp94_;
	gdouble _tmp95_;
	cairo_pattern_t* _tmp96_;
	PlankColor _tmp97_;
	gdouble _tmp98_;
	PlankColor _tmp99_;
	gdouble _tmp100_;
	PlankColor _tmp101_;
	gdouble _tmp102_;
	cairo_t* _tmp103_;
	cairo_pattern_t* _tmp104_;
	cairo_t* _tmp105_;
	gint _tmp106_;
	gint _tmp107_;
	cairo_t* _tmp108_;
	cairo_t* _tmp109_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (surface != NULL);
	_tmp0_ = surface;
	_tmp1_ = plank_surface_get_Context (_tmp0_);
	_tmp2_ = _tmp1_;
	cr = _tmp2_;
	_tmp3_ = surface;
	_tmp4_ = plank_surface_get_Width (_tmp3_);
	_tmp5_ = _tmp4_;
	width = _tmp5_;
	_tmp6_ = surface;
	_tmp7_ = plank_surface_get_Height (_tmp6_);
	_tmp8_ = _tmp7_;
	height = _tmp8_;
	_tmp10_ = self->priv->_BottomRoundness;
	if (_tmp10_ > 0) {
		gint _tmp11_;
		_tmp11_ = self->priv->_LineWidth;
		_tmp9_ = _tmp11_;
	} else {
		gint _tmp12_;
		_tmp12_ = self->priv->_LineWidth;
		_tmp9_ = -_tmp12_;
	}
	bottom_offset = _tmp9_;
	_tmp13_ = cr;
	cairo_save (_tmp13_);
	_tmp14_ = height;
	_tmp15_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) _tmp14_);
	_cairo_pattern_destroy0 (gradient);
	gradient = _tmp15_;
	_tmp16_ = gradient;
	_tmp17_ = self->priv->_FillStartColor;
	_tmp18_ = _tmp17_.red;
	_tmp19_ = self->priv->_FillStartColor;
	_tmp20_ = _tmp19_.green;
	_tmp21_ = self->priv->_FillStartColor;
	_tmp22_ = _tmp21_.blue;
	_tmp23_ = self->priv->_FillStartColor;
	_tmp24_ = _tmp23_.alpha;
	cairo_pattern_add_color_stop_rgba (_tmp16_, (gdouble) 0, _tmp18_, _tmp20_, _tmp22_, _tmp24_);
	_tmp25_ = gradient;
	_tmp26_ = self->priv->_FillEndColor;
	_tmp27_ = _tmp26_.red;
	_tmp28_ = self->priv->_FillEndColor;
	_tmp29_ = _tmp28_.green;
	_tmp30_ = self->priv->_FillEndColor;
	_tmp31_ = _tmp30_.blue;
	_tmp32_ = self->priv->_FillEndColor;
	_tmp33_ = _tmp32_.alpha;
	cairo_pattern_add_color_stop_rgba (_tmp25_, (gdouble) 1, _tmp27_, _tmp29_, _tmp31_, _tmp33_);
	_tmp34_ = cr;
	_tmp35_ = gradient;
	cairo_set_source (_tmp34_, _tmp35_);
	_tmp36_ = cr;
	_tmp37_ = self->priv->_LineWidth;
	_tmp38_ = self->priv->_LineWidth;
	_tmp39_ = width;
	_tmp40_ = self->priv->_LineWidth;
	_tmp41_ = height;
	_tmp42_ = self->priv->_LineWidth;
	_tmp43_ = bottom_offset;
	_tmp44_ = self->priv->_TopRoundness;
	_tmp45_ = self->priv->_BottomRoundness;
	_tmp46_ = self->priv->_LineWidth;
	plank_theme_draw_rounded_rect (_tmp36_, _tmp37_ / 2.0, _tmp38_ / 2.0, (gdouble) (_tmp39_ - _tmp40_), (_tmp41_ - (_tmp42_ / 2.0)) - (_tmp43_ / 2.0), (gdouble) _tmp44_, (gdouble) _tmp45_, (gdouble) _tmp46_);
	_tmp47_ = cr;
	cairo_fill_preserve (_tmp47_);
	_tmp48_ = cr;
	_tmp49_ = self->priv->_OuterStrokeColor;
	_tmp50_ = _tmp49_.red;
	_tmp51_ = self->priv->_OuterStrokeColor;
	_tmp52_ = _tmp51_.green;
	_tmp53_ = self->priv->_OuterStrokeColor;
	_tmp54_ = _tmp53_.blue;
	_tmp55_ = self->priv->_OuterStrokeColor;
	_tmp56_ = _tmp55_.alpha;
	cairo_set_source_rgba (_tmp48_, _tmp50_, _tmp52_, _tmp54_, _tmp56_);
	_tmp57_ = cr;
	_tmp58_ = self->priv->_LineWidth;
	cairo_set_line_width (_tmp57_, (gdouble) _tmp58_);
	_tmp59_ = cr;
	cairo_stroke (_tmp59_);
	_tmp60_ = self->priv->_LineWidth;
	_tmp61_ = height;
	_tmp62_ = self->priv->_LineWidth;
	_tmp63_ = bottom_offset;
	_tmp64_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) (2 * _tmp60_), (gdouble) 0, (gdouble) ((_tmp61_ - (2 * _tmp62_)) - _tmp63_));
	_cairo_pattern_destroy0 (gradient);
	gradient = _tmp64_;
	_tmp65_ = gradient;
	_tmp66_ = self->priv->_InnerStrokeColor;
	_tmp67_ = _tmp66_.red;
	_tmp68_ = self->priv->_InnerStrokeColor;
	_tmp69_ = _tmp68_.green;
	_tmp70_ = self->priv->_InnerStrokeColor;
	_tmp71_ = _tmp70_.blue;
	cairo_pattern_add_color_stop_rgba (_tmp65_, (gdouble) 0, _tmp67_, _tmp69_, _tmp71_, 0.5);
	_tmp73_ = self->priv->_TopRoundness;
	if (_tmp73_ > 0) {
		gint _tmp74_;
		_tmp74_ = self->priv->_TopRoundness;
		_tmp72_ = _tmp74_;
	} else {
		gint _tmp75_;
		_tmp75_ = self->priv->_LineWidth;
		_tmp72_ = _tmp75_;
	}
	_tmp76_ = gradient;
	_tmp77_ = height;
	_tmp78_ = self->priv->_InnerStrokeColor;
	_tmp79_ = _tmp78_.red;
	_tmp80_ = self->priv->_InnerStrokeColor;
	_tmp81_ = _tmp80_.green;
	_tmp82_ = self->priv->_InnerStrokeColor;
	_tmp83_ = _tmp82_.blue;
	cairo_pattern_add_color_stop_rgba (_tmp76_, _tmp72_ / ((gdouble) _tmp77_), _tmp79_, _tmp81_, _tmp83_, 0.12);
	_tmp85_ = self->priv->_BottomRoundness;
	if (_tmp85_ > 0) {
		gint _tmp86_;
		_tmp86_ = self->priv->_BottomRoundness;
		_tmp84_ = _tmp86_;
	} else {
		gint _tmp87_;
		_tmp87_ = self->priv->_LineWidth;
		_tmp84_ = _tmp87_;
	}
	_tmp88_ = gradient;
	_tmp89_ = height;
	_tmp90_ = self->priv->_InnerStrokeColor;
	_tmp91_ = _tmp90_.red;
	_tmp92_ = self->priv->_InnerStrokeColor;
	_tmp93_ = _tmp92_.green;
	_tmp94_ = self->priv->_InnerStrokeColor;
	_tmp95_ = _tmp94_.blue;
	cairo_pattern_add_color_stop_rgba (_tmp88_, 1 - (_tmp84_ / ((gdouble) _tmp89_)), _tmp91_, _tmp93_, _tmp95_, 0.08);
	_tmp96_ = gradient;
	_tmp97_ = self->priv->_InnerStrokeColor;
	_tmp98_ = _tmp97_.red;
	_tmp99_ = self->priv->_InnerStrokeColor;
	_tmp100_ = _tmp99_.green;
	_tmp101_ = self->priv->_InnerStrokeColor;
	_tmp102_ = _tmp101_.blue;
	cairo_pattern_add_color_stop_rgba (_tmp96_, (gdouble) 1, _tmp98_, _tmp100_, _tmp102_, 0.19);
	_tmp103_ = cr;
	_tmp104_ = gradient;
	cairo_set_source (_tmp103_, _tmp104_);
	_tmp105_ = cr;
	_tmp106_ = width;
	_tmp107_ = height;
	plank_theme_draw_inner_rect (self, _tmp105_, _tmp106_, _tmp107_);
	_tmp108_ = cr;
	cairo_stroke (_tmp108_);
	_tmp109_ = cr;
	cairo_restore (_tmp109_);
	_cairo_pattern_destroy0 (gradient);
}


/**
 * Similar to draw_rounded_rect, but moves in to avoid a containing rounded rect's lines.
 *
 * @param cr the context to draw with
 * @param width the width of the rect
 * @param height the height of the rect
 */
void plank_theme_draw_inner_rect (PlankTheme* self, cairo_t* cr, gint width, gint height) {
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint bottom_offset;
	cairo_t* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp1_ = self->priv->_BottomRoundness;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		_tmp2_ = self->priv->_LineWidth;
		_tmp0_ = _tmp2_;
	} else {
		gint _tmp3_;
		_tmp3_ = self->priv->_LineWidth;
		_tmp0_ = -_tmp3_;
	}
	bottom_offset = _tmp0_;
	_tmp4_ = cr;
	_tmp5_ = self->priv->_LineWidth;
	_tmp6_ = self->priv->_LineWidth;
	_tmp7_ = width;
	_tmp8_ = self->priv->_LineWidth;
	_tmp9_ = height;
	_tmp10_ = self->priv->_LineWidth;
	_tmp11_ = self->priv->_TopRoundness;
	_tmp12_ = self->priv->_LineWidth;
	_tmp13_ = self->priv->_BottomRoundness;
	_tmp14_ = self->priv->_LineWidth;
	_tmp15_ = self->priv->_LineWidth;
	plank_theme_draw_rounded_rect (_tmp4_, (3 * _tmp5_) / 2.0, (3 * _tmp6_) / 2.0, (gdouble) (_tmp7_ - (3 * _tmp8_)), (_tmp9_ - ((3 * _tmp10_) / 2.0)) - ((3 * bottom_offset) / 2.0), (gdouble) (_tmp11_ - _tmp12_), (gdouble) (_tmp13_ - _tmp14_), (gdouble) _tmp15_);
}


/**
 * Draws a rounded rectangle.  If compositing is disabled, just draws a normal rectangle.
 *
 * @param cr the context to draw with
 * @param x the x location of the rect
 * @param y the y location of the rect
 * @param width the width of the rect
 * @param height the height of the rect
 * @param top_radius the roundedness of the top edge
 * @param bottom_radius the roundedness of the bottom edge
 * @param line_width the line-width of the rect
 */
void plank_theme_draw_rounded_rect (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gdouble top_radius, gdouble bottom_radius, gdouble line_width) {
	gdouble min_size;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	GdkScreen* _tmp10_;
	gboolean _tmp11_;
	gdouble _tmp13_;
	cairo_t* _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	cairo_t* _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	cairo_t* _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	cairo_t* _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	cairo_t* _tmp50_;
	g_return_if_fail (cr != NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = MIN (_tmp0_, _tmp1_);
	min_size = _tmp2_;
	_tmp3_ = top_radius;
	_tmp4_ = min_size;
	_tmp5_ = CLAMP (_tmp3_, 0.0, _tmp4_);
	top_radius = _tmp5_;
	_tmp6_ = bottom_radius;
	_tmp7_ = min_size;
	_tmp8_ = top_radius;
	_tmp9_ = CLAMP (_tmp6_, 0.0, _tmp7_ - _tmp8_);
	bottom_radius = _tmp9_;
	_tmp10_ = gdk_screen_get_default ();
	_tmp11_ = gdk_screen_is_composited (_tmp10_);
	if (!_tmp11_) {
		gdouble _tmp12_;
		bottom_radius = 0.0;
		_tmp12_ = bottom_radius;
		top_radius = _tmp12_;
	}
	_tmp13_ = top_radius;
	if (_tmp13_ == 0.0) {
		cairo_t* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		_tmp14_ = cr;
		_tmp15_ = x;
		_tmp16_ = line_width;
		_tmp17_ = y;
		cairo_move_to (_tmp14_, _tmp15_ - (_tmp16_ / 2.0), _tmp17_);
	} else {
		cairo_t* _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		_tmp18_ = cr;
		_tmp19_ = x;
		_tmp20_ = top_radius;
		_tmp21_ = y;
		cairo_move_to (_tmp18_, _tmp19_ + _tmp20_, _tmp21_);
	}
	_tmp22_ = cr;
	_tmp23_ = x;
	_tmp24_ = width;
	_tmp25_ = top_radius;
	_tmp26_ = y;
	_tmp27_ = top_radius;
	_tmp28_ = top_radius;
	cairo_arc (_tmp22_, (_tmp23_ + _tmp24_) - _tmp25_, _tmp26_ + _tmp27_, _tmp28_, -G_PI_2, (gdouble) 0);
	_tmp29_ = cr;
	_tmp30_ = x;
	_tmp31_ = width;
	_tmp32_ = bottom_radius;
	_tmp33_ = y;
	_tmp34_ = height;
	_tmp35_ = bottom_radius;
	_tmp36_ = bottom_radius;
	cairo_arc (_tmp29_, (_tmp30_ + _tmp31_) - _tmp32_, (_tmp33_ + _tmp34_) - _tmp35_, _tmp36_, (gdouble) 0, G_PI_2);
	_tmp37_ = cr;
	_tmp38_ = x;
	_tmp39_ = bottom_radius;
	_tmp40_ = y;
	_tmp41_ = height;
	_tmp42_ = bottom_radius;
	_tmp43_ = bottom_radius;
	cairo_arc (_tmp37_, _tmp38_ + _tmp39_, (_tmp40_ + _tmp41_) - _tmp42_, _tmp43_, G_PI_2, G_PI);
	_tmp44_ = cr;
	_tmp45_ = x;
	_tmp46_ = top_radius;
	_tmp47_ = y;
	_tmp48_ = top_radius;
	_tmp49_ = top_radius;
	cairo_arc (_tmp44_, _tmp45_ + _tmp46_, _tmp47_ + _tmp48_, _tmp49_, G_PI, -G_PI_2);
	_tmp50_ = cr;
	cairo_close_path (_tmp50_);
}


/**
 * Draws a rounded horizontal line.
 *
 * @param cr the context to draw with
 * @param x the x location of the line
 * @param y the y location of the line
 * @param width the width of the line
 * @param height the height of the line
 * @param is_round_left weather the left is round or not
 * @param is_round_right weather the right is round or not
 * @param stroke filling style of the outline
 * @param fill filling style of the inner area
 */
void plank_theme_draw_rounded_line (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gboolean is_round_left, gboolean is_round_right, cairo_pattern_t* stroke, cairo_pattern_t* fill) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gboolean _tmp10_;
	gdouble left_radius;
	gdouble _tmp12_ = 0.0;
	gboolean _tmp13_;
	gdouble right_radius;
	cairo_t* _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	cairo_t* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gboolean _tmp24_;
	cairo_t* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gboolean _tmp41_;
	cairo_t* _tmp53_;
	cairo_pattern_t* _tmp54_;
	cairo_pattern_t* _tmp58_;
	cairo_t* _tmp61_;
	g_return_if_fail (cr != NULL);
	_tmp0_ = height;
	_tmp1_ = width;
	if (_tmp0_ > _tmp1_) {
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		_tmp2_ = y;
		_tmp3_ = height;
		_tmp4_ = width;
		_tmp5_ = floor ((_tmp3_ - _tmp4_) / 2.0);
		y = _tmp2_ + _tmp5_;
		_tmp6_ = width;
		height = _tmp6_;
	}
	_tmp7_ = height;
	_tmp8_ = floor (_tmp7_ / 2.0);
	height = 2.0 * _tmp8_;
	_tmp10_ = is_round_left;
	if (_tmp10_) {
		gdouble _tmp11_;
		_tmp11_ = height;
		_tmp9_ = _tmp11_ / 2.0;
	} else {
		_tmp9_ = 0.0;
	}
	left_radius = _tmp9_;
	_tmp13_ = is_round_right;
	if (_tmp13_) {
		gdouble _tmp14_;
		_tmp14_ = height;
		_tmp12_ = _tmp14_ / 2.0;
	} else {
		_tmp12_ = 0.0;
	}
	right_radius = _tmp12_;
	_tmp15_ = cr;
	_tmp16_ = x;
	_tmp17_ = width;
	_tmp18_ = right_radius;
	_tmp19_ = y;
	cairo_move_to (_tmp15_, (_tmp16_ + _tmp17_) - _tmp18_, _tmp19_);
	_tmp20_ = cr;
	_tmp21_ = x;
	_tmp22_ = left_radius;
	_tmp23_ = y;
	cairo_line_to (_tmp20_, _tmp21_ + _tmp22_, _tmp23_);
	_tmp24_ = is_round_left;
	if (_tmp24_) {
		cairo_t* _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
		_tmp25_ = cr;
		_tmp26_ = x;
		_tmp27_ = left_radius;
		_tmp28_ = y;
		_tmp29_ = left_radius;
		_tmp30_ = left_radius;
		cairo_arc_negative (_tmp25_, _tmp26_ + _tmp27_, _tmp28_ + _tmp29_, _tmp30_, -G_PI_2, G_PI_2);
	} else {
		cairo_t* _tmp31_;
		gdouble _tmp32_;
		gdouble _tmp33_;
		gdouble _tmp34_;
		_tmp31_ = cr;
		_tmp32_ = x;
		_tmp33_ = y;
		_tmp34_ = height;
		cairo_line_to (_tmp31_, _tmp32_, _tmp33_ + _tmp34_);
	}
	_tmp35_ = cr;
	_tmp36_ = x;
	_tmp37_ = width;
	_tmp38_ = right_radius;
	_tmp39_ = y;
	_tmp40_ = height;
	cairo_line_to (_tmp35_, (_tmp36_ + _tmp37_) - _tmp38_, _tmp39_ + _tmp40_);
	_tmp41_ = is_round_right;
	if (_tmp41_) {
		cairo_t* _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
		gdouble _tmp47_;
		gdouble _tmp48_;
		_tmp42_ = cr;
		_tmp43_ = x;
		_tmp44_ = width;
		_tmp45_ = right_radius;
		_tmp46_ = y;
		_tmp47_ = right_radius;
		_tmp48_ = right_radius;
		cairo_arc_negative (_tmp42_, (_tmp43_ + _tmp44_) - _tmp45_, _tmp46_ + _tmp47_, _tmp48_, G_PI_2, -G_PI_2);
	} else {
		cairo_t* _tmp49_;
		gdouble _tmp50_;
		gdouble _tmp51_;
		gdouble _tmp52_;
		_tmp49_ = cr;
		_tmp50_ = x;
		_tmp51_ = width;
		_tmp52_ = y;
		cairo_line_to (_tmp49_, _tmp50_ + _tmp51_, _tmp52_);
	}
	_tmp53_ = cr;
	cairo_close_path (_tmp53_);
	_tmp54_ = fill;
	if (_tmp54_ != NULL) {
		cairo_t* _tmp55_;
		cairo_pattern_t* _tmp56_;
		cairo_t* _tmp57_;
		_tmp55_ = cr;
		_tmp56_ = fill;
		cairo_set_source (_tmp55_, _tmp56_);
		_tmp57_ = cr;
		cairo_fill_preserve (_tmp57_);
	}
	_tmp58_ = stroke;
	if (_tmp58_ != NULL) {
		cairo_t* _tmp59_;
		cairo_pattern_t* _tmp60_;
		_tmp59_ = cr;
		_tmp60_ = stroke;
		cairo_set_source (_tmp59_, _tmp60_);
	}
	_tmp61_ = cr;
	cairo_stroke (_tmp61_);
}


/**
 * {@inheritDoc}
 */
static void plank_theme_real_verify (PlankPreferences* base, const gchar* prop) {
	PlankTheme * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	static GQuark _tmp3_label4 = 0;
	static GQuark _tmp3_label5 = 0;
	static GQuark _tmp3_label6 = 0;
	self = (PlankTheme*) base;
	g_return_if_fail (prop != NULL);
	_tmp0_ = prop;
	PLANK_PREFERENCES_CLASS (plank_theme_parent_class)->verify (G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_PREFERENCES, PlankPreferences), _tmp0_);
	_tmp1_ = prop;
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("TopRoundness")))) {
		switch (0) {
			default:
			{
				gint _tmp5_;
				_tmp5_ = self->priv->_TopRoundness;
				if (_tmp5_ < 0) {
					plank_theme_set_TopRoundness (self, 0);
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("BottomRoundness")))) {
		switch (0) {
			default:
			{
				gint _tmp6_;
				_tmp6_ = self->priv->_BottomRoundness;
				if (_tmp6_ < 0) {
					plank_theme_set_BottomRoundness (self, 0);
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("LineWidth")))) {
		switch (0) {
			default:
			{
				gint _tmp7_;
				_tmp7_ = self->priv->_LineWidth;
				if (_tmp7_ < 0) {
					plank_theme_set_LineWidth (self, 0);
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("OuterStrokeColor")))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label4) ? _tmp3_label4 : (_tmp3_label4 = g_quark_from_static_string ("FillStartColor")))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label5) ? _tmp3_label5 : (_tmp3_label5 = g_quark_from_static_string ("FillEndColor")))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label6) ? _tmp3_label6 : (_tmp3_label6 = g_quark_from_static_string ("InnerStrokeColor")))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}


/**
 * Get a sorted array of all available theme-names
 *
 * @return array containing all available theme-names
 */
gchar** plank_theme_get_theme_list (int* result_length1) {
	gchar** result = NULL;
	GeeHashSet* list;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeArrayList* _result_;
	GeeArrayList* _tmp35_;
	GeeHashSet* _tmp36_;
	gint _tmp37_;
	gpointer* _tmp38_;
	gchar** _tmp39_;
	gint _tmp39__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	list = _tmp0_;
	_tmp1_ = list;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, PLANK_THEME_DEFAULT_NAME);
	_tmp2_ = list;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, PLANK_THEME_GTK_THEME_NAME);
	{
		GFileEnumerator* enumerator;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileInfo* info = NULL;
		_tmp3_ = plank_paths_get_AppThemeFolder ();
		_tmp4_ = _tmp3_;
		_tmp5_ = g_file_enumerate_children (_tmp4_, "standard::name,standard::type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		enumerator = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch23_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp6_;
			GFileEnumerator* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFileInfo* _tmp12_;
			gboolean _tmp13_;
			GeeHashSet* _tmp16_;
			GFileInfo* _tmp17_;
			const gchar* _tmp18_;
			_tmp7_ = enumerator;
			_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error_);
			_tmp6_ = _tmp8_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				goto __catch23_g_error;
			}
			_tmp9_ = _tmp6_;
			_tmp6_ = NULL;
			_g_object_unref0 (info);
			info = _tmp9_;
			_tmp10_ = info;
			if (!(_tmp10_ != NULL)) {
				_g_object_unref0 (_tmp6_);
				break;
			}
			_tmp12_ = info;
			_tmp13_ = g_file_info_get_is_hidden (_tmp12_);
			if (_tmp13_) {
				_tmp11_ = TRUE;
			} else {
				GFileInfo* _tmp14_;
				GFileType _tmp15_;
				_tmp14_ = info;
				_tmp15_ = g_file_info_get_file_type (_tmp14_);
				_tmp11_ = _tmp15_ != G_FILE_TYPE_DIRECTORY;
			}
			if (_tmp11_) {
				_g_object_unref0 (_tmp6_);
				continue;
			}
			_tmp16_ = list;
			_tmp17_ = info;
			_tmp18_ = g_file_info_get_name (_tmp17_);
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp18_);
			_g_object_unref0 (_tmp6_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
	}
	goto __finally23;
	__catch23_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally23:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		GFileEnumerator* enumerator;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFileEnumerator* _tmp21_;
		GFileInfo* info = NULL;
		_tmp19_ = plank_paths_get_ThemeFolder ();
		_tmp20_ = _tmp19_;
		_tmp21_ = g_file_enumerate_children (_tmp20_, "standard::name,standard::type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		enumerator = _tmp21_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch24_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp22_;
			GFileEnumerator* _tmp23_;
			GFileInfo* _tmp24_;
			GFileInfo* _tmp25_;
			GFileInfo* _tmp26_;
			gboolean _tmp27_ = FALSE;
			GFileInfo* _tmp28_;
			gboolean _tmp29_;
			GeeHashSet* _tmp32_;
			GFileInfo* _tmp33_;
			const gchar* _tmp34_;
			_tmp23_ = enumerator;
			_tmp24_ = g_file_enumerator_next_file (_tmp23_, NULL, &_inner_error_);
			_tmp22_ = _tmp24_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				goto __catch24_g_error;
			}
			_tmp25_ = _tmp22_;
			_tmp22_ = NULL;
			_g_object_unref0 (info);
			info = _tmp25_;
			_tmp26_ = info;
			if (!(_tmp26_ != NULL)) {
				_g_object_unref0 (_tmp22_);
				break;
			}
			_tmp28_ = info;
			_tmp29_ = g_file_info_get_is_hidden (_tmp28_);
			if (_tmp29_) {
				_tmp27_ = TRUE;
			} else {
				GFileInfo* _tmp30_;
				GFileType _tmp31_;
				_tmp30_ = info;
				_tmp31_ = g_file_info_get_file_type (_tmp30_);
				_tmp27_ = _tmp31_ != G_FILE_TYPE_DIRECTORY;
			}
			if (_tmp27_) {
				_g_object_unref0 (_tmp22_);
				continue;
			}
			_tmp32_ = list;
			_tmp33_ = info;
			_tmp34_ = g_file_info_get_name (_tmp33_);
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp34_);
			_g_object_unref0 (_tmp22_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
	}
	goto __finally24;
	__catch24_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally24:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp35_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_result_ = _tmp35_;
	_tmp36_ = list;
	gee_array_list_add_all (_result_, (GeeCollection*) _tmp36_);
	gee_list_sort ((GeeList*) _result_, NULL, NULL, NULL);
	_tmp38_ = gee_collection_to_array ((GeeCollection*) _result_, &_tmp37_);
	_tmp39_ = _tmp38_;
	_tmp39__length1 = _tmp37_;
	if (result_length1) {
		*result_length1 = _tmp39__length1;
	}
	result = _tmp39_;
	_g_object_unref0 (_result_);
	_g_object_unref0 (list);
	return result;
}


/**
 * Try to get an already existing folder located in the
 * themes folder while prefering the user's themes folder.
 * If there is no folder found we fallback to the "Default" theme.
 * If even that folder doesn't exist return NULL (and use built-in defaults)
 *
 * @param name the basename of the folder
 * @return {@link GLib.File} the folder of the theme or NULL
 */
GFile* plank_theme_get_theme_folder (const gchar* name) {
	GFile* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	GFile* folder = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GFile* _tmp9_;
	gboolean _tmp10_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	gboolean _tmp17_ = FALSE;
	GFile* _tmp18_;
	gboolean _tmp19_;
	const gchar* _tmp22_;
	GFile* _tmp23_;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	if (g_strcmp0 (_tmp0_, PLANK_THEME_DEFAULT_NAME) == 0) {
		GFile* _tmp1_;
		_tmp1_ = plank_theme_get_default_theme_folder ();
		result = _tmp1_;
		return result;
	}
	_tmp2_ = name;
	if (g_strcmp0 (_tmp2_, PLANK_THEME_GTK_THEME_NAME) == 0) {
		GFile* _tmp3_;
		_tmp3_ = plank_theme_get_gtk_theme_folder ();
		result = _tmp3_;
		return result;
	}
	_tmp4_ = plank_paths_get_AppThemeFolder ();
	_tmp5_ = _tmp4_;
	_tmp6_ = name;
	_tmp7_ = g_file_get_child (_tmp5_, _tmp6_);
	_g_object_unref0 (folder);
	folder = _tmp7_;
	_tmp9_ = folder;
	_tmp10_ = g_file_query_exists (_tmp9_, NULL);
	if (_tmp10_) {
		GFile* _tmp11_;
		GFileType _tmp12_;
		_tmp11_ = folder;
		_tmp12_ = g_file_query_file_type (_tmp11_, G_FILE_QUERY_INFO_NONE, NULL);
		_tmp8_ = _tmp12_ == G_FILE_TYPE_DIRECTORY;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		result = folder;
		return result;
	}
	_tmp13_ = plank_paths_get_ThemeFolder ();
	_tmp14_ = _tmp13_;
	_tmp15_ = name;
	_tmp16_ = g_file_get_child (_tmp14_, _tmp15_);
	_g_object_unref0 (folder);
	folder = _tmp16_;
	_tmp18_ = folder;
	_tmp19_ = g_file_query_exists (_tmp18_, NULL);
	if (_tmp19_) {
		GFile* _tmp20_;
		GFileType _tmp21_;
		_tmp20_ = folder;
		_tmp21_ = g_file_query_file_type (_tmp20_, G_FILE_QUERY_INFO_NONE, NULL);
		_tmp17_ = _tmp21_ == G_FILE_TYPE_DIRECTORY;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		result = folder;
		return result;
	}
	_tmp22_ = name;
	g_warning ("Theme.vala:450: %s not found, falling back to %s.", _tmp22_, PLANK_THEME_DEFAULT_NAME);
	_tmp23_ = plank_theme_get_default_theme_folder ();
	result = _tmp23_;
	_g_object_unref0 (folder);
	return result;
}


static GFile* plank_theme_get_default_theme_folder (void) {
	GFile* result = NULL;
	GFile* folder = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	gboolean _tmp5_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	_tmp0_ = plank_paths_get_ThemeFolder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_child (_tmp1_, PLANK_THEME_DEFAULT_NAME);
	_g_object_unref0 (folder);
	folder = _tmp2_;
	_tmp4_ = folder;
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
	if (_tmp5_) {
		GFile* _tmp6_;
		GFileType _tmp7_;
		_tmp6_ = folder;
		_tmp7_ = g_file_query_file_type (_tmp6_, G_FILE_QUERY_INFO_NONE, NULL);
		_tmp3_ = _tmp7_ == G_FILE_TYPE_DIRECTORY;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = folder;
		return result;
	}
	_tmp8_ = folder;
	_tmp9_ = g_file_get_path (_tmp8_);
	_tmp10_ = _tmp9_;
	g_warning ("Theme.vala:465: %s is not a folder fallback to the built-in defaults!", _tmp10_);
	_g_free0 (_tmp10_);
	result = NULL;
	_g_object_unref0 (folder);
	return result;
}


static GFile* plank_theme_get_gtk_theme_folder (void) {
	GFile* result = NULL;
	GFile* folder = NULL;
	const gchar* exec_name;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* name;
	GtkSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gboolean _tmp12_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GFile* _tmp27_;
	GFile* _tmp28_;
	gboolean _tmp29_;
	const gchar* _tmp62_;
	_tmp0_ = plank_paths_get_AppName ();
	_tmp1_ = _tmp0_;
	exec_name = _tmp1_;
	_tmp2_ = gtk_settings_get_default ();
	g_object_get (_tmp2_, "gtk-theme-name", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	name = _tmp4_;
	_tmp5_ = plank_paths_get_DataHomeFolder ();
	_tmp6_ = _tmp5_;
	_tmp7_ = name;
	_tmp8_ = g_strdup_printf ("themes/%s", _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_file_get_child (_tmp6_, _tmp9_);
	_g_object_unref0 (folder);
	folder = _tmp10_;
	_g_free0 (_tmp9_);
	_tmp11_ = folder;
	_tmp12_ = g_file_query_exists (_tmp11_, NULL);
	if (_tmp12_) {
		GFile* _tmp13_;
		const gchar* _tmp14_;
		GFile* _tmp15_;
		gboolean _tmp16_ = FALSE;
		GFile* _tmp17_;
		gboolean _tmp18_;
		const gchar* _tmp21_;
		_tmp13_ = folder;
		_tmp14_ = exec_name;
		_tmp15_ = g_file_get_child (_tmp13_, _tmp14_);
		_g_object_unref0 (folder);
		folder = _tmp15_;
		_tmp17_ = folder;
		_tmp18_ = g_file_query_exists (_tmp17_, NULL);
		if (_tmp18_) {
			GFile* _tmp19_;
			GFileType _tmp20_;
			_tmp19_ = folder;
			_tmp20_ = g_file_query_file_type (_tmp19_, G_FILE_QUERY_INFO_NONE, NULL);
			_tmp16_ = _tmp20_ == G_FILE_TYPE_DIRECTORY;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			result = folder;
			_g_free0 (name);
			return result;
		}
		_tmp21_ = name;
		g_warning ("Theme.vala:484: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp21_);
		result = NULL;
		_g_free0 (name);
		_g_object_unref0 (folder);
		return result;
	}
	_tmp22_ = plank_paths_get_HomeFolder ();
	_tmp23_ = _tmp22_;
	_tmp24_ = name;
	_tmp25_ = g_strdup_printf (".themes/%s", _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = g_file_get_child (_tmp23_, _tmp26_);
	_g_object_unref0 (folder);
	folder = _tmp27_;
	_g_free0 (_tmp26_);
	_tmp28_ = folder;
	_tmp29_ = g_file_query_exists (_tmp28_, NULL);
	if (_tmp29_) {
		GFile* _tmp30_;
		const gchar* _tmp31_;
		GFile* _tmp32_;
		gboolean _tmp33_ = FALSE;
		GFile* _tmp34_;
		gboolean _tmp35_;
		const gchar* _tmp38_;
		_tmp30_ = folder;
		_tmp31_ = exec_name;
		_tmp32_ = g_file_get_child (_tmp30_, _tmp31_);
		_g_object_unref0 (folder);
		folder = _tmp32_;
		_tmp34_ = folder;
		_tmp35_ = g_file_query_exists (_tmp34_, NULL);
		if (_tmp35_) {
			GFile* _tmp36_;
			GFileType _tmp37_;
			_tmp36_ = folder;
			_tmp37_ = g_file_query_file_type (_tmp36_, G_FILE_QUERY_INFO_NONE, NULL);
			_tmp33_ = _tmp37_ == G_FILE_TYPE_DIRECTORY;
		} else {
			_tmp33_ = FALSE;
		}
		if (_tmp33_) {
			result = folder;
			_g_free0 (name);
			return result;
		}
		_tmp38_ = name;
		g_warning ("Theme.vala:496: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp38_);
		result = NULL;
		_g_free0 (name);
		_g_object_unref0 (folder);
		return result;
	}
	{
		GeeArrayList* _datafolder_list;
		GeeArrayList* _tmp39_;
		GeeArrayList* _tmp40_;
		GeeArrayList* _tmp41_;
		gint _datafolder_size;
		GeeArrayList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _datafolder_index;
		_tmp39_ = plank_paths_get_DataDirFolders ();
		_tmp40_ = _tmp39_;
		_tmp41_ = _g_object_ref0 (_tmp40_);
		_datafolder_list = _tmp41_;
		_tmp42_ = _datafolder_list;
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_datafolder_size = _tmp44_;
		_datafolder_index = -1;
		while (TRUE) {
			gint _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			GFile* datafolder;
			GeeArrayList* _tmp48_;
			gint _tmp49_;
			gpointer _tmp50_;
			GFile* _tmp51_;
			const gchar* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			GFile* _tmp56_;
			gboolean _tmp57_ = FALSE;
			GFile* _tmp58_;
			gboolean _tmp59_;
			_tmp45_ = _datafolder_index;
			_datafolder_index = _tmp45_ + 1;
			_tmp46_ = _datafolder_index;
			_tmp47_ = _datafolder_size;
			if (!(_tmp46_ < _tmp47_)) {
				break;
			}
			_tmp48_ = _datafolder_list;
			_tmp49_ = _datafolder_index;
			_tmp50_ = gee_abstract_list_get ((GeeAbstractList*) _tmp48_, _tmp49_);
			datafolder = (GFile*) _tmp50_;
			_tmp51_ = datafolder;
			_tmp52_ = name;
			_tmp53_ = exec_name;
			_tmp54_ = g_strdup_printf ("themes/%s/%s", _tmp52_, _tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = g_file_get_child (_tmp51_, _tmp55_);
			_g_object_unref0 (folder);
			folder = _tmp56_;
			_g_free0 (_tmp55_);
			_tmp58_ = folder;
			_tmp59_ = g_file_query_exists (_tmp58_, NULL);
			if (_tmp59_) {
				GFile* _tmp60_;
				GFileType _tmp61_;
				_tmp60_ = folder;
				_tmp61_ = g_file_query_file_type (_tmp60_, G_FILE_QUERY_INFO_NONE, NULL);
				_tmp57_ = _tmp61_ == G_FILE_TYPE_DIRECTORY;
			} else {
				_tmp57_ = FALSE;
			}
			if (_tmp57_) {
				result = folder;
				_g_object_unref0 (datafolder);
				_g_object_unref0 (_datafolder_list);
				_g_free0 (name);
				return result;
			}
			_g_object_unref0 (datafolder);
		}
		_g_object_unref0 (_datafolder_list);
	}
	_tmp62_ = name;
	g_warning ("Theme.vala:508: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp62_);
	result = NULL;
	_g_free0 (name);
	_g_object_unref0 (folder);
	return result;
}


gint plank_theme_get_TopRoundness (PlankTheme* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_TopRoundness;
	result = _tmp0_;
	return result;
}


void plank_theme_set_TopRoundness (PlankTheme* self, gint value) {
	g_return_if_fail (self != NULL);
	if (plank_theme_get_TopRoundness (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_TopRoundness = _tmp0_;
		g_object_notify ((GObject *) self, "TopRoundness");
	}
}


gint plank_theme_get_BottomRoundness (PlankTheme* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_BottomRoundness;
	result = _tmp0_;
	return result;
}


void plank_theme_set_BottomRoundness (PlankTheme* self, gint value) {
	g_return_if_fail (self != NULL);
	if (plank_theme_get_BottomRoundness (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_BottomRoundness = _tmp0_;
		g_object_notify ((GObject *) self, "BottomRoundness");
	}
}


gint plank_theme_get_LineWidth (PlankTheme* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_LineWidth;
	result = _tmp0_;
	return result;
}


void plank_theme_set_LineWidth (PlankTheme* self, gint value) {
	g_return_if_fail (self != NULL);
	if (plank_theme_get_LineWidth (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_LineWidth = _tmp0_;
		g_object_notify ((GObject *) self, "LineWidth");
	}
}


void plank_theme_get_OuterStrokeColor (PlankTheme* self, PlankColor * result) {
	PlankColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_OuterStrokeColor;
	*result = _tmp0_;
	return;
}


static gboolean _gdk_rgba_equal (const GdkRGBA * s1, const GdkRGBA * s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->red != s2->red) {
		return FALSE;
	}
	if (s1->green != s2->green) {
		return FALSE;
	}
	if (s1->blue != s2->blue) {
		return FALSE;
	}
	if (s1->alpha != s2->alpha) {
		return FALSE;
	}
	return TRUE;
}


void plank_theme_set_OuterStrokeColor (PlankTheme* self, PlankColor * value) {
	PlankColor old_value;
	g_return_if_fail (self != NULL);
	if (_gdk_rgba_equal (value, (plank_theme_get_OuterStrokeColor (self, &old_value), &old_value)) != TRUE) {
		PlankColor _tmp0_;
		_tmp0_ = *value;
		self->priv->_OuterStrokeColor = _tmp0_;
		g_object_notify ((GObject *) self, "OuterStrokeColor");
	}
}


void plank_theme_get_FillStartColor (PlankTheme* self, PlankColor * result) {
	PlankColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_FillStartColor;
	*result = _tmp0_;
	return;
}


void plank_theme_set_FillStartColor (PlankTheme* self, PlankColor * value) {
	PlankColor old_value;
	g_return_if_fail (self != NULL);
	if (_gdk_rgba_equal (value, (plank_theme_get_FillStartColor (self, &old_value), &old_value)) != TRUE) {
		PlankColor _tmp0_;
		_tmp0_ = *value;
		self->priv->_FillStartColor = _tmp0_;
		g_object_notify ((GObject *) self, "FillStartColor");
	}
}


void plank_theme_get_FillEndColor (PlankTheme* self, PlankColor * result) {
	PlankColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_FillEndColor;
	*result = _tmp0_;
	return;
}


void plank_theme_set_FillEndColor (PlankTheme* self, PlankColor * value) {
	PlankColor old_value;
	g_return_if_fail (self != NULL);
	if (_gdk_rgba_equal (value, (plank_theme_get_FillEndColor (self, &old_value), &old_value)) != TRUE) {
		PlankColor _tmp0_;
		_tmp0_ = *value;
		self->priv->_FillEndColor = _tmp0_;
		g_object_notify ((GObject *) self, "FillEndColor");
	}
}


void plank_theme_get_InnerStrokeColor (PlankTheme* self, PlankColor * result) {
	PlankColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_InnerStrokeColor;
	*result = _tmp0_;
	return;
}


void plank_theme_set_InnerStrokeColor (PlankTheme* self, PlankColor * value) {
	PlankColor old_value;
	g_return_if_fail (self != NULL);
	if (_gdk_rgba_equal (value, (plank_theme_get_InnerStrokeColor (self, &old_value), &old_value)) != TRUE) {
		PlankColor _tmp0_;
		_tmp0_ = *value;
		self->priv->_InnerStrokeColor = _tmp0_;
		g_object_notify ((GObject *) self, "InnerStrokeColor");
	}
}


static void _plank_theme_gtk_theme_name_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	plank_theme_gtk_theme_name_changed ((PlankTheme*) self, _sender, pspec);
}


static GObject * plank_theme_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankTheme * self;
	GtkSettings* gtk_settings;
	GtkSettings* _tmp0_;
	gchar* theme_name;
	GtkSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkSettings* _tmp5_;
	parent_class = G_OBJECT_CLASS (plank_theme_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_THEME, PlankTheme);
	_tmp0_ = gtk_settings_get_default ();
	gtk_settings = _tmp0_;
	_tmp1_ = gtk_settings;
	g_object_get (_tmp1_, "gtk-theme-name", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	theme_name = _tmp3_;
	_tmp4_ = theme_name;
	plank_theme_update_style_context (self, _tmp4_);
	_tmp5_ = gtk_settings;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::gtk-theme-name", (GCallback) _plank_theme_gtk_theme_name_changed_g_object_notify, self, 0);
	_g_free0 (theme_name);
	return obj;
}


static void plank_theme_class_init (PlankThemeClass * klass) {
	plank_theme_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankThemePrivate));
	((PlankPreferencesClass *) klass)->reset_properties = (void (*) (PlankPreferences *)) plank_theme_real_reset_properties;
	((PlankPreferencesClass *) klass)->verify = (void (*) (PlankPreferences *, const gchar*)) plank_theme_real_verify;
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_theme_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_theme_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_theme_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_theme_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_TOP_ROUNDNESS, g_param_spec_int ("TopRoundness", "top-roundness", "The roundness of the top corners.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_BOTTOM_ROUNDNESS, g_param_spec_int ("BottomRoundness", "bottom-roundness", "The roundness of the bottom corners.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_LINE_WIDTH, g_param_spec_int ("LineWidth", "line-width", "The thickness (in pixels) of lines drawn.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_OUTER_STROKE_COLOR, g_param_spec_boxed ("OuterStrokeColor", "outer-stroke-color", "The color (RGBA) of the outer stroke.", PLANK_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_FILL_START_COLOR, g_param_spec_boxed ("FillStartColor", "fill-start-color", "The starting color (RGBA) of the fill gradient.", PLANK_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_FILL_END_COLOR, g_param_spec_boxed ("FillEndColor", "fill-end-color", "The ending color (RGBA) of the fill gradient.", PLANK_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_INNER_STROKE_COLOR, g_param_spec_boxed ("InnerStrokeColor", "inner-stroke-color", "The color (RGBA) of the inner stroke.", PLANK_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void plank_theme_instance_init (PlankTheme * self) {
	self->priv = PLANK_THEME_GET_PRIVATE (self);
}


static void plank_theme_finalize (GObject * obj) {
	PlankTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_THEME, PlankTheme);
	_g_object_unref0 (self->priv->theme_folder);
	_g_object_unref0 (self->priv->style_context);
	G_OBJECT_CLASS (plank_theme_parent_class)->finalize (obj);
}


/**
 * A themed renderer for windows.
 */
GType plank_theme_get_type (void) {
	static volatile gsize plank_theme_type_id__volatile = 0;
	if (g_once_init_enter (&plank_theme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankTheme), 0, (GInstanceInitFunc) plank_theme_instance_init, NULL };
		GType plank_theme_type_id;
		plank_theme_type_id = g_type_register_static (PLANK_TYPE_PREFERENCES, "PlankTheme", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_theme_type_id__volatile, plank_theme_type_id);
	}
	return plank_theme_type_id__volatile;
}


static void _vala_plank_theme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_THEME, PlankTheme);
	switch (property_id) {
		case PLANK_THEME_TOP_ROUNDNESS:
		g_value_set_int (value, plank_theme_get_TopRoundness (self));
		break;
		case PLANK_THEME_BOTTOM_ROUNDNESS:
		g_value_set_int (value, plank_theme_get_BottomRoundness (self));
		break;
		case PLANK_THEME_LINE_WIDTH:
		g_value_set_int (value, plank_theme_get_LineWidth (self));
		break;
		case PLANK_THEME_OUTER_STROKE_COLOR:
		{
			PlankColor boxed;
			plank_theme_get_OuterStrokeColor (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case PLANK_THEME_FILL_START_COLOR:
		{
			PlankColor boxed;
			plank_theme_get_FillStartColor (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case PLANK_THEME_FILL_END_COLOR:
		{
			PlankColor boxed;
			plank_theme_get_FillEndColor (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case PLANK_THEME_INNER_STROKE_COLOR:
		{
			PlankColor boxed;
			plank_theme_get_InnerStrokeColor (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_theme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_THEME, PlankTheme);
	switch (property_id) {
		case PLANK_THEME_TOP_ROUNDNESS:
		plank_theme_set_TopRoundness (self, g_value_get_int (value));
		break;
		case PLANK_THEME_BOTTOM_ROUNDNESS:
		plank_theme_set_BottomRoundness (self, g_value_get_int (value));
		break;
		case PLANK_THEME_LINE_WIDTH:
		plank_theme_set_LineWidth (self, g_value_get_int (value));
		break;
		case PLANK_THEME_OUTER_STROKE_COLOR:
		plank_theme_set_OuterStrokeColor (self, g_value_get_boxed (value));
		break;
		case PLANK_THEME_FILL_START_COLOR:
		plank_theme_set_FillStartColor (self, g_value_get_boxed (value));
		break;
		case PLANK_THEME_FILL_END_COLOR:
		plank_theme_set_FillEndColor (self, g_value_get_boxed (value));
		break;
		case PLANK_THEME_INNER_STROKE_COLOR:
		plank_theme_set_InnerStrokeColor (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



