/* DockElement.c generated by valac 0.36.2, the Vala compiler
 * generated from DockElement.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define PLANK_TYPE_DOCK_ELEMENT (plank_dock_element_get_type ())
#define PLANK_DOCK_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DOCK_ELEMENT, PlankDockElement))
#define PLANK_DOCK_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DOCK_ELEMENT, PlankDockElementClass))
#define PLANK_IS_DOCK_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DOCK_ELEMENT))
#define PLANK_IS_DOCK_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DOCK_ELEMENT))
#define PLANK_DOCK_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DOCK_ELEMENT, PlankDockElementClass))

typedef struct _PlankDockElement PlankDockElement;
typedef struct _PlankDockElementClass PlankDockElementClass;
typedef struct _PlankDockElementPrivate PlankDockElementPrivate;

#define PLANK_TYPE_POPUP_BUTTON (plank_popup_button_get_type ())

#define PLANK_TYPE_ANIMATION_TYPE (plank_animation_type_get_type ())

#define PLANK_TYPE_DOCK_CONTAINER (plank_dock_container_get_type ())
#define PLANK_DOCK_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer))
#define PLANK_DOCK_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DOCK_CONTAINER, PlankDockContainerClass))
#define PLANK_IS_DOCK_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DOCK_CONTAINER))
#define PLANK_IS_DOCK_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DOCK_CONTAINER))
#define PLANK_DOCK_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DOCK_CONTAINER, PlankDockContainerClass))

typedef struct _PlankDockContainer PlankDockContainer;
typedef struct _PlankDockContainerClass PlankDockContainerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define PLANK_TYPE_DOCK_CONTROLLER (plank_dock_controller_get_type ())
#define PLANK_DOCK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DOCK_CONTROLLER, PlankDockController))
#define PLANK_DOCK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DOCK_CONTROLLER, PlankDockControllerClass))
#define PLANK_IS_DOCK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DOCK_CONTROLLER))
#define PLANK_IS_DOCK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DOCK_CONTROLLER))
#define PLANK_DOCK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DOCK_CONTROLLER, PlankDockControllerClass))

typedef struct _PlankDockController PlankDockController;
typedef struct _PlankDockControllerClass PlankDockControllerClass;
enum  {
	PLANK_DOCK_ELEMENT_NEEDS_REDRAW_SIGNAL,
	PLANK_DOCK_ELEMENT_LAST_SIGNAL
};
static guint plank_dock_element_signals[PLANK_DOCK_ELEMENT_LAST_SIGNAL] = {0};

typedef enum  {
	PLANK_POPUP_BUTTON_NONE = 1 << 0,
	PLANK_POPUP_BUTTON_LEFT = 1 << 1,
	PLANK_POPUP_BUTTON_MIDDLE = 1 << 2,
	PLANK_POPUP_BUTTON_RIGHT = 1 << 3
} PlankPopupButton;

typedef enum  {
	PLANK_ANIMATION_TYPE_NONE,
	PLANK_ANIMATION_TYPE_BOUNCE,
	PLANK_ANIMATION_TYPE_DARKEN,
	PLANK_ANIMATION_TYPE_LIGHTEN
} PlankAnimationType;

struct _PlankDockElement {
	GObject parent_instance;
	PlankDockElementPrivate * priv;
};

struct _PlankDockElementClass {
	GObjectClass parent_class;
	PlankAnimationType (*on_clicked) (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time);
	PlankAnimationType (*on_hovered) (PlankDockElement* self);
	PlankAnimationType (*on_scrolled) (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time);
	GeeArrayList* (*get_menu_items) (PlankDockElement* self);
	gchar* (*get_drop_text) (PlankDockElement* self);
	gboolean (*can_be_removed) (PlankDockElement* self);
	gboolean (*can_accept_drop) (PlankDockElement* self, GeeArrayList* uris);
	gboolean (*accept_drop) (PlankDockElement* self, GeeArrayList* uris);
	gchar* (*unique_id) (PlankDockElement* self);
	void (*reset_buffers) (PlankDockElement* self);
};

struct _PlankDockElementPrivate {
	PlankDockContainer* _Container;
	gchar* _Text;
	gboolean _IsAttached;
	gboolean _IsVisible;
	PlankPopupButton _Button;
	PlankAnimationType _ClickedAnimation;
	PlankAnimationType _HoveredAnimation;
	PlankAnimationType _ScrolledAnimation;
	gint64 _AddTime;
	gint64 _RemoveTime;
	gint64 _LastClicked;
	gint64 _LastHovered;
	gint64 _LastScrolled;
	gint64 _LastUrgent;
	gint64 _LastActive;
	gint64 _LastMove;
	gint64 _LastValid;
};


static gpointer plank_dock_element_parent_class = NULL;

GType plank_dock_element_get_type (void) G_GNUC_CONST;
GType plank_popup_button_get_type (void) G_GNUC_CONST;
GType plank_animation_type_get_type (void) G_GNUC_CONST;
GType plank_dock_container_get_type (void) G_GNUC_CONST;
#define PLANK_DOCK_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_DOCK_ELEMENT, PlankDockElementPrivate))
enum  {
	PLANK_DOCK_ELEMENT_DUMMY_PROPERTY,
	PLANK_DOCK_ELEMENT_CONTAINER,
	PLANK_DOCK_ELEMENT_TEXT,
	PLANK_DOCK_ELEMENT_IS_ATTACHED,
	PLANK_DOCK_ELEMENT_IS_VISIBLE,
	PLANK_DOCK_ELEMENT_BUTTON,
	PLANK_DOCK_ELEMENT_CLICKED_ANIMATION,
	PLANK_DOCK_ELEMENT_HOVERED_ANIMATION,
	PLANK_DOCK_ELEMENT_SCROLLED_ANIMATION,
	PLANK_DOCK_ELEMENT_ADD_TIME,
	PLANK_DOCK_ELEMENT_REMOVE_TIME,
	PLANK_DOCK_ELEMENT_LAST_CLICKED,
	PLANK_DOCK_ELEMENT_LAST_HOVERED,
	PLANK_DOCK_ELEMENT_LAST_SCROLLED,
	PLANK_DOCK_ELEMENT_LAST_URGENT,
	PLANK_DOCK_ELEMENT_LAST_ACTIVE,
	PLANK_DOCK_ELEMENT_LAST_MOVE,
	PLANK_DOCK_ELEMENT_LAST_VALID
};
void plank_dock_element_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time);
PlankAnimationType plank_dock_element_on_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time);
void plank_dock_element_set_ClickedAnimation (PlankDockElement* self, PlankAnimationType value);
void plank_dock_element_set_LastClicked (PlankDockElement* self, gint64 value);
static PlankAnimationType plank_dock_element_real_on_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time);
void plank_dock_element_hovered (PlankDockElement* self);
PlankAnimationType plank_dock_element_on_hovered (PlankDockElement* self);
void plank_dock_element_set_HoveredAnimation (PlankDockElement* self, PlankAnimationType value);
void plank_dock_element_set_LastHovered (PlankDockElement* self, gint64 value);
static PlankAnimationType plank_dock_element_real_on_hovered (PlankDockElement* self);
void plank_dock_element_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time);
PlankAnimationType plank_dock_element_on_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time);
void plank_dock_element_set_ScrolledAnimation (PlankDockElement* self, PlankAnimationType value);
static PlankAnimationType plank_dock_element_real_on_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time);
void plank_dock_element_set_LastScrolled (PlankDockElement* self, gint64 value);
GType plank_dock_controller_get_type (void) G_GNUC_CONST;
PlankDockController* plank_dock_element_get_dock (PlankDockElement* self);
PlankDockContainer* plank_dock_element_get_Container (PlankDockElement* self);
GeeArrayList* plank_dock_element_get_menu_items (PlankDockElement* self);
static GeeArrayList* plank_dock_element_real_get_menu_items (PlankDockElement* self);
gchar* plank_dock_element_get_drop_text (PlankDockElement* self);
static gchar* plank_dock_element_real_get_drop_text (PlankDockElement* self);
gboolean plank_dock_element_can_be_removed (PlankDockElement* self);
static gboolean plank_dock_element_real_can_be_removed (PlankDockElement* self);
gboolean plank_dock_element_can_accept_drop (PlankDockElement* self, GeeArrayList* uris);
static gboolean plank_dock_element_real_can_accept_drop (PlankDockElement* self, GeeArrayList* uris);
gboolean plank_dock_element_accept_drop (PlankDockElement* self, GeeArrayList* uris);
static gboolean plank_dock_element_real_accept_drop (PlankDockElement* self, GeeArrayList* uris);
gchar* plank_dock_element_unique_id (PlankDockElement* self);
static gchar* plank_dock_element_real_unique_id (PlankDockElement* self);
gchar* plank_dock_element_as_uri (PlankDockElement* self);
void plank_dock_element_reset_buffers (PlankDockElement* self);
static void plank_dock_element_real_reset_buffers (PlankDockElement* self);
GtkMenuItem* plank_dock_element_create_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon);
static GtkMenuItem* plank_dock_element_create_menu_item_iternal (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon, gboolean mnemonics);
GdkPixbuf* plank_drawing_service_load_icon (const gchar* names, gint width, gint height);
GtkMenuItem* plank_dock_element_create_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon);
GdkPixbuf* plank_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
GtkMenuItem* plank_dock_element_create_literal_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon);
GtkMenuItem* plank_dock_element_create_literal_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon);
PlankDockElement* plank_dock_element_construct (GType object_type);
void plank_dock_element_set_Container (PlankDockElement* self, PlankDockContainer* value);
const gchar* plank_dock_element_get_Text (PlankDockElement* self);
void plank_dock_element_set_Text (PlankDockElement* self, const gchar* value);
gboolean plank_dock_element_get_IsAttached (PlankDockElement* self);
void plank_dock_element_set_IsAttached (PlankDockElement* self, gboolean value);
gboolean plank_dock_element_get_IsVisible (PlankDockElement* self);
void plank_dock_element_set_IsVisible (PlankDockElement* self, gboolean value);
PlankPopupButton plank_dock_element_get_Button (PlankDockElement* self);
void plank_dock_element_set_Button (PlankDockElement* self, PlankPopupButton value);
PlankAnimationType plank_dock_element_get_ClickedAnimation (PlankDockElement* self);
PlankAnimationType plank_dock_element_get_HoveredAnimation (PlankDockElement* self);
PlankAnimationType plank_dock_element_get_ScrolledAnimation (PlankDockElement* self);
gint64 plank_dock_element_get_AddTime (PlankDockElement* self);
void plank_dock_element_set_AddTime (PlankDockElement* self, gint64 value);
gint64 plank_dock_element_get_RemoveTime (PlankDockElement* self);
void plank_dock_element_set_RemoveTime (PlankDockElement* self, gint64 value);
gint64 plank_dock_element_get_LastClicked (PlankDockElement* self);
gint64 plank_dock_element_get_LastHovered (PlankDockElement* self);
gint64 plank_dock_element_get_LastScrolled (PlankDockElement* self);
gint64 plank_dock_element_get_LastUrgent (PlankDockElement* self);
void plank_dock_element_set_LastUrgent (PlankDockElement* self, gint64 value);
gint64 plank_dock_element_get_LastActive (PlankDockElement* self);
void plank_dock_element_set_LastActive (PlankDockElement* self, gint64 value);
gint64 plank_dock_element_get_LastMove (PlankDockElement* self);
void plank_dock_element_set_LastMove (PlankDockElement* self, gint64 value);
gint64 plank_dock_element_get_LastValid (PlankDockElement* self);
void plank_dock_element_set_LastValid (PlankDockElement* self, gint64 value);
static void plank_dock_element_finalize (GObject * obj);
static void _vala_plank_dock_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_dock_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Called when an item is clicked on.
 *
 * @param button the button clicked
 * @param mod the modifiers
 * @param event_time the timestamp of the event triggering this action
 */
void plank_dock_element_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time) {
	PlankPopupButton _tmp0_;
	GdkModifierType _tmp1_;
	guint32 _tmp2_;
	PlankAnimationType _tmp3_;
	gint64 _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = button;
	_tmp1_ = mod;
	_tmp2_ = event_time;
	_tmp3_ = plank_dock_element_on_clicked (self, _tmp0_, _tmp1_, _tmp2_);
	plank_dock_element_set_ClickedAnimation (self, _tmp3_);
	_tmp4_ = g_get_monotonic_time ();
	plank_dock_element_set_LastClicked (self, _tmp4_);
}


/**
 * Called when an item is clicked on.
 *
 * @param button the button clicked
 * @param mod the modifiers
 * @param event_time the timestamp of the event triggering this action
 * @return which type of animation to trigger
 */
static PlankAnimationType plank_dock_element_real_on_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time) {
	PlankAnimationType result = 0;
	result = PLANK_ANIMATION_TYPE_NONE;
	return result;
}


PlankAnimationType plank_dock_element_on_clicked (PlankDockElement* self, PlankPopupButton button, GdkModifierType mod, guint32 event_time) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->on_clicked (self, button, mod, event_time);
}


/**
 * Called when an item gets hovered.
 */
void plank_dock_element_hovered (PlankDockElement* self) {
	PlankAnimationType _tmp0_;
	gint64 _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = plank_dock_element_on_hovered (self);
	plank_dock_element_set_HoveredAnimation (self, _tmp0_);
	_tmp1_ = g_get_monotonic_time ();
	plank_dock_element_set_LastHovered (self, _tmp1_);
}


/**
 * Called when an item gets hovered.
 *
 * @return which type of animation to trigger
 */
static PlankAnimationType plank_dock_element_real_on_hovered (PlankDockElement* self) {
	PlankAnimationType result = 0;
	result = PLANK_ANIMATION_TYPE_LIGHTEN;
	return result;
}


PlankAnimationType plank_dock_element_on_hovered (PlankDockElement* self) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->on_hovered (self);
}


/**
 * Called when an item is scrolled over.
 *
 * @param direction the scroll direction
 * @param mod the modifiers
 * @param event_time the timestamp of the event triggering this action
 */
void plank_dock_element_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time) {
	GdkScrollDirection _tmp0_;
	GdkModifierType _tmp1_;
	guint32 _tmp2_;
	PlankAnimationType _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = direction;
	_tmp1_ = mod;
	_tmp2_ = event_time;
	_tmp3_ = plank_dock_element_on_scrolled (self, _tmp0_, _tmp1_, _tmp2_);
	plank_dock_element_set_ScrolledAnimation (self, _tmp3_);
}


/**
 * Called when an item is scrolled over.
 *
 * @param direction the scroll direction
 * @param mod the modifiers
 * @param event_time the timestamp of the event triggering this action
 * @return which type of animation to trigger
 */
static PlankAnimationType plank_dock_element_real_on_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time) {
	PlankAnimationType result = 0;
	gint64 _tmp0_;
	_tmp0_ = g_get_monotonic_time ();
	plank_dock_element_set_LastScrolled (self, _tmp0_);
	result = PLANK_ANIMATION_TYPE_NONE;
	return result;
}


PlankAnimationType plank_dock_element_on_scrolled (PlankDockElement* self, GdkScrollDirection direction, GdkModifierType mod, guint32 event_time) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->on_scrolled (self, direction, mod, event_time);
}


/**
 * Get the dock which this element is part of
 *
 * @return the dock-controller of this element, or null
 */
PlankDockController* plank_dock_element_get_dock (PlankDockElement* self) {
	PlankDockController* result = NULL;
	PlankDockContainer* container;
	PlankDockContainer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Container;
	container = _tmp0_;
	while (TRUE) {
		PlankDockContainer* _tmp1_;
		PlankDockContainer* _tmp2_;
		PlankDockContainer* _tmp4_;
		PlankDockContainer* _tmp5_;
		_tmp1_ = container;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = container;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, PLANK_TYPE_DOCK_CONTROLLER)) {
			PlankDockContainer* _tmp3_;
			_tmp3_ = container;
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
			return result;
		}
		_tmp4_ = container;
		_tmp5_ = ((PlankDockElement*) _tmp4_)->priv->_Container;
		container = _tmp5_;
	}
	result = NULL;
	return result;
}


/**
 * Returns a list of the item's menu items.
 *
 * @return the item's menu items
 */
static GeeArrayList* plank_dock_element_real_get_menu_items (PlankDockElement* self) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_;
	_tmp0_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = _tmp0_;
	return result;
}


GeeArrayList* plank_dock_element_get_menu_items (PlankDockElement* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->get_menu_items (self);
}


/**
 * The item's text for drop actions.
 *
 * @return the item's drop-text
 */
static gchar* plank_dock_element_real_get_drop_text (PlankDockElement* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("");
	result = _tmp0_;
	return result;
}


gchar* plank_dock_element_get_drop_text (PlankDockElement* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->get_drop_text (self);
}


/**
 * Returns if this item can be removed from the dock.
 *
 * @return if this item can be removed from the dock
 */
static gboolean plank_dock_element_real_can_be_removed (PlankDockElement* self) {
	gboolean result = FALSE;
	result = TRUE;
	return result;
}


gboolean plank_dock_element_can_be_removed (PlankDockElement* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->can_be_removed (self);
}


/**
 * Returns if the item accepts a drop of the given URIs.
 *
 * @param uris the URIs to check
 * @return if the item accepts a drop of the given URIs
 */
static gboolean plank_dock_element_real_can_accept_drop (PlankDockElement* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_dock_element_can_accept_drop (PlankDockElement* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->can_accept_drop (self, uris);
}


/**
 * Accepts a drop of the given URIs.
 *
 * @param uris the URIs to accept
 * @return if the item accepted a drop of the given URIs
 */
static gboolean plank_dock_element_real_accept_drop (PlankDockElement* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_dock_element_accept_drop (PlankDockElement* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->accept_drop (self, uris);
}


/**
 * Returns a unique ID for this dock item.
 *
 * @return a unique ID for this dock element
 */
static gchar* plank_dock_element_real_unique_id (PlankDockElement* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup_printf ("dockelement%p", self);
	result = _tmp0_;
	return result;
}


gchar* plank_dock_element_unique_id (PlankDockElement* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_DOCK_ELEMENT_GET_CLASS (self)->unique_id (self);
}


/**
 * Returns a unique URI for this dock element.
 *
 * @return a unique URI for this dock element
 */
gchar* plank_dock_element_as_uri (PlankDockElement* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = plank_dock_element_unique_id (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("plank://%s", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


/**
 * Resets the buffers for this element.
 */
static void plank_dock_element_real_reset_buffers (PlankDockElement* self) {
	g_critical ("Type `%s' does not implement abstract method `plank_dock_element_reset_buffers'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void plank_dock_element_reset_buffers (PlankDockElement* self) {
	g_return_if_fail (self != NULL);
	PLANK_DOCK_ELEMENT_GET_CLASS (self)->reset_buffers (self);
}


/**
 * Creates a new menu item with mnemonics enabled.
 *
 * @param title the title of the menu item
 * @param icon the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
GtkMenuItem* plank_dock_element_create_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint width = 0;
	gint height = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	gboolean _tmp12_;
	GtkMenuItem* _tmp13_;
	g_return_val_if_fail (title != NULL, NULL);
	_tmp1_ = icon;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = icon;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		const gchar* _tmp3_;
		GtkMenuItem* _tmp4_;
		_tmp3_ = title;
		_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp3_);
		g_object_ref_sink (_tmp4_);
		result = _tmp4_;
		return result;
	}
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp5_, &_tmp6_);
	width = _tmp5_;
	height = _tmp6_;
	_tmp7_ = title;
	_tmp8_ = icon;
	_tmp9_ = width;
	_tmp10_ = height;
	_tmp11_ = plank_drawing_service_load_icon (_tmp8_, _tmp9_, _tmp10_);
	_tmp12_ = force_show_icon;
	_tmp13_ = plank_dock_element_create_menu_item_iternal (_tmp7_, _tmp11_, _tmp12_, TRUE);
	result = _tmp13_;
	return result;
}


/**
 * Creates a new menu item with mnemonics enabled.
 *
 * @param title the title of the menu item
 * @param pixbuf the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GtkMenuItem* plank_dock_element_create_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	GdkPixbuf* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	gboolean _tmp18_;
	GtkMenuItem* _tmp19_;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	_tmp3_ = width;
	_tmp4_ = pixbuf;
	_tmp5_ = gdk_pixbuf_get_width (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp3_ != _tmp6_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp7_;
		GdkPixbuf* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp7_ = height;
		_tmp8_ = pixbuf;
		_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp2_ = _tmp7_ != _tmp10_;
	}
	if (_tmp2_) {
		GdkPixbuf* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkPixbuf* _tmp14_;
		_tmp11_ = pixbuf;
		_tmp12_ = width;
		_tmp13_ = height;
		_tmp14_ = plank_drawing_service_ar_scale (_tmp11_, _tmp12_, _tmp13_);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp14_;
	}
	_tmp15_ = title;
	_tmp16_ = pixbuf;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	_tmp18_ = force_show_icon;
	_tmp19_ = plank_dock_element_create_menu_item_iternal (_tmp15_, _tmp17_, _tmp18_, TRUE);
	result = _tmp19_;
	_g_object_unref0 (pixbuf);
	return result;
}


/**
 * Creates a new menu item with mnemonics disabled.
 *
 * @param title the title of the menu item
 * @param icon the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
GtkMenuItem* plank_dock_element_create_literal_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint width = 0;
	gint height = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	gboolean _tmp12_;
	GtkMenuItem* _tmp13_;
	g_return_val_if_fail (title != NULL, NULL);
	_tmp1_ = icon;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = icon;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		const gchar* _tmp3_;
		GtkMenuItem* _tmp4_;
		_tmp3_ = title;
		_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp3_);
		g_object_ref_sink (_tmp4_);
		result = _tmp4_;
		return result;
	}
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp5_, &_tmp6_);
	width = _tmp5_;
	height = _tmp6_;
	_tmp7_ = title;
	_tmp8_ = icon;
	_tmp9_ = width;
	_tmp10_ = height;
	_tmp11_ = plank_drawing_service_load_icon (_tmp8_, _tmp9_, _tmp10_);
	_tmp12_ = force_show_icon;
	_tmp13_ = plank_dock_element_create_menu_item_iternal (_tmp7_, _tmp11_, _tmp12_, FALSE);
	result = _tmp13_;
	return result;
}


/**
 * Creates a new menu item with mnemonics disabled.
 *
 * @param title the title of the menu item
 * @param pixbuf the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
GtkMenuItem* plank_dock_element_create_literal_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	GdkPixbuf* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	gboolean _tmp18_;
	GtkMenuItem* _tmp19_;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	_tmp3_ = width;
	_tmp4_ = pixbuf;
	_tmp5_ = gdk_pixbuf_get_width (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp3_ != _tmp6_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp7_;
		GdkPixbuf* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp7_ = height;
		_tmp8_ = pixbuf;
		_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp2_ = _tmp7_ != _tmp10_;
	}
	if (_tmp2_) {
		GdkPixbuf* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkPixbuf* _tmp14_;
		_tmp11_ = pixbuf;
		_tmp12_ = width;
		_tmp13_ = height;
		_tmp14_ = plank_drawing_service_ar_scale (_tmp11_, _tmp12_, _tmp13_);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp14_;
	}
	_tmp15_ = title;
	_tmp16_ = pixbuf;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	_tmp18_ = force_show_icon;
	_tmp19_ = plank_dock_element_create_menu_item_iternal (_tmp15_, _tmp17_, _tmp18_, FALSE);
	result = _tmp19_;
	_g_object_unref0 (pixbuf);
	return result;
}


static GtkMenuItem* plank_dock_element_create_menu_item_iternal (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon, gboolean mnemonics) {
	GtkMenuItem* result = NULL;
	GtkImageMenuItem* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkImageMenuItem* item;
	GtkImageMenuItem* _tmp6_;
	GtkImageMenuItem* _tmp7_;
	GdkPixbuf* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	gboolean _tmp11_;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	_tmp1_ = mnemonics;
	if (_tmp1_) {
		const gchar* _tmp2_;
		GtkImageMenuItem* _tmp3_;
		_tmp2_ = title;
		_tmp3_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_tmp2_);
		g_object_ref_sink (_tmp3_);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		const gchar* _tmp4_;
		GtkImageMenuItem* _tmp5_;
		_tmp4_ = title;
		_tmp5_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp4_);
		g_object_ref_sink (_tmp5_);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	item = _tmp6_;
	_tmp7_ = item;
	_tmp8_ = pixbuf;
	_tmp9_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_image_menu_item_set_image (_tmp7_, (GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = force_show_icon;
	if (_tmp11_) {
		GtkImageMenuItem* _tmp12_;
		_tmp12_ = item;
		gtk_image_menu_item_set_always_show_image (_tmp12_, TRUE);
	}
	result = (GtkMenuItem*) item;
	_g_object_unref0 (_tmp0_);
	_g_object_unref0 (pixbuf);
	return result;
}


PlankDockElement* plank_dock_element_construct (GType object_type) {
	PlankDockElement * self = NULL;
	self = (PlankDockElement*) g_object_new (object_type, NULL);
	return self;
}


PlankDockContainer* plank_dock_element_get_Container (PlankDockElement* self) {
	PlankDockContainer* result;
	PlankDockContainer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Container;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_Container (PlankDockElement* self, PlankDockContainer* value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_Container (self) != value) {
		PlankDockContainer* _tmp0_;
		PlankDockContainer* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_Container);
		self->priv->_Container = _tmp1_;
		g_object_notify ((GObject *) self, "Container");
	}
}


const gchar* plank_dock_element_get_Text (PlankDockElement* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Text;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_Text (PlankDockElement* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, plank_dock_element_get_Text (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_Text);
		self->priv->_Text = _tmp1_;
		g_object_notify ((GObject *) self, "Text");
	}
}


gboolean plank_dock_element_get_IsAttached (PlankDockElement* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_IsAttached;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_IsAttached (PlankDockElement* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_IsAttached (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_IsAttached = _tmp0_;
		g_object_notify ((GObject *) self, "IsAttached");
	}
}


gboolean plank_dock_element_get_IsVisible (PlankDockElement* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_IsVisible;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_IsVisible (PlankDockElement* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_IsVisible (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_IsVisible = _tmp0_;
		g_object_notify ((GObject *) self, "IsVisible");
	}
}


PlankPopupButton plank_dock_element_get_Button (PlankDockElement* self) {
	PlankPopupButton result;
	PlankPopupButton _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Button;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_Button (PlankDockElement* self, PlankPopupButton value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_Button (self) != value) {
		PlankPopupButton _tmp0_;
		_tmp0_ = value;
		self->priv->_Button = _tmp0_;
		g_object_notify ((GObject *) self, "Button");
	}
}


PlankAnimationType plank_dock_element_get_ClickedAnimation (PlankDockElement* self) {
	PlankAnimationType result;
	PlankAnimationType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ClickedAnimation;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_ClickedAnimation (PlankDockElement* self, PlankAnimationType value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_ClickedAnimation (self) != value) {
		PlankAnimationType _tmp0_;
		_tmp0_ = value;
		self->priv->_ClickedAnimation = _tmp0_;
		g_object_notify ((GObject *) self, "ClickedAnimation");
	}
}


PlankAnimationType plank_dock_element_get_HoveredAnimation (PlankDockElement* self) {
	PlankAnimationType result;
	PlankAnimationType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_HoveredAnimation;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_HoveredAnimation (PlankDockElement* self, PlankAnimationType value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_HoveredAnimation (self) != value) {
		PlankAnimationType _tmp0_;
		_tmp0_ = value;
		self->priv->_HoveredAnimation = _tmp0_;
		g_object_notify ((GObject *) self, "HoveredAnimation");
	}
}


PlankAnimationType plank_dock_element_get_ScrolledAnimation (PlankDockElement* self) {
	PlankAnimationType result;
	PlankAnimationType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ScrolledAnimation;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_ScrolledAnimation (PlankDockElement* self, PlankAnimationType value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_ScrolledAnimation (self) != value) {
		PlankAnimationType _tmp0_;
		_tmp0_ = value;
		self->priv->_ScrolledAnimation = _tmp0_;
		g_object_notify ((GObject *) self, "ScrolledAnimation");
	}
}


gint64 plank_dock_element_get_AddTime (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_AddTime;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_AddTime (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_AddTime (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_AddTime = _tmp0_;
		g_object_notify ((GObject *) self, "AddTime");
	}
}


gint64 plank_dock_element_get_RemoveTime (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_RemoveTime;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_RemoveTime (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_RemoveTime (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_RemoveTime = _tmp0_;
		g_object_notify ((GObject *) self, "RemoveTime");
	}
}


gint64 plank_dock_element_get_LastClicked (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastClicked;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastClicked (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastClicked (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastClicked = _tmp0_;
		g_object_notify ((GObject *) self, "LastClicked");
	}
}


gint64 plank_dock_element_get_LastHovered (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastHovered;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastHovered (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastHovered (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastHovered = _tmp0_;
		g_object_notify ((GObject *) self, "LastHovered");
	}
}


gint64 plank_dock_element_get_LastScrolled (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastScrolled;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastScrolled (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastScrolled (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastScrolled = _tmp0_;
		g_object_notify ((GObject *) self, "LastScrolled");
	}
}


gint64 plank_dock_element_get_LastUrgent (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastUrgent;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastUrgent (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastUrgent (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastUrgent = _tmp0_;
		g_object_notify ((GObject *) self, "LastUrgent");
	}
}


gint64 plank_dock_element_get_LastActive (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastActive;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastActive (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastActive (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastActive = _tmp0_;
		g_object_notify ((GObject *) self, "LastActive");
	}
}


gint64 plank_dock_element_get_LastMove (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastMove;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastMove (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastMove (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastMove = _tmp0_;
		g_object_notify ((GObject *) self, "LastMove");
	}
}


gint64 plank_dock_element_get_LastValid (PlankDockElement* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastValid;
	result = _tmp0_;
	return result;
}


void plank_dock_element_set_LastValid (PlankDockElement* self, gint64 value) {
	g_return_if_fail (self != NULL);
	if (plank_dock_element_get_LastValid (self) != value) {
		gint64 _tmp0_;
		_tmp0_ = value;
		self->priv->_LastValid = _tmp0_;
		g_object_notify ((GObject *) self, "LastValid");
	}
}


static void plank_dock_element_class_init (PlankDockElementClass * klass) {
	plank_dock_element_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankDockElementPrivate));
	((PlankDockElementClass *) klass)->on_clicked = (PlankAnimationType (*) (PlankDockElement *, PlankPopupButton, GdkModifierType, guint32)) plank_dock_element_real_on_clicked;
	((PlankDockElementClass *) klass)->on_hovered = (PlankAnimationType (*) (PlankDockElement *)) plank_dock_element_real_on_hovered;
	((PlankDockElementClass *) klass)->on_scrolled = (PlankAnimationType (*) (PlankDockElement *, GdkScrollDirection, GdkModifierType, guint32)) plank_dock_element_real_on_scrolled;
	((PlankDockElementClass *) klass)->get_menu_items = (GeeArrayList* (*) (PlankDockElement *)) plank_dock_element_real_get_menu_items;
	((PlankDockElementClass *) klass)->get_drop_text = (gchar* (*) (PlankDockElement *)) plank_dock_element_real_get_drop_text;
	((PlankDockElementClass *) klass)->can_be_removed = (gboolean (*) (PlankDockElement *)) plank_dock_element_real_can_be_removed;
	((PlankDockElementClass *) klass)->can_accept_drop = (gboolean (*) (PlankDockElement *, GeeArrayList*)) plank_dock_element_real_can_accept_drop;
	((PlankDockElementClass *) klass)->accept_drop = (gboolean (*) (PlankDockElement *, GeeArrayList*)) plank_dock_element_real_accept_drop;
	((PlankDockElementClass *) klass)->unique_id = (gchar* (*) (PlankDockElement *)) plank_dock_element_real_unique_id;
	((PlankDockElementClass *) klass)->reset_buffers = (void (*) (PlankDockElement *)) plank_dock_element_real_reset_buffers;
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_element_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_element_set_property;
	G_OBJECT_CLASS (klass)->finalize = plank_dock_element_finalize;
	/**
	 * The dock element's container which it is added too (if any).
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_CONTAINER, g_param_spec_object ("Container", "Container", "Container", PLANK_TYPE_DOCK_CONTAINER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The dock item's text.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_TEXT, g_param_spec_string ("Text", "Text", "Text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Whether the item is currently hidden on the dock.
	 * If TRUE it will be drawn and does consume space.
	 * If FALSE it will not be drawn and does not consume space.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_IS_ATTACHED, g_param_spec_boolean ("IsAttached", "IsAttached", "IsAttached", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Whether the item is currently visible on the dock.
	 * If TRUE it will be drawn and does consume space.
	 * If FALSE it will not be drawn and does consume space.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_IS_VISIBLE, g_param_spec_boolean ("IsVisible", "IsVisible", "IsVisible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The buttons this item shows popup menus for.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_BUTTON, g_param_spec_flags ("Button", "Button", "Button", PLANK_TYPE_POPUP_BUTTON, PLANK_POPUP_BUTTON_RIGHT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last click event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_CLICKED_ANIMATION, g_param_spec_enum ("ClickedAnimation", "ClickedAnimation", "ClickedAnimation", PLANK_TYPE_ANIMATION_TYPE, PLANK_ANIMATION_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last hover event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_HOVERED_ANIMATION, g_param_spec_enum ("HoveredAnimation", "HoveredAnimation", "HoveredAnimation", PLANK_TYPE_ANIMATION_TYPE, PLANK_ANIMATION_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last scroll event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_SCROLLED_ANIMATION, g_param_spec_enum ("ScrolledAnimation", "ScrolledAnimation", "ScrolledAnimation", PLANK_TYPE_ANIMATION_TYPE, PLANK_ANIMATION_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The time the item was added to the dock.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_ADD_TIME, g_param_spec_int64 ("AddTime", "AddTime", "AddTime", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The time the item was removed from the dock.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_REMOVE_TIME, g_param_spec_int64 ("RemoveTime", "RemoveTime", "RemoveTime", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was clicked.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_CLICKED, g_param_spec_int64 ("LastClicked", "LastClicked", "LastClicked", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was hovered.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_HOVERED, g_param_spec_int64 ("LastHovered", "LastHovered", "LastHovered", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was scrolled.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_SCROLLED, g_param_spec_int64 ("LastScrolled", "LastScrolled", "LastScrolled", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its urgent status.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_URGENT, g_param_spec_int64 ("LastUrgent", "LastUrgent", "LastUrgent", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its active status.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_ACTIVE, g_param_spec_int64 ("LastActive", "LastActive", "LastActive", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its position.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_MOVE, g_param_spec_int64 ("LastMove", "LastMove", "LastMove", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was valid.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_ELEMENT_LAST_VALID, g_param_spec_int64 ("LastValid", "LastValid", "LastValid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Signal fired when the dock element needs redrawn.
	 */
	plank_dock_element_signals[PLANK_DOCK_ELEMENT_NEEDS_REDRAW_SIGNAL] = g_signal_new ("needs_redraw", PLANK_TYPE_DOCK_ELEMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void plank_dock_element_instance_init (PlankDockElement * self) {
	gchar* _tmp0_;
	self->priv = PLANK_DOCK_ELEMENT_GET_PRIVATE (self);
	self->priv->_Container = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_Text = _tmp0_;
	self->priv->_IsAttached = TRUE;
	self->priv->_IsVisible = TRUE;
	self->priv->_Button = PLANK_POPUP_BUTTON_RIGHT;
	self->priv->_ClickedAnimation = PLANK_ANIMATION_TYPE_NONE;
	self->priv->_HoveredAnimation = PLANK_ANIMATION_TYPE_NONE;
	self->priv->_ScrolledAnimation = PLANK_ANIMATION_TYPE_NONE;
}


static void plank_dock_element_finalize (GObject * obj) {
	PlankDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement);
	_g_object_unref0 (self->priv->_Container);
	_g_free0 (self->priv->_Text);
	G_OBJECT_CLASS (plank_dock_element_parent_class)->finalize (obj);
}


/**
 * The base class for all dock elements.
 */
GType plank_dock_element_get_type (void) {
	static volatile gsize plank_dock_element_type_id__volatile = 0;
	if (g_once_init_enter (&plank_dock_element_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDockElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockElement), 0, (GInstanceInitFunc) plank_dock_element_instance_init, NULL };
		GType plank_dock_element_type_id;
		plank_dock_element_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDockElement", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_dock_element_type_id__volatile, plank_dock_element_type_id);
	}
	return plank_dock_element_type_id__volatile;
}


static void _vala_plank_dock_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement);
	switch (property_id) {
		case PLANK_DOCK_ELEMENT_CONTAINER:
		g_value_set_object (value, plank_dock_element_get_Container (self));
		break;
		case PLANK_DOCK_ELEMENT_TEXT:
		g_value_set_string (value, plank_dock_element_get_Text (self));
		break;
		case PLANK_DOCK_ELEMENT_IS_ATTACHED:
		g_value_set_boolean (value, plank_dock_element_get_IsAttached (self));
		break;
		case PLANK_DOCK_ELEMENT_IS_VISIBLE:
		g_value_set_boolean (value, plank_dock_element_get_IsVisible (self));
		break;
		case PLANK_DOCK_ELEMENT_BUTTON:
		g_value_set_flags (value, plank_dock_element_get_Button (self));
		break;
		case PLANK_DOCK_ELEMENT_CLICKED_ANIMATION:
		g_value_set_enum (value, plank_dock_element_get_ClickedAnimation (self));
		break;
		case PLANK_DOCK_ELEMENT_HOVERED_ANIMATION:
		g_value_set_enum (value, plank_dock_element_get_HoveredAnimation (self));
		break;
		case PLANK_DOCK_ELEMENT_SCROLLED_ANIMATION:
		g_value_set_enum (value, plank_dock_element_get_ScrolledAnimation (self));
		break;
		case PLANK_DOCK_ELEMENT_ADD_TIME:
		g_value_set_int64 (value, plank_dock_element_get_AddTime (self));
		break;
		case PLANK_DOCK_ELEMENT_REMOVE_TIME:
		g_value_set_int64 (value, plank_dock_element_get_RemoveTime (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_CLICKED:
		g_value_set_int64 (value, plank_dock_element_get_LastClicked (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_HOVERED:
		g_value_set_int64 (value, plank_dock_element_get_LastHovered (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_SCROLLED:
		g_value_set_int64 (value, plank_dock_element_get_LastScrolled (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_URGENT:
		g_value_set_int64 (value, plank_dock_element_get_LastUrgent (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_ACTIVE:
		g_value_set_int64 (value, plank_dock_element_get_LastActive (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_MOVE:
		g_value_set_int64 (value, plank_dock_element_get_LastMove (self));
		break;
		case PLANK_DOCK_ELEMENT_LAST_VALID:
		g_value_set_int64 (value, plank_dock_element_get_LastValid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_dock_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement);
	switch (property_id) {
		case PLANK_DOCK_ELEMENT_CONTAINER:
		plank_dock_element_set_Container (self, g_value_get_object (value));
		break;
		case PLANK_DOCK_ELEMENT_TEXT:
		plank_dock_element_set_Text (self, g_value_get_string (value));
		break;
		case PLANK_DOCK_ELEMENT_IS_ATTACHED:
		plank_dock_element_set_IsAttached (self, g_value_get_boolean (value));
		break;
		case PLANK_DOCK_ELEMENT_IS_VISIBLE:
		plank_dock_element_set_IsVisible (self, g_value_get_boolean (value));
		break;
		case PLANK_DOCK_ELEMENT_BUTTON:
		plank_dock_element_set_Button (self, g_value_get_flags (value));
		break;
		case PLANK_DOCK_ELEMENT_CLICKED_ANIMATION:
		plank_dock_element_set_ClickedAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_DOCK_ELEMENT_HOVERED_ANIMATION:
		plank_dock_element_set_HoveredAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_DOCK_ELEMENT_SCROLLED_ANIMATION:
		plank_dock_element_set_ScrolledAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_DOCK_ELEMENT_ADD_TIME:
		plank_dock_element_set_AddTime (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_REMOVE_TIME:
		plank_dock_element_set_RemoveTime (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_CLICKED:
		plank_dock_element_set_LastClicked (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_HOVERED:
		plank_dock_element_set_LastHovered (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_SCROLLED:
		plank_dock_element_set_LastScrolled (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_URGENT:
		plank_dock_element_set_LastUrgent (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_ACTIVE:
		plank_dock_element_set_LastActive (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_MOVE:
		plank_dock_element_set_LastMove (self, g_value_get_int64 (value));
		break;
		case PLANK_DOCK_ELEMENT_LAST_VALID:
		plank_dock_element_set_LastValid (self, g_value_get_int64 (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



