/* Environment.c generated by valac 0.36.2, the Vala compiler
 * generated from Environment.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>


#define PLANK_TYPE_XDG_SESSION_CLASS (plank_xdg_session_class_get_type ())

#define PLANK_TYPE_XDG_SESSION_DESKTOP (plank_xdg_session_desktop_get_type ())

#define PLANK_TYPE_XDG_SESSION_TYPE (plank_xdg_session_type_get_type ())

typedef enum  {
	PLANK_XDG_SESSION_CLASS_USER,
	PLANK_XDG_SESSION_CLASS_GREETER,
	PLANK_XDG_SESSION_CLASS_LOCK_SCREEN,
	PLANK_XDG_SESSION_CLASS_BACKGROUND
} PlankXdgSessionClass;

typedef enum  {
	PLANK_XDG_SESSION_DESKTOP_GNOME = 1 << 0,
	PLANK_XDG_SESSION_DESKTOP_KDE = 1 << 1,
	PLANK_XDG_SESSION_DESKTOP_LXDE = 1 << 2,
	PLANK_XDG_SESSION_DESKTOP_MATE = 1 << 3,
	PLANK_XDG_SESSION_DESKTOP_RAZOR = 1 << 4,
	PLANK_XDG_SESSION_DESKTOP_ROX = 1 << 5,
	PLANK_XDG_SESSION_DESKTOP_TDE = 1 << 6,
	PLANK_XDG_SESSION_DESKTOP_UNITY = 1 << 7,
	PLANK_XDG_SESSION_DESKTOP_XFCE = 1 << 8,
	PLANK_XDG_SESSION_DESKTOP_EDE = 1 << 9,
	PLANK_XDG_SESSION_DESKTOP_CINNAMON = 1 << 10,
	PLANK_XDG_SESSION_DESKTOP_PANTHEON = 1 << 11,
	PLANK_XDG_SESSION_DESKTOP_OLD = 1 << 12
} PlankXdgSessionDesktop;

typedef enum  {
	PLANK_XDG_SESSION_TYPE_UNSPECIFIED,
	PLANK_XDG_SESSION_TYPE_TTY,
	PLANK_XDG_SESSION_TYPE_X11,
	PLANK_XDG_SESSION_TYPE_WAYLAND,
	PLANK_XDG_SESSION_TYPE_MIR
} PlankXdgSessionType;


extern PlankXdgSessionClass plank_session_class;
PlankXdgSessionClass plank_session_class = 0;
extern PlankXdgSessionDesktop plank_session_desktop;
PlankXdgSessionDesktop plank_session_desktop = 0;
extern PlankXdgSessionType plank_session_type;
PlankXdgSessionType plank_session_type = 0;

GType plank_xdg_session_class_get_type (void) G_GNUC_CONST;
PlankXdgSessionClass plank_xdg_session_class_from_string (const gchar* s);
GType plank_xdg_session_desktop_get_type (void) G_GNUC_CONST;
static PlankXdgSessionDesktop plank_xdg_session_desktop_from_single_string (const gchar* s);
PlankXdgSessionDesktop plank_xdg_session_desktop_from_string (const gchar* s);
GType plank_xdg_session_type_get_type (void) G_GNUC_CONST;
PlankXdgSessionType plank_xdg_session_type_from_string (const gchar* s);
void plank_environment_initialize (void);
PlankXdgSessionClass plank_get_xdg_session_class (void);
PlankXdgSessionDesktop plank_get_xdg_session_desktop (void);
PlankXdgSessionType plank_get_xdg_session_type (void);
gboolean plank_environment_is_session_class (PlankXdgSessionClass type);
gboolean plank_environment_is_session_desktop (PlankXdgSessionDesktop type);
gboolean plank_environment_is_session_type (PlankXdgSessionType type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


PlankXdgSessionClass plank_xdg_session_class_from_string (const gchar* s) {
	PlankXdgSessionClass result = 0;
	PlankXdgSessionClass _result_ = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	g_return_val_if_fail (s != NULL, 0);
	_tmp0_ = s;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	g_free (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("greeter")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_CLASS_GREETER;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("lock-screen")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_CLASS_LOCK_SCREEN;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("background")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_CLASS_BACKGROUND;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_CLASS_USER;
				break;
			}
		}
	}
	result = _result_;
	return result;
}


GType plank_xdg_session_class_get_type (void) {
	static volatile gsize plank_xdg_session_class_type_id__volatile = 0;
	if (g_once_init_enter (&plank_xdg_session_class_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_XDG_SESSION_CLASS_USER, "PLANK_XDG_SESSION_CLASS_USER", "user"}, {PLANK_XDG_SESSION_CLASS_GREETER, "PLANK_XDG_SESSION_CLASS_GREETER", "greeter"}, {PLANK_XDG_SESSION_CLASS_LOCK_SCREEN, "PLANK_XDG_SESSION_CLASS_LOCK_SCREEN", "lock-screen"}, {PLANK_XDG_SESSION_CLASS_BACKGROUND, "PLANK_XDG_SESSION_CLASS_BACKGROUND", "background"}, {0, NULL, NULL}};
		GType plank_xdg_session_class_type_id;
		plank_xdg_session_class_type_id = g_enum_register_static ("PlankXdgSessionClass", values);
		g_once_init_leave (&plank_xdg_session_class_type_id__volatile, plank_xdg_session_class_type_id);
	}
	return plank_xdg_session_class_type_id__volatile;
}


static PlankXdgSessionDesktop plank_xdg_session_desktop_from_single_string (const gchar* s) {
	PlankXdgSessionDesktop result = 0;
	PlankXdgSessionDesktop _result_ = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	static GQuark _tmp3_label4 = 0;
	static GQuark _tmp3_label5 = 0;
	static GQuark _tmp3_label6 = 0;
	static GQuark _tmp3_label7 = 0;
	static GQuark _tmp3_label8 = 0;
	static GQuark _tmp3_label9 = 0;
	static GQuark _tmp3_label10 = 0;
	static GQuark _tmp3_label11 = 0;
	static GQuark _tmp3_label12 = 0;
	g_return_val_if_fail (s != NULL, 0);
	_tmp0_ = s;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	g_free (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("gnome")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_GNOME;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("kde")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_KDE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("lxde")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_LXDE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("mate")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_MATE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label4) ? _tmp3_label4 : (_tmp3_label4 = g_quark_from_static_string ("razor")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_RAZOR;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label5) ? _tmp3_label5 : (_tmp3_label5 = g_quark_from_static_string ("rox")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_ROX;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label6) ? _tmp3_label6 : (_tmp3_label6 = g_quark_from_static_string ("tde")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_TDE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label7) ? _tmp3_label7 : (_tmp3_label7 = g_quark_from_static_string ("unity")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_UNITY;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label8) ? _tmp3_label8 : (_tmp3_label8 = g_quark_from_static_string ("xfce")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_XFCE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label9) ? _tmp3_label9 : (_tmp3_label9 = g_quark_from_static_string ("ede")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_EDE;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label10) ? _tmp3_label10 : (_tmp3_label10 = g_quark_from_static_string ("cinnamon")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_CINNAMON;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label11) ? _tmp3_label11 : (_tmp3_label11 = g_quark_from_static_string ("pantheon")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_PANTHEON;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label12) ? _tmp3_label12 : (_tmp3_label12 = g_quark_from_static_string ("old")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_DESKTOP_OLD;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				_result_ = 0;
				break;
			}
		}
	}
	result = _result_;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


PlankXdgSessionDesktop plank_xdg_session_desktop_from_string (const gchar* s) {
	PlankXdgSessionDesktop result = 0;
	PlankXdgSessionDesktop _result_;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (s != NULL, 0);
	_result_ = 0;
	_tmp0_ = s;
	_tmp1_ = string_contains (_tmp0_, ";");
	if (_tmp1_) {
		const gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		_tmp2_ = s;
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ";", 0);
		{
			gchar** e_collection = NULL;
			gint e_collection_length1 = 0;
			gint _e_collection_size_ = 0;
			gint e_it = 0;
			e_collection = _tmp4_;
			e_collection_length1 = _vala_array_length (_tmp3_);
			for (e_it = 0; e_it < _vala_array_length (_tmp3_); e_it = e_it + 1) {
				const gchar* e = NULL;
				e = e_collection[e_it];
				{
					const gchar* _tmp5_;
					_tmp5_ = e;
					if (_tmp5_ != NULL) {
						PlankXdgSessionDesktop _tmp6_;
						const gchar* _tmp7_;
						PlankXdgSessionDesktop _tmp8_;
						_tmp6_ = _result_;
						_tmp7_ = e;
						_tmp8_ = plank_xdg_session_desktop_from_single_string (_tmp7_);
						_result_ = _tmp6_ | _tmp8_;
					}
				}
			}
			e_collection = (_vala_array_free (e_collection, e_collection_length1, (GDestroyNotify) g_free), NULL);
		}
	} else {
		const gchar* _tmp9_;
		PlankXdgSessionDesktop _tmp10_;
		_tmp9_ = s;
		_tmp10_ = plank_xdg_session_desktop_from_single_string (_tmp9_);
		_result_ = _tmp10_;
	}
	result = _result_;
	return result;
}


GType plank_xdg_session_desktop_get_type (void) {
	static volatile gsize plank_xdg_session_desktop_type_id__volatile = 0;
	if (g_once_init_enter (&plank_xdg_session_desktop_type_id__volatile)) {
		static const GFlagsValue values[] = {{PLANK_XDG_SESSION_DESKTOP_GNOME, "PLANK_XDG_SESSION_DESKTOP_GNOME", "gnome"}, {PLANK_XDG_SESSION_DESKTOP_KDE, "PLANK_XDG_SESSION_DESKTOP_KDE", "kde"}, {PLANK_XDG_SESSION_DESKTOP_LXDE, "PLANK_XDG_SESSION_DESKTOP_LXDE", "lxde"}, {PLANK_XDG_SESSION_DESKTOP_MATE, "PLANK_XDG_SESSION_DESKTOP_MATE", "mate"}, {PLANK_XDG_SESSION_DESKTOP_RAZOR, "PLANK_XDG_SESSION_DESKTOP_RAZOR", "razor"}, {PLANK_XDG_SESSION_DESKTOP_ROX, "PLANK_XDG_SESSION_DESKTOP_ROX", "rox"}, {PLANK_XDG_SESSION_DESKTOP_TDE, "PLANK_XDG_SESSION_DESKTOP_TDE", "tde"}, {PLANK_XDG_SESSION_DESKTOP_UNITY, "PLANK_XDG_SESSION_DESKTOP_UNITY", "unity"}, {PLANK_XDG_SESSION_DESKTOP_XFCE, "PLANK_XDG_SESSION_DESKTOP_XFCE", "xfce"}, {PLANK_XDG_SESSION_DESKTOP_EDE, "PLANK_XDG_SESSION_DESKTOP_EDE", "ede"}, {PLANK_XDG_SESSION_DESKTOP_CINNAMON, "PLANK_XDG_SESSION_DESKTOP_CINNAMON", "cinnamon"}, {PLANK_XDG_SESSION_DESKTOP_PANTHEON, "PLANK_XDG_SESSION_DESKTOP_PANTHEON", "pantheon"}, {PLANK_XDG_SESSION_DESKTOP_OLD, "PLANK_XDG_SESSION_DESKTOP_OLD", "old"}, {0, NULL, NULL}};
		GType plank_xdg_session_desktop_type_id;
		plank_xdg_session_desktop_type_id = g_flags_register_static ("PlankXdgSessionDesktop", values);
		g_once_init_leave (&plank_xdg_session_desktop_type_id__volatile, plank_xdg_session_desktop_type_id);
	}
	return plank_xdg_session_desktop_type_id__volatile;
}


PlankXdgSessionType plank_xdg_session_type_from_string (const gchar* s) {
	PlankXdgSessionType result = 0;
	PlankXdgSessionType _result_ = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	g_return_val_if_fail (s != NULL, 0);
	_tmp0_ = s;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	g_free (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("tty")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_TYPE_TTY;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("x11")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_TYPE_X11;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("wayland")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_TYPE_WAYLAND;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("mir")))) {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_TYPE_MIR;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				_result_ = PLANK_XDG_SESSION_TYPE_UNSPECIFIED;
				break;
			}
		}
	}
	result = _result_;
	return result;
}


GType plank_xdg_session_type_get_type (void) {
	static volatile gsize plank_xdg_session_type_type_id__volatile = 0;
	if (g_once_init_enter (&plank_xdg_session_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_XDG_SESSION_TYPE_UNSPECIFIED, "PLANK_XDG_SESSION_TYPE_UNSPECIFIED", "unspecified"}, {PLANK_XDG_SESSION_TYPE_TTY, "PLANK_XDG_SESSION_TYPE_TTY", "tty"}, {PLANK_XDG_SESSION_TYPE_X11, "PLANK_XDG_SESSION_TYPE_X11", "x11"}, {PLANK_XDG_SESSION_TYPE_WAYLAND, "PLANK_XDG_SESSION_TYPE_WAYLAND", "wayland"}, {PLANK_XDG_SESSION_TYPE_MIR, "PLANK_XDG_SESSION_TYPE_MIR", "mir"}, {0, NULL, NULL}};
		GType plank_xdg_session_type_type_id;
		plank_xdg_session_type_type_id = g_enum_register_static ("PlankXdgSessionType", values);
		g_once_init_leave (&plank_xdg_session_type_type_id__volatile, plank_xdg_session_type_type_id);
	}
	return plank_xdg_session_type_type_id__volatile;
}


void plank_environment_initialize (void) {
	PlankXdgSessionClass _tmp0_;
	PlankXdgSessionDesktop _tmp1_;
	PlankXdgSessionType _tmp2_;
	_tmp0_ = plank_get_xdg_session_class ();
	plank_session_class = _tmp0_;
	_tmp1_ = plank_get_xdg_session_desktop ();
	plank_session_desktop = _tmp1_;
	_tmp2_ = plank_get_xdg_session_type ();
	plank_session_type = _tmp2_;
}


gboolean plank_environment_is_session_class (PlankXdgSessionClass type) {
	gboolean result = FALSE;
	PlankXdgSessionClass _tmp0_;
	PlankXdgSessionClass _tmp1_;
	_tmp0_ = type;
	_tmp1_ = plank_session_class;
	result = _tmp0_ == _tmp1_;
	return result;
}


gboolean plank_environment_is_session_desktop (PlankXdgSessionDesktop type) {
	gboolean result = FALSE;
	PlankXdgSessionDesktop _tmp0_;
	PlankXdgSessionDesktop _tmp1_;
	_tmp0_ = type;
	_tmp1_ = plank_session_desktop;
	result = (_tmp1_ & _tmp0_) == _tmp0_;
	return result;
}


gboolean plank_environment_is_session_type (PlankXdgSessionType type) {
	gboolean result = FALSE;
	PlankXdgSessionType _tmp0_;
	PlankXdgSessionType _tmp1_;
	_tmp0_ = type;
	_tmp1_ = plank_session_type;
	result = _tmp0_ == _tmp1_;
	return result;
}


PlankXdgSessionClass plank_get_xdg_session_class (void) {
	PlankXdgSessionClass result = 0;
	const gchar* _result_ = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_getenv ("XDG_SESSION_CLASS");
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		PlankXdgSessionClass _tmp3_;
		_tmp2_ = _result_;
		_tmp3_ = plank_xdg_session_class_from_string (_tmp2_);
		result = _tmp3_;
		return result;
	}
	g_warning ("Environment.vala:161: XDG_SESSION_CLASS not set in this environment!");
	result = PLANK_XDG_SESSION_CLASS_USER;
	return result;
}


PlankXdgSessionDesktop plank_get_xdg_session_desktop (void) {
	PlankXdgSessionDesktop result = 0;
	const gchar* _result_ = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	_tmp0_ = g_getenv ("XDG_SESSION_DESKTOP");
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ == NULL) {
		const gchar* _tmp2_;
		_tmp2_ = g_getenv ("XDG_CURRENT_DESKTOP");
		_result_ = _tmp2_;
	}
	_tmp3_ = _result_;
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_;
		_tmp4_ = g_getenv ("DESKTOP_SESSION");
		_result_ = _tmp4_;
	}
	_tmp5_ = _result_;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		PlankXdgSessionDesktop _tmp7_;
		_tmp6_ = _result_;
		_tmp7_ = plank_xdg_session_desktop_from_string (_tmp6_);
		result = _tmp7_;
		return result;
	}
	g_warning ("Environment.vala:179: Neither of XDG_SESSION_DESKTOP, XDG_CURRENT_DESK" \
"TOP or DESKTOP_SESSION is set in this environment!");
	result = PLANK_XDG_SESSION_DESKTOP_GNOME;
	return result;
}


PlankXdgSessionType plank_get_xdg_session_type (void) {
	PlankXdgSessionType result = 0;
	const gchar* _result_ = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GdkScreen* _tmp4_;
	_tmp0_ = g_getenv ("XDG_SESSION_TYPE");
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		PlankXdgSessionType _tmp3_;
		_tmp2_ = _result_;
		_tmp3_ = plank_xdg_session_type_from_string (_tmp2_);
		result = _tmp3_;
		return result;
	}
	g_warning ("Environment.vala:192: XDG_SESSION_TYPE not set in this environment!");
	_tmp4_ = gdk_screen_get_default ();
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gdk_x11_screen_get_type ())) {
		result = PLANK_XDG_SESSION_TYPE_X11;
		return result;
	}
	g_error ("Environment.vala:197: XdgSessionType could not be determined!");
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



