/* HoverWindow.c generated by valac 0.36.2, the Vala compiler
 * generated from HoverWindow.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <atk/atk.h>
#include "gtk-compat.h"


#define PLANK_TYPE_HOVER_WINDOW (plank_hover_window_get_type ())
#define PLANK_HOVER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_HOVER_WINDOW, PlankHoverWindow))
#define PLANK_HOVER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_HOVER_WINDOW, PlankHoverWindowClass))
#define PLANK_IS_HOVER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_HOVER_WINDOW))
#define PLANK_IS_HOVER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_HOVER_WINDOW))
#define PLANK_HOVER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_HOVER_WINDOW, PlankHoverWindowClass))

typedef struct _PlankHoverWindow PlankHoverWindow;
typedef struct _PlankHoverWindowClass PlankHoverWindowClass;
typedef struct _PlankHoverWindowPrivate PlankHoverWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))

struct _PlankHoverWindow {
	GtkWindow parent_instance;
	PlankHoverWindowPrivate * priv;
};

struct _PlankHoverWindowClass {
	GtkWindowClass parent_class;
};

struct _PlankHoverWindowPrivate {
	GtkBox* box;
	GtkLabel* label;
};


static gpointer plank_hover_window_parent_class = NULL;

GType plank_hover_window_get_type (void) G_GNUC_CONST;
#define PLANK_HOVER_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_HOVER_WINDOW, PlankHoverWindowPrivate))
enum  {
	PLANK_HOVER_WINDOW_DUMMY_PROPERTY
};
#define PLANK_HOVER_WINDOW_PADDING 10
PlankHoverWindow* plank_hover_window_new (void);
PlankHoverWindow* plank_hover_window_construct (GType object_type);
void plank_hover_window_show_at (PlankHoverWindow* self, gint x, gint y, GtkPositionType position);
void plank_hover_window_set_text (PlankHoverWindow* self, const gchar* text);
static gboolean plank_hover_window_real_draw (GtkWidget* base, cairo_t* cr);
static GObject * plank_hover_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_hover_window_finalize (GObject * obj);


PlankHoverWindow* plank_hover_window_construct (GType object_type) {
	PlankHoverWindow * self = NULL;
	self = (PlankHoverWindow*) g_object_new (object_type, "type", GTK_WINDOW_POPUP, "type-hint", GDK_WINDOW_TYPE_HINT_TOOLTIP, NULL);
	return self;
}


PlankHoverWindow* plank_hover_window_new (void) {
	return plank_hover_window_construct (PLANK_TYPE_HOVER_WINDOW);
}


/**
 * Shows and centers the window according to the x/y location specified
 * while accounting the dock's position.
 *
 * @param x the x location
 * @param y the y location
 * @param position the dock's position
 */
void plank_hover_window_show_at (PlankHoverWindow* self, gint x, gint y, GtkPositionType position) {
	GdkScreen* screen;
	GdkScreen* _tmp0_;
	GdkRectangle monitor = {0};
	GdkScreen* _tmp1_;
	GdkScreen* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_ = {0};
	gint width;
	gint _tmp7_;
	gint height;
	gint _tmp8_;
	GtkPositionType _tmp9_;
	gint _tmp24_;
	GdkRectangle _tmp25_;
	gint _tmp26_;
	GdkRectangle _tmp27_;
	gint _tmp28_;
	GdkRectangle _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	GdkRectangle _tmp36_;
	gint _tmp37_;
	GdkRectangle _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	screen = _tmp0_;
	_tmp1_ = screen;
	_tmp2_ = screen;
	_tmp3_ = x;
	_tmp4_ = y;
	_tmp5_ = gdk_screen_get_monitor_at_point (_tmp2_, _tmp3_, _tmp4_);
	gdk_screen_get_monitor_geometry (_tmp1_, _tmp5_, &_tmp6_);
	monitor = _tmp6_;
	gtk_widget_show ((GtkWidget*) self);
	_tmp7_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp7_;
	_tmp8_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp8_;
	_tmp9_ = position;
	switch (_tmp9_) {
		case GTK_POS_BOTTOM:
		{
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			_tmp10_ = x;
			_tmp11_ = width;
			x = _tmp10_ - (_tmp11_ / 2);
			_tmp12_ = y;
			_tmp13_ = height;
			y = (_tmp12_ - _tmp13_) - PLANK_HOVER_WINDOW_PADDING;
			break;
		}
		case GTK_POS_TOP:
		{
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp14_ = x;
			_tmp15_ = width;
			x = _tmp14_ - (_tmp15_ / 2);
			_tmp16_ = y;
			y = _tmp16_ + PLANK_HOVER_WINDOW_PADDING;
			break;
		}
		case GTK_POS_LEFT:
		{
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			_tmp17_ = x;
			x = _tmp17_ + PLANK_HOVER_WINDOW_PADDING;
			_tmp18_ = y;
			_tmp19_ = height;
			y = _tmp18_ - (_tmp19_ / 2);
			break;
		}
		case GTK_POS_RIGHT:
		{
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			_tmp20_ = x;
			_tmp21_ = width;
			x = (_tmp20_ - _tmp21_) - PLANK_HOVER_WINDOW_PADDING;
			_tmp22_ = y;
			_tmp23_ = height;
			y = _tmp22_ - (_tmp23_ / 2);
			break;
		}
		default:
		break;
	}
	_tmp24_ = x;
	_tmp25_ = monitor;
	_tmp26_ = _tmp25_.x;
	_tmp27_ = monitor;
	_tmp28_ = _tmp27_.x;
	_tmp29_ = monitor;
	_tmp30_ = _tmp29_.width;
	_tmp31_ = width;
	_tmp32_ = CLAMP (_tmp24_, _tmp26_, (_tmp28_ + _tmp30_) - _tmp31_);
	x = _tmp32_;
	_tmp33_ = y;
	_tmp34_ = monitor;
	_tmp35_ = _tmp34_.y;
	_tmp36_ = monitor;
	_tmp37_ = _tmp36_.y;
	_tmp38_ = monitor;
	_tmp39_ = _tmp38_.height;
	_tmp40_ = height;
	_tmp41_ = CLAMP (_tmp33_, _tmp35_, (_tmp37_ + _tmp39_) - _tmp40_);
	y = _tmp41_;
	_tmp42_ = x;
	_tmp43_ = y;
	gtk_window_move ((GtkWindow*) self, _tmp42_, _tmp43_);
}


/**
 * Set the tooltip-text to show
 *
 * @param text the text to show
 */
void plank_hover_window_set_text (PlankHoverWindow* self, const gchar* text) {
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->label;
	_tmp1_ = text;
	gtk_label_set_text (_tmp0_, _tmp1_);
	_tmp2_ = text;
	if (_tmp2_ != NULL) {
		GtkLabel* _tmp3_;
		_tmp3_ = self->priv->label;
		gtk_widget_show ((GtkWidget*) _tmp3_);
	} else {
		GtkLabel* _tmp4_;
		_tmp4_ = self->priv->label;
		gtk_widget_hide ((GtkWidget*) _tmp4_);
	}
}


/**
 * {@inheritDoc}
 */
static gboolean plank_hover_window_real_draw (GtkWidget* base, cairo_t* cr) {
	PlankHoverWindow * self;
	gboolean result = FALSE;
	gint width;
	gint _tmp0_;
	gint height;
	gint _tmp1_;
	GtkStyleContext* context;
	GtkStyleContext* _tmp2_;
	gboolean _tmp3_;
	cairo_t* _tmp33_;
	gboolean _tmp34_;
	self = (PlankHoverWindow*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	context = _tmp2_;
	_tmp3_ = gtk_widget_is_composited ((GtkWidget*) self);
	if (_tmp3_) {
		cairo_t* _tmp4_;
		cairo_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_t* _tmp7_;
		GtkStyleContext* _tmp8_;
		cairo_t* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GtkStyleContext* _tmp12_;
		cairo_t* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		_tmp4_ = cr;
		cairo_save (_tmp4_);
		_tmp5_ = cr;
		cairo_set_operator (_tmp5_, CAIRO_OPERATOR_CLEAR);
		_tmp6_ = cr;
		cairo_paint (_tmp6_);
		_tmp7_ = cr;
		cairo_restore (_tmp7_);
		gtk_widget_shape_combine_region ((GtkWidget*) self, NULL);
		_tmp8_ = context;
		_tmp9_ = cr;
		_tmp10_ = width;
		_tmp11_ = height;
		gtk_render_background (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp10_, (gdouble) _tmp11_);
		_tmp12_ = context;
		_tmp13_ = cr;
		_tmp14_ = width;
		_tmp15_ = height;
		gtk_render_frame (_tmp12_, _tmp13_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp14_, (gdouble) _tmp15_);
	} else {
		cairo_surface_t* surface;
		GdkWindow* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		cairo_surface_t* _tmp19_;
		cairo_t* compat_cr;
		cairo_surface_t* _tmp20_;
		cairo_t* _tmp21_;
		GtkStyleContext* _tmp22_;
		cairo_t* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		GtkStyleContext* _tmp26_;
		cairo_t* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		cairo_region_t* region;
		cairo_surface_t* _tmp30_;
		cairo_region_t* _tmp31_;
		cairo_region_t* _tmp32_;
		_tmp16_ = gtk_widget_get_window ((GtkWidget*) self);
		_tmp17_ = width;
		_tmp18_ = height;
		_tmp19_ = gdk_window_create_similar_surface (_tmp16_, CAIRO_CONTENT_COLOR_ALPHA, _tmp17_, _tmp18_);
		surface = _tmp19_;
		_tmp20_ = surface;
		_tmp21_ = cairo_create (_tmp20_);
		compat_cr = _tmp21_;
		_tmp22_ = context;
		_tmp23_ = compat_cr;
		_tmp24_ = width;
		_tmp25_ = height;
		gtk_render_background (_tmp22_, _tmp23_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp24_, (gdouble) _tmp25_);
		_tmp26_ = context;
		_tmp27_ = compat_cr;
		_tmp28_ = width;
		_tmp29_ = height;
		gtk_render_frame (_tmp26_, _tmp27_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp28_, (gdouble) _tmp29_);
		_tmp30_ = surface;
		_tmp31_ = gdk_cairo_region_create_from_surface (_tmp30_);
		region = _tmp31_;
		_tmp32_ = region;
		gtk_widget_shape_combine_region ((GtkWidget*) self, _tmp32_);
		_cairo_region_destroy0 (region);
		_cairo_destroy0 (compat_cr);
		_cairo_surface_destroy0 (surface);
	}
	_tmp33_ = cr;
	_tmp34_ = GTK_WIDGET_CLASS (plank_hover_window_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp33_);
	result = _tmp34_;
	return result;
}


static GObject * plank_hover_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankHoverWindow * self;
	GdkScreen* screen;
	GdkScreen* _tmp0_;
	GdkVisual* _tmp1_;
	GdkScreen* _tmp2_;
	GdkVisual* _tmp3_;
	GtkStyleContext* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkBox* _tmp16_;
	GtkLabel* _tmp17_;
	parent_class = G_OBJECT_CLASS (plank_hover_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_HOVER_WINDOW, PlankHoverWindow);
	gtk_widget_set_app_paintable ((GtkWidget*) self, TRUE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	screen = _tmp0_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		GdkScreen* _tmp4_;
		GdkVisual* _tmp5_;
		_tmp4_ = screen;
		_tmp5_ = gdk_screen_get_system_visual (_tmp4_);
		_tmp1_ = _tmp5_;
	}
	gtk_widget_set_visual ((GtkWidget*) self, _tmp1_);
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp6_, GTK_STYLE_CLASS_TOOLTIP);
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->box);
	self->priv->box = _tmp7_;
	_tmp8_ = self->priv->box;
	gtk_widget_set_margin_left ((GtkWidget*) _tmp8_, 6);
	_tmp9_ = self->priv->box;
	gtk_widget_set_margin_right ((GtkWidget*) _tmp9_, 6);
	_tmp10_ = self->priv->box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp10_, 6);
	_tmp11_ = self->priv->box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp11_, 6);
	_tmp12_ = self->priv->box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->box;
	gtk_widget_show ((GtkWidget*) _tmp13_);
	_tmp14_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->label);
	self->priv->label = _tmp14_;
	_tmp15_ = self->priv->label;
	gtk_label_set_line_wrap (_tmp15_, TRUE);
	_tmp16_ = self->priv->box;
	_tmp17_ = self->priv->label;
	gtk_box_pack_start (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 0);
	return obj;
}


static void plank_hover_window_class_init (PlankHoverWindowClass * klass) {
	GTypeClass* _tmp0_;
	GObjectClass* _tmp1_;
	plank_hover_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankHoverWindowPrivate));
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) plank_hover_window_real_draw;
	G_OBJECT_CLASS (klass)->constructor = plank_hover_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_hover_window_finalize;
	gtk_widget_class_set_accessible_role (GTK_WIDGET_CLASS (klass), ATK_ROLE_TOOL_TIP);
	_tmp0_ = g_type_class_ref (PLANK_TYPE_HOVER_WINDOW);
	_tmp1_ = (GObjectClass*) _tmp0_;
	plank_compat_gtk_widget_class_set_css_name (_tmp1_, "tooltip");
	_g_type_class_unref0 (_tmp1_);
}


static void plank_hover_window_instance_init (PlankHoverWindow * self) {
	self->priv = PLANK_HOVER_WINDOW_GET_PRIVATE (self);
}


static void plank_hover_window_finalize (GObject * obj) {
	PlankHoverWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_HOVER_WINDOW, PlankHoverWindow);
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (plank_hover_window_parent_class)->finalize (obj);
}


/**
 * A hover window that shows labels for dock items.
 * This window floats outside (but near) the dock.
 */
GType plank_hover_window_get_type (void) {
	static volatile gsize plank_hover_window_type_id__volatile = 0;
	if (g_once_init_enter (&plank_hover_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankHoverWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_hover_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankHoverWindow), 0, (GInstanceInitFunc) plank_hover_window_instance_init, NULL };
		GType plank_hover_window_type_id;
		plank_hover_window_type_id = g_type_register_static (gtk_window_get_type (), "PlankHoverWindow", &g_define_type_info, 0);
		g_once_init_leave (&plank_hover_window_type_id__volatile, plank_hover_window_type_id);
	}
	return plank_hover_window_type_id__volatile;
}



